/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the M68k target                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 3;
using PredicateBitset = llvm::PredicateBitsetImpl<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(M68kInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(M68kInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static M68kInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static M68kInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const int64_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  void runCustomAction(unsigned FnID, const MatcherState &State) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
};
const static size_t NumTypeObjects = 3;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_IsPICBit = 0,
  Feature_IsNotPICBit = 1,
  Feature_AtLeastM68020Bit = 2,
};

PredicateBitset M68kInstructionSelector::
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const {
  PredicateBitset Features;
  if (TM.isPositionIndependent())
    Features.set(Feature_IsPICBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->atLeastM68020())
    Features.set(Feature_AtLeastM68020Bit);
  return Features;
}

void M68kInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const M68kSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset M68kInstructionSelector::
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features;
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
const static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

M68kInstructionSelector::ComplexMatcherMemFn
M68kInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool M68kInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_Mximm8_1to8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_Mximm16_1to8,
  GICXXPred_I64_Predicate_Mximm32_1to8,
};
bool M68kInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_Mximm8_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_Mximm16_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_Mximm32_1to8: {
     return Imm >= 1 && Imm <= 8; 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool M68kInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool M68kInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("M68kInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
M68kInstructionSelector::CustomRendererFn
M68kInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool M68kInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  NewMIVector OutMIs;
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, OutMIs, State, ExecInfo, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

void M68kInstructionSelector::runCustomAction(unsigned, const MatcherState&) const {
    llvm_unreachable("M68kInstructionSelector does not support custom C++ actions!");
}
const int64_t *M68kInstructionSelector::getMatchTable() const {
  constexpr static int64_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/46, 130, /*)*//*default:*//*Label 18*/ 2508,
    /*TargetOpcode::G_ADD*//*Label 0*/ 89,
    /*TargetOpcode::G_SUB*//*Label 1*/ 273,
    /*TargetOpcode::G_MUL*//*Label 2*/ 523,
    /*TargetOpcode::G_SDIV*//*Label 3*/ 563,
    /*TargetOpcode::G_UDIV*//*Label 4*/ 603, 0, 0, 0, 0,
    /*TargetOpcode::G_AND*//*Label 5*/ 643,
    /*TargetOpcode::G_OR*//*Label 6*/ 827,
    /*TargetOpcode::G_XOR*//*Label 7*/ 1011, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_ANYEXT*//*Label 8*/ 1195,
    /*TargetOpcode::G_TRUNC*//*Label 9*/ 1245,
    /*TargetOpcode::G_CONSTANT*//*Label 10*/ 1283, 0, 0, 0,
    /*TargetOpcode::G_SEXT*//*Label 11*/ 1443, 0,
    /*TargetOpcode::G_ZEXT*//*Label 12*/ 1493,
    /*TargetOpcode::G_SHL*//*Label 13*/ 1543,
    /*TargetOpcode::G_LSHR*//*Label 14*/ 1736,
    /*TargetOpcode::G_ASHR*//*Label 15*/ 1929, 0, 0,
    /*TargetOpcode::G_ROTR*//*Label 16*/ 2122,
    /*TargetOpcode::G_ROTL*//*Label 17*/ 2315,
    // Label 0: @89
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 22*/ 272,
    /*GILLT_s8*//*Label 19*/ 98,
    /*GILLT_s16*//*Label 20*/ 156,
    /*GILLT_s32*//*Label 21*/ 214,
    // Label 19: @98
    GIM_Try, /*On fail goto*//*Label 23*/ 155,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 24*/ 142, // Rule ID 687 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (ADD8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 687,
        GIR_Done,
      // Label 24: @142
      GIM_Try, /*On fail goto*//*Label 25*/ 154, // Rule ID 675 //
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ADD8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 675,
        GIR_Done,
      // Label 25: @154
      GIM_Reject,
    // Label 23: @155
    GIM_Reject,
    // Label 20: @156
    GIM_Try, /*On fail goto*//*Label 26*/ 213,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 27*/ 200, // Rule ID 688 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (ADD16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 688,
        GIR_Done,
      // Label 27: @200
      GIM_Try, /*On fail goto*//*Label 28*/ 212, // Rule ID 676 //
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ADD16dr:{ *:[i16] }:{ *:[i8] } MxXRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD16dr,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 676,
        GIR_Done,
      // Label 28: @212
      GIM_Reject,
    // Label 26: @213
    GIM_Reject,
    // Label 21: @214
    GIM_Try, /*On fail goto*//*Label 29*/ 271,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 30*/ 258, // Rule ID 689 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (ADD32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 689,
        GIR_Done,
      // Label 30: @258
      GIM_Try, /*On fail goto*//*Label 31*/ 270, // Rule ID 677 //
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ADD32dr:{ *:[i32] }:{ *:[i8] } MxXRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD32dr,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 677,
        GIR_Done,
      // Label 31: @270
      GIM_Reject,
    // Label 29: @271
    GIM_Reject,
    // Label 22: @272
    GIM_Reject,
    // Label 1: @273
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 35*/ 522,
    /*GILLT_s8*//*Label 32*/ 282,
    /*GILLT_s16*//*Label 33*/ 362,
    /*GILLT_s32*//*Label 34*/ 442,
    // Label 32: @282
    GIM_Try, /*On fail goto*//*Label 36*/ 361,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 37*/ 318, // Rule ID 529 //
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i8] } 0:{ *:[i8] }, i8:{ *:[i8] }:$src)  =>  (NEG8d:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG8d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 529,
        GIR_Done,
      // Label 37: @318
      GIM_Try, /*On fail goto*//*Label 38*/ 348, // Rule ID 726 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (SUB8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 726,
        GIR_Done,
      // Label 38: @348
      GIM_Try, /*On fail goto*//*Label 39*/ 360, // Rule ID 714 //
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SUB8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 714,
        GIR_Done,
      // Label 39: @360
      GIM_Reject,
    // Label 36: @361
    GIM_Reject,
    // Label 33: @362
    GIM_Try, /*On fail goto*//*Label 40*/ 441,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 41*/ 398, // Rule ID 531 //
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i16] } 0:{ *:[i16] }, i16:{ *:[i16] }:$src)  =>  (NEG16d:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG16d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 531,
        GIR_Done,
      // Label 41: @398
      GIM_Try, /*On fail goto*//*Label 42*/ 428, // Rule ID 727 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (SUB16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 727,
        GIR_Done,
      // Label 42: @428
      GIM_Try, /*On fail goto*//*Label 43*/ 440, // Rule ID 715 //
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SUB16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 715,
        GIR_Done,
      // Label 43: @440
      GIM_Reject,
    // Label 40: @441
    GIM_Reject,
    // Label 34: @442
    GIM_Try, /*On fail goto*//*Label 44*/ 521,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 45*/ 478, // Rule ID 533 //
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$src)  =>  (NEG32d:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG32d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 533,
        GIR_Done,
      // Label 45: @478
      GIM_Try, /*On fail goto*//*Label 46*/ 508, // Rule ID 728 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (SUB32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 728,
        GIR_Done,
      // Label 46: @508
      GIM_Try, /*On fail goto*//*Label 47*/ 520, // Rule ID 716 //
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SUB32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 716,
        GIR_Done,
      // Label 47: @520
      GIM_Reject,
    // Label 44: @521
    GIM_Reject,
    // Label 35: @522
    GIM_Reject,
    // Label 2: @523
    GIM_Try, /*On fail goto*//*Label 48*/ 562, // Rule ID 665 //
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/0, /*OtherMI*/0, /*OtherOpIdx*/1,
      // (mul:{ *:[i32] } i32:{ *:[i32] }:$dst, i32:{ *:[i32] }:$opd)  =>  (SMULd32d32:{ *:[i32] }:{ *:[i8] } ?:{ *:[i32] }:$dst, ?:{ *:[i32] }:$opd)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SMULd32d32,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // opd
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 665,
      GIR_Done,
    // Label 48: @562
    GIM_Reject,
    // Label 3: @563
    GIM_Try, /*On fail goto*//*Label 49*/ 602, // Rule ID 652 //
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/0, /*OtherMI*/0, /*OtherOpIdx*/1,
      // (sdiv:{ *:[i32] } i32:{ *:[i32] }:$dst, i32:{ *:[i32] }:$opd)  =>  (SDIVd32d32:{ *:[i32] }:{ *:[i8] } ?:{ *:[i32] }:$dst, ?:{ *:[i32] }:$opd)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SDIVd32d32,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // opd
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 652,
      GIR_Done,
    // Label 49: @602
    GIM_Reject,
    // Label 4: @603
    GIM_Try, /*On fail goto*//*Label 50*/ 642, // Rule ID 653 //
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/0, /*OtherMI*/0, /*OtherOpIdx*/1,
      // (udiv:{ *:[i32] } i32:{ *:[i32] }:$dst, i32:{ *:[i32] }:$opd)  =>  (UDIVd32d32:{ *:[i32] }:{ *:[i8] } ?:{ *:[i32] }:$dst, ?:{ *:[i32] }:$opd)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::UDIVd32d32,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // dst
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // opd
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 653,
      GIR_Done,
    // Label 50: @642
    GIM_Reject,
    // Label 5: @643
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 54*/ 826,
    /*GILLT_s8*//*Label 51*/ 652,
    /*GILLT_s16*//*Label 52*/ 710,
    /*GILLT_s32*//*Label 53*/ 768,
    // Label 51: @652
    GIM_Try, /*On fail goto*//*Label 55*/ 709,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 56*/ 696, // Rule ID 756 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (AND8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 756,
        GIR_Done,
      // Label 56: @696
      GIM_Try, /*On fail goto*//*Label 57*/ 708, // Rule ID 753 //
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (AND8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 753,
        GIR_Done,
      // Label 57: @708
      GIM_Reject,
    // Label 55: @709
    GIM_Reject,
    // Label 52: @710
    GIM_Try, /*On fail goto*//*Label 58*/ 767,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 59*/ 754, // Rule ID 757 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (AND16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 757,
        GIR_Done,
      // Label 59: @754
      GIM_Try, /*On fail goto*//*Label 60*/ 766, // Rule ID 754 //
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (AND16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 754,
        GIR_Done,
      // Label 60: @766
      GIM_Reject,
    // Label 58: @767
    GIM_Reject,
    // Label 53: @768
    GIM_Try, /*On fail goto*//*Label 61*/ 825,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 62*/ 812, // Rule ID 758 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (AND32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 758,
        GIR_Done,
      // Label 62: @812
      GIM_Try, /*On fail goto*//*Label 63*/ 824, // Rule ID 755 //
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (AND32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 755,
        GIR_Done,
      // Label 63: @824
      GIM_Reject,
    // Label 61: @825
    GIM_Reject,
    // Label 54: @826
    GIM_Reject,
    // Label 6: @827
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 67*/ 1010,
    /*GILLT_s8*//*Label 64*/ 836,
    /*GILLT_s16*//*Label 65*/ 894,
    /*GILLT_s32*//*Label 66*/ 952,
    // Label 64: @836
    GIM_Try, /*On fail goto*//*Label 68*/ 893,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 69*/ 880, // Rule ID 762 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (OR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 762,
        GIR_Done,
      // Label 69: @880
      GIM_Try, /*On fail goto*//*Label 70*/ 892, // Rule ID 759 //
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (OR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 759,
        GIR_Done,
      // Label 70: @892
      GIM_Reject,
    // Label 68: @893
    GIM_Reject,
    // Label 65: @894
    GIM_Try, /*On fail goto*//*Label 71*/ 951,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 72*/ 938, // Rule ID 763 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (OR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 763,
        GIR_Done,
      // Label 72: @938
      GIM_Try, /*On fail goto*//*Label 73*/ 950, // Rule ID 760 //
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (OR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 760,
        GIR_Done,
      // Label 73: @950
      GIM_Reject,
    // Label 71: @951
    GIM_Reject,
    // Label 66: @952
    GIM_Try, /*On fail goto*//*Label 74*/ 1009,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 75*/ 996, // Rule ID 764 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (OR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 764,
        GIR_Done,
      // Label 75: @996
      GIM_Try, /*On fail goto*//*Label 76*/ 1008, // Rule ID 761 //
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (OR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 761,
        GIR_Done,
      // Label 76: @1008
      GIM_Reject,
    // Label 74: @1009
    GIM_Reject,
    // Label 67: @1010
    GIM_Reject,
    // Label 7: @1011
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 80*/ 1194,
    /*GILLT_s8*//*Label 77*/ 1020,
    /*GILLT_s16*//*Label 78*/ 1078,
    /*GILLT_s32*//*Label 79*/ 1136,
    // Label 77: @1020
    GIM_Try, /*On fail goto*//*Label 81*/ 1077,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 82*/ 1064, // Rule ID 768 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (XOR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 768,
        GIR_Done,
      // Label 82: @1064
      GIM_Try, /*On fail goto*//*Label 83*/ 1076, // Rule ID 765 //
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (XOR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 765,
        GIR_Done,
      // Label 83: @1076
      GIM_Reject,
    // Label 81: @1077
    GIM_Reject,
    // Label 78: @1078
    GIM_Try, /*On fail goto*//*Label 84*/ 1135,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 85*/ 1122, // Rule ID 769 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (XOR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 769,
        GIR_Done,
      // Label 85: @1122
      GIM_Try, /*On fail goto*//*Label 86*/ 1134, // Rule ID 766 //
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (XOR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 766,
        GIR_Done,
      // Label 86: @1134
      GIM_Reject,
    // Label 84: @1135
    GIM_Reject,
    // Label 79: @1136
    GIM_Try, /*On fail goto*//*Label 87*/ 1193,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 88*/ 1180, // Rule ID 770 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (XOR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 770,
        GIR_Done,
      // Label 88: @1180
      GIM_Try, /*On fail goto*//*Label 89*/ 1192, // Rule ID 767 //
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (XOR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 767,
        GIR_Done,
      // Label 89: @1192
      GIM_Reject,
    // Label 87: @1193
    GIM_Reject,
    // Label 80: @1194
    GIM_Reject,
    // Label 8: @1195
    GIM_Try, /*On fail goto*//*Label 90*/ 1244,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 93*/ 1243,
      /*GILLT_s8*//*Label 91*/ 1209,
      /*GILLT_s16*//*Label 92*/ 1226,
      // Label 91: @1209
      GIM_Try, /*On fail goto*//*Label 94*/ 1225, // Rule ID 629 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (anyext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 629,
        GIR_Done,
      // Label 94: @1225
      GIM_Reject,
      // Label 92: @1226
      GIM_Try, /*On fail goto*//*Label 95*/ 1242, // Rule ID 633 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (anyext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 633,
        GIR_Done,
      // Label 95: @1242
      GIM_Reject,
      // Label 93: @1243
      GIM_Reject,
    // Label 90: @1244
    GIM_Reject,
    // Label 9: @1245
    GIM_Try, /*On fail goto*//*Label 96*/ 1282, // Rule ID 637 //
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
      // (trunc:{ *:[i16] } i32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } MxXRD32:{ *:[i32] }:$src, MxSubRegIndex16Lo:{ *:[i32] })
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/TargetOpcode::COPY,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/2, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, M68k::XR16RegClassID,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, M68k::XR32RegClassID,
      // GIR_Coverage, 637,
      GIR_Done,
    // Label 96: @1282
    GIM_Reject,
    // Label 10: @1283
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 100*/ 1442,
    /*GILLT_s8*//*Label 97*/ 1292,
    /*GILLT_s16*//*Label 98*/ 1314,
    /*GILLT_s32*//*Label 99*/ 1378,
    // Label 97: @1292
    GIM_Try, /*On fail goto*//*Label 101*/ 1313, // Rule ID 84 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i8] }):$src  =>  (MOV8di:{ *:[i8] }:{ *:[i8] } (imm:{ *:[i8] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV8di,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 84,
      GIR_Done,
    // Label 101: @1313
    GIM_Reject,
    // Label 98: @1314
    GIM_Try, /*On fail goto*//*Label 102*/ 1335, // Rule ID 80 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR16RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV16ri,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 80,
      GIR_Done,
    // Label 102: @1335
    GIM_Try, /*On fail goto*//*Label 103*/ 1356, // Rule ID 82 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::AR16RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16ai:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV16ai,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 82,
      GIR_Done,
    // Label 103: @1356
    GIM_Try, /*On fail goto*//*Label 104*/ 1377, // Rule ID 85 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16di:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV16di,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 85,
      GIR_Done,
    // Label 104: @1377
    GIM_Reject,
    // Label 99: @1378
    GIM_Try, /*On fail goto*//*Label 105*/ 1399, // Rule ID 81 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV32ri,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 81,
      GIR_Done,
    // Label 105: @1399
    GIM_Try, /*On fail goto*//*Label 106*/ 1420, // Rule ID 83 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::AR32RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32ai:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV32ai,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 83,
      GIR_Done,
    // Label 106: @1420
    GIM_Try, /*On fail goto*//*Label 107*/ 1441, // Rule ID 86 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32di:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV32di,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 86,
      GIR_Done,
    // Label 107: @1441
    GIM_Reject,
    // Label 100: @1442
    GIM_Reject,
    // Label 11: @1443
    GIM_Try, /*On fail goto*//*Label 108*/ 1492,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 111*/ 1491,
      /*GILLT_s8*//*Label 109*/ 1457,
      /*GILLT_s16*//*Label 110*/ 1474,
      // Label 109: @1457
      GIM_Try, /*On fail goto*//*Label 112*/ 1473, // Rule ID 602 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (sext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVSXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 602,
        GIR_Done,
      // Label 112: @1473
      GIM_Reject,
      // Label 110: @1474
      GIM_Try, /*On fail goto*//*Label 113*/ 1490, // Rule ID 606 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVSXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 606,
        GIR_Done,
      // Label 113: @1490
      GIM_Reject,
      // Label 111: @1491
      GIM_Reject,
    // Label 108: @1492
    GIM_Reject,
    // Label 12: @1493
    GIM_Try, /*On fail goto*//*Label 114*/ 1542,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 117*/ 1541,
      /*GILLT_s8*//*Label 115*/ 1507,
      /*GILLT_s16*//*Label 116*/ 1524,
      // Label 115: @1507
      GIM_Try, /*On fail goto*//*Label 118*/ 1523, // Rule ID 615 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (zext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 615,
        GIR_Done,
      // Label 118: @1523
      GIM_Reject,
      // Label 116: @1524
      GIM_Try, /*On fail goto*//*Label 119*/ 1540, // Rule ID 620 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 620,
        GIR_Done,
      // Label 119: @1540
      GIM_Reject,
      // Label 117: @1541
      GIM_Reject,
    // Label 114: @1542
    GIM_Reject,
    // Label 13: @1543
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 123*/ 1735,
    /*GILLT_s8*//*Label 120*/ 1552,
    /*GILLT_s16*//*Label 121*/ 1613,
    /*GILLT_s32*//*Label 122*/ 1674,
    // Label 120: @1552
    GIM_Try, /*On fail goto*//*Label 124*/ 1612,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 125*/ 1599, // Rule ID 343 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (SHL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 343,
        GIR_Done,
      // Label 125: @1599
      GIM_Try, /*On fail goto*//*Label 126*/ 1611, // Rule ID 340 //
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SHL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 340,
        GIR_Done,
      // Label 126: @1611
      GIM_Reject,
    // Label 124: @1612
    GIM_Reject,
    // Label 121: @1613
    GIM_Try, /*On fail goto*//*Label 127*/ 1673,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 128*/ 1660, // Rule ID 344 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (SHL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 344,
        GIR_Done,
      // Label 128: @1660
      GIM_Try, /*On fail goto*//*Label 129*/ 1672, // Rule ID 341 //
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SHL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 341,
        GIR_Done,
      // Label 129: @1672
      GIM_Reject,
    // Label 127: @1673
    GIM_Reject,
    // Label 122: @1674
    GIM_Try, /*On fail goto*//*Label 130*/ 1734,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 131*/ 1721, // Rule ID 345 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (SHL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 345,
        GIR_Done,
      // Label 131: @1721
      GIM_Try, /*On fail goto*//*Label 132*/ 1733, // Rule ID 342 //
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SHL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 342,
        GIR_Done,
      // Label 132: @1733
      GIM_Reject,
    // Label 130: @1734
    GIM_Reject,
    // Label 123: @1735
    GIM_Reject,
    // Label 14: @1736
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 136*/ 1928,
    /*GILLT_s8*//*Label 133*/ 1745,
    /*GILLT_s16*//*Label 134*/ 1806,
    /*GILLT_s32*//*Label 135*/ 1867,
    // Label 133: @1745
    GIM_Try, /*On fail goto*//*Label 137*/ 1805,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 138*/ 1792, // Rule ID 349 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (LSR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 349,
        GIR_Done,
      // Label 138: @1792
      GIM_Try, /*On fail goto*//*Label 139*/ 1804, // Rule ID 346 //
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (LSR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 346,
        GIR_Done,
      // Label 139: @1804
      GIM_Reject,
    // Label 137: @1805
    GIM_Reject,
    // Label 134: @1806
    GIM_Try, /*On fail goto*//*Label 140*/ 1866,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 141*/ 1853, // Rule ID 350 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (LSR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 350,
        GIR_Done,
      // Label 141: @1853
      GIM_Try, /*On fail goto*//*Label 142*/ 1865, // Rule ID 347 //
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (LSR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 347,
        GIR_Done,
      // Label 142: @1865
      GIM_Reject,
    // Label 140: @1866
    GIM_Reject,
    // Label 135: @1867
    GIM_Try, /*On fail goto*//*Label 143*/ 1927,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 144*/ 1914, // Rule ID 351 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (LSR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 351,
        GIR_Done,
      // Label 144: @1914
      GIM_Try, /*On fail goto*//*Label 145*/ 1926, // Rule ID 348 //
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (LSR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 348,
        GIR_Done,
      // Label 145: @1926
      GIM_Reject,
    // Label 143: @1927
    GIM_Reject,
    // Label 136: @1928
    GIM_Reject,
    // Label 15: @1929
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 149*/ 2121,
    /*GILLT_s8*//*Label 146*/ 1938,
    /*GILLT_s16*//*Label 147*/ 1999,
    /*GILLT_s32*//*Label 148*/ 2060,
    // Label 146: @1938
    GIM_Try, /*On fail goto*//*Label 150*/ 1998,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 151*/ 1985, // Rule ID 355 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ASR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 355,
        GIR_Done,
      // Label 151: @1985
      GIM_Try, /*On fail goto*//*Label 152*/ 1997, // Rule ID 352 //
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ASR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 352,
        GIR_Done,
      // Label 152: @1997
      GIM_Reject,
    // Label 150: @1998
    GIM_Reject,
    // Label 147: @1999
    GIM_Try, /*On fail goto*//*Label 153*/ 2059,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 154*/ 2046, // Rule ID 356 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ASR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 356,
        GIR_Done,
      // Label 154: @2046
      GIM_Try, /*On fail goto*//*Label 155*/ 2058, // Rule ID 353 //
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ASR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 353,
        GIR_Done,
      // Label 155: @2058
      GIM_Reject,
    // Label 153: @2059
    GIM_Reject,
    // Label 148: @2060
    GIM_Try, /*On fail goto*//*Label 156*/ 2120,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 157*/ 2107, // Rule ID 357 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ASR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 357,
        GIR_Done,
      // Label 157: @2107
      GIM_Try, /*On fail goto*//*Label 158*/ 2119, // Rule ID 354 //
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ASR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 354,
        GIR_Done,
      // Label 158: @2119
      GIM_Reject,
    // Label 156: @2120
    GIM_Reject,
    // Label 149: @2121
    GIM_Reject,
    // Label 16: @2122
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 162*/ 2314,
    /*GILLT_s8*//*Label 159*/ 2131,
    /*GILLT_s16*//*Label 160*/ 2192,
    /*GILLT_s32*//*Label 161*/ 2253,
    // Label 159: @2131
    GIM_Try, /*On fail goto*//*Label 163*/ 2191,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 164*/ 2178, // Rule ID 367 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 367,
        GIR_Done,
      // Label 164: @2178
      GIM_Try, /*On fail goto*//*Label 165*/ 2190, // Rule ID 364 //
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 364,
        GIR_Done,
      // Label 165: @2190
      GIM_Reject,
    // Label 163: @2191
    GIM_Reject,
    // Label 160: @2192
    GIM_Try, /*On fail goto*//*Label 166*/ 2252,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 167*/ 2239, // Rule ID 368 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 368,
        GIR_Done,
      // Label 167: @2239
      GIM_Try, /*On fail goto*//*Label 168*/ 2251, // Rule ID 365 //
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 365,
        GIR_Done,
      // Label 168: @2251
      GIM_Reject,
    // Label 166: @2252
    GIM_Reject,
    // Label 161: @2253
    GIM_Try, /*On fail goto*//*Label 169*/ 2313,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 170*/ 2300, // Rule ID 369 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 369,
        GIR_Done,
      // Label 170: @2300
      GIM_Try, /*On fail goto*//*Label 171*/ 2312, // Rule ID 366 //
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 366,
        GIR_Done,
      // Label 171: @2312
      GIM_Reject,
    // Label 169: @2313
    GIM_Reject,
    // Label 162: @2314
    GIM_Reject,
    // Label 17: @2315
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 175*/ 2507,
    /*GILLT_s8*//*Label 172*/ 2324,
    /*GILLT_s16*//*Label 173*/ 2385,
    /*GILLT_s32*//*Label 174*/ 2446,
    // Label 172: @2324
    GIM_Try, /*On fail goto*//*Label 176*/ 2384,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 177*/ 2371, // Rule ID 361 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 361,
        GIR_Done,
      // Label 177: @2371
      GIM_Try, /*On fail goto*//*Label 178*/ 2383, // Rule ID 358 //
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 358,
        GIR_Done,
      // Label 178: @2383
      GIM_Reject,
    // Label 176: @2384
    GIM_Reject,
    // Label 173: @2385
    GIM_Try, /*On fail goto*//*Label 179*/ 2445,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 180*/ 2432, // Rule ID 362 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 362,
        GIR_Done,
      // Label 180: @2432
      GIM_Try, /*On fail goto*//*Label 181*/ 2444, // Rule ID 359 //
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 359,
        GIR_Done,
      // Label 181: @2444
      GIM_Reject,
    // Label 179: @2445
    GIM_Reject,
    // Label 174: @2446
    GIM_Try, /*On fail goto*//*Label 182*/ 2506,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 183*/ 2493, // Rule ID 363 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GICXXPred_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 363,
        GIR_Done,
      // Label 183: @2493
      GIM_Try, /*On fail goto*//*Label 184*/ 2505, // Rule ID 360 //
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 360,
        GIR_Done,
      // Label 184: @2505
      GIM_Reject,
    // Label 182: @2506
    GIM_Reject,
    // Label 175: @2507
    GIM_Reject,
    // Label 18: @2508
    GIM_Reject,
    };
  return MatchTable0;
}
#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
