/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * M68k Disassembler                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static std::enable_if_t<std::is_integral<InsnType>::value>
insertBits(InsnType &field, InsnType bits, unsigned startBit, unsigned numBits) {
  assert(startBit + numBits <= sizeof field * 8);
  field |= (InsnType)bits << startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value>
insertBits(InsnType &field, uint64_t bits, unsigned startBit, unsigned numBits) {
  field.insertBits(bits, startBit, numBits);
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTable80[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 0, 158, 6, 0, // Skip to: 1702
/* 8 */       MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11 */      MCD::OPC_FilterValue, 0, 65, 0, 0, // Skip to: 81
/* 16 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 19 */      MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 35
/* 24 */      MCD::OPC_CheckField, 24, 8, 0, 182, 52, 0, // Skip to: 13525
/* 31 */      MCD::OPC_Decode, 189, 3, 0, // Opcode: BTST32di
/* 35 */      MCD::OPC_FilterValue, 5, 18, 0, 0, // Skip to: 58
/* 40 */      MCD::OPC_CheckField, 24, 8, 0, 166, 52, 0, // Skip to: 13525
/* 47 */      MCD::OPC_CheckField, 3, 1, 0, 159, 52, 0, // Skip to: 13525
/* 54 */      MCD::OPC_Decode, 205, 9, 1, // Opcode: XOR8di
/* 58 */      MCD::OPC_FilterValue, 6, 150, 52, 0, // Skip to: 13525
/* 63 */      MCD::OPC_CheckField, 24, 8, 0, 143, 52, 0, // Skip to: 13525
/* 70 */      MCD::OPC_CheckField, 3, 1, 0, 136, 52, 0, // Skip to: 13525
/* 77 */      MCD::OPC_Decode, 140, 4, 2, // Opcode: CMP8di
/* 81 */      MCD::OPC_FilterValue, 1, 158, 0, 0, // Skip to: 244
/* 86 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 89 */      MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 112
/* 94 */      MCD::OPC_CheckField, 24, 8, 0, 112, 52, 0, // Skip to: 13525
/* 101 */     MCD::OPC_CheckField, 3, 1, 0, 105, 52, 0, // Skip to: 13525
/* 108 */     MCD::OPC_Decode, 191, 8, 3, // Opcode: OR8ji
/* 112 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 135
/* 117 */     MCD::OPC_CheckField, 24, 8, 0, 89, 52, 0, // Skip to: 13525
/* 124 */     MCD::OPC_CheckField, 3, 1, 0, 82, 52, 0, // Skip to: 13525
/* 131 */     MCD::OPC_Decode, 173, 3, 3, // Opcode: AND8ji
/* 135 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 158
/* 140 */     MCD::OPC_CheckField, 24, 8, 0, 66, 52, 0, // Skip to: 13525
/* 147 */     MCD::OPC_CheckField, 3, 1, 0, 59, 52, 0, // Skip to: 13525
/* 154 */     MCD::OPC_Decode, 185, 9, 3, // Opcode: SUB8ji
/* 158 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 181
/* 163 */     MCD::OPC_CheckField, 24, 8, 0, 43, 52, 0, // Skip to: 13525
/* 170 */     MCD::OPC_CheckField, 3, 1, 0, 36, 52, 0, // Skip to: 13525
/* 177 */     MCD::OPC_Decode, 129, 3, 3, // Opcode: ADD8ji
/* 181 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 221
/* 186 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 189 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 205
/* 194 */     MCD::OPC_CheckField, 24, 8, 0, 12, 52, 0, // Skip to: 13525
/* 201 */     MCD::OPC_Decode, 195, 3, 3, // Opcode: BTST8ji
/* 205 */     MCD::OPC_FilterValue, 1, 3, 52, 0, // Skip to: 13525
/* 210 */     MCD::OPC_CheckField, 24, 8, 0, 252, 51, 0, // Skip to: 13525
/* 217 */     MCD::OPC_Decode, 199, 3, 3, // Opcode: BTST8oi
/* 221 */     MCD::OPC_FilterValue, 6, 243, 51, 0, // Skip to: 13525
/* 226 */     MCD::OPC_CheckField, 24, 8, 0, 236, 51, 0, // Skip to: 13525
/* 233 */     MCD::OPC_CheckField, 3, 1, 0, 229, 51, 0, // Skip to: 13525
/* 240 */     MCD::OPC_Decode, 146, 4, 4, // Opcode: CMP8ji
/* 244 */     MCD::OPC_FilterValue, 2, 158, 0, 0, // Skip to: 407
/* 249 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 252 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 275
/* 257 */     MCD::OPC_CheckField, 24, 8, 0, 205, 51, 0, // Skip to: 13525
/* 264 */     MCD::OPC_CheckField, 3, 1, 1, 198, 51, 0, // Skip to: 13525
/* 271 */     MCD::OPC_Decode, 193, 8, 5, // Opcode: OR8pi
/* 275 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 298
/* 280 */     MCD::OPC_CheckField, 24, 8, 0, 182, 51, 0, // Skip to: 13525
/* 287 */     MCD::OPC_CheckField, 3, 1, 1, 175, 51, 0, // Skip to: 13525
/* 294 */     MCD::OPC_Decode, 175, 3, 5, // Opcode: AND8pi
/* 298 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 321
/* 303 */     MCD::OPC_CheckField, 24, 8, 0, 159, 51, 0, // Skip to: 13525
/* 310 */     MCD::OPC_CheckField, 3, 1, 1, 152, 51, 0, // Skip to: 13525
/* 317 */     MCD::OPC_Decode, 187, 9, 5, // Opcode: SUB8pi
/* 321 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 344
/* 326 */     MCD::OPC_CheckField, 24, 8, 0, 136, 51, 0, // Skip to: 13525
/* 333 */     MCD::OPC_CheckField, 3, 1, 1, 129, 51, 0, // Skip to: 13525
/* 340 */     MCD::OPC_Decode, 131, 3, 5, // Opcode: ADD8pi
/* 344 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 384
/* 349 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 352 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 368
/* 357 */     MCD::OPC_CheckField, 24, 8, 0, 105, 51, 0, // Skip to: 13525
/* 364 */     MCD::OPC_Decode, 191, 3, 3, // Opcode: BTST8ei
/* 368 */     MCD::OPC_FilterValue, 1, 96, 51, 0, // Skip to: 13525
/* 373 */     MCD::OPC_CheckField, 24, 8, 0, 89, 51, 0, // Skip to: 13525
/* 380 */     MCD::OPC_Decode, 201, 3, 5, // Opcode: BTST8pi
/* 384 */     MCD::OPC_FilterValue, 6, 80, 51, 0, // Skip to: 13525
/* 389 */     MCD::OPC_CheckField, 24, 8, 0, 73, 51, 0, // Skip to: 13525
/* 396 */     MCD::OPC_CheckField, 3, 1, 1, 66, 51, 0, // Skip to: 13525
/* 403 */     MCD::OPC_Decode, 148, 4, 6, // Opcode: CMP8pi
/* 407 */     MCD::OPC_FilterValue, 3, 39, 1, 0, // Skip to: 707
/* 412 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 415 */     MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 445
/* 420 */     MCD::OPC_CheckField, 40, 4, 8, 42, 51, 0, // Skip to: 13525
/* 427 */     MCD::OPC_CheckField, 24, 8, 0, 35, 51, 0, // Skip to: 13525
/* 434 */     MCD::OPC_CheckField, 3, 1, 0, 28, 51, 0, // Skip to: 13525
/* 441 */     MCD::OPC_Decode, 189, 8, 7, // Opcode: OR8fi
/* 445 */     MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 475
/* 450 */     MCD::OPC_CheckField, 40, 4, 8, 12, 51, 0, // Skip to: 13525
/* 457 */     MCD::OPC_CheckField, 24, 8, 0, 5, 51, 0, // Skip to: 13525
/* 464 */     MCD::OPC_CheckField, 3, 1, 0, 254, 50, 0, // Skip to: 13525
/* 471 */     MCD::OPC_Decode, 171, 3, 7, // Opcode: AND8fi
/* 475 */     MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 505
/* 480 */     MCD::OPC_CheckField, 40, 4, 8, 238, 50, 0, // Skip to: 13525
/* 487 */     MCD::OPC_CheckField, 24, 8, 0, 231, 50, 0, // Skip to: 13525
/* 494 */     MCD::OPC_CheckField, 3, 1, 0, 224, 50, 0, // Skip to: 13525
/* 501 */     MCD::OPC_Decode, 183, 9, 7, // Opcode: SUB8fi
/* 505 */     MCD::OPC_FilterValue, 3, 25, 0, 0, // Skip to: 535
/* 510 */     MCD::OPC_CheckField, 40, 4, 8, 208, 50, 0, // Skip to: 13525
/* 517 */     MCD::OPC_CheckField, 24, 8, 0, 201, 50, 0, // Skip to: 13525
/* 524 */     MCD::OPC_CheckField, 3, 1, 0, 194, 50, 0, // Skip to: 13525
/* 531 */     MCD::OPC_Decode, 255, 2, 7, // Opcode: ADD8fi
/* 535 */     MCD::OPC_FilterValue, 4, 73, 0, 0, // Skip to: 613
/* 540 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 543 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 566
/* 548 */     MCD::OPC_CheckField, 40, 4, 8, 170, 50, 0, // Skip to: 13525
/* 555 */     MCD::OPC_CheckField, 24, 8, 0, 163, 50, 0, // Skip to: 13525
/* 562 */     MCD::OPC_Decode, 193, 3, 7, // Opcode: BTST8fi
/* 566 */     MCD::OPC_FilterValue, 1, 154, 50, 0, // Skip to: 13525
/* 571 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 574 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 590
/* 579 */     MCD::OPC_CheckField, 24, 8, 0, 139, 50, 0, // Skip to: 13525
/* 586 */     MCD::OPC_Decode, 203, 3, 8, // Opcode: BTST8qi
/* 590 */     MCD::OPC_FilterValue, 3, 130, 50, 0, // Skip to: 13525
/* 595 */     MCD::OPC_CheckField, 40, 4, 8, 123, 50, 0, // Skip to: 13525
/* 602 */     MCD::OPC_CheckField, 24, 8, 0, 116, 50, 0, // Skip to: 13525
/* 609 */     MCD::OPC_Decode, 197, 3, 9, // Opcode: BTST8ki
/* 613 */     MCD::OPC_FilterValue, 6, 107, 50, 0, // Skip to: 13525
/* 618 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 621 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 644
/* 626 */     MCD::OPC_CheckField, 40, 4, 8, 92, 50, 0, // Skip to: 13525
/* 633 */     MCD::OPC_CheckField, 24, 8, 0, 85, 50, 0, // Skip to: 13525
/* 640 */     MCD::OPC_Decode, 145, 4, 10, // Opcode: CMP8fi
/* 644 */     MCD::OPC_FilterValue, 1, 76, 50, 0, // Skip to: 13525
/* 649 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 652 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 668
/* 657 */     MCD::OPC_CheckField, 24, 8, 0, 61, 50, 0, // Skip to: 13525
/* 664 */     MCD::OPC_Decode, 137, 4, 11, // Opcode: CMP8bi
/* 668 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 684
/* 673 */     MCD::OPC_CheckField, 24, 8, 0, 45, 50, 0, // Skip to: 13525
/* 680 */     MCD::OPC_Decode, 149, 4, 12, // Opcode: CMP8qi
/* 684 */     MCD::OPC_FilterValue, 3, 36, 50, 0, // Skip to: 13525
/* 689 */     MCD::OPC_CheckField, 40, 4, 8, 29, 50, 0, // Skip to: 13525
/* 696 */     MCD::OPC_CheckField, 24, 8, 0, 22, 50, 0, // Skip to: 13525
/* 703 */     MCD::OPC_Decode, 147, 4, 13, // Opcode: CMP8ki
/* 707 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 747
/* 712 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 715 */     MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 731
/* 720 */     MCD::OPC_CheckField, 3, 1, 0, 254, 49, 0, // Skip to: 13525
/* 727 */     MCD::OPC_Decode, 201, 9, 14, // Opcode: XOR16di
/* 731 */     MCD::OPC_FilterValue, 6, 245, 49, 0, // Skip to: 13525
/* 736 */     MCD::OPC_CheckField, 3, 1, 0, 238, 49, 0, // Skip to: 13525
/* 743 */     MCD::OPC_Decode, 241, 3, 15, // Opcode: CMP16di
/* 747 */     MCD::OPC_FilterValue, 5, 83, 0, 0, // Skip to: 835
/* 752 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 755 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 771
/* 760 */     MCD::OPC_CheckField, 3, 1, 0, 214, 49, 0, // Skip to: 13525
/* 767 */     MCD::OPC_Decode, 164, 8, 16, // Opcode: OR16ji
/* 771 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 787
/* 776 */     MCD::OPC_CheckField, 3, 1, 0, 198, 49, 0, // Skip to: 13525
/* 783 */     MCD::OPC_Decode, 146, 3, 16, // Opcode: AND16ji
/* 787 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 803
/* 792 */     MCD::OPC_CheckField, 3, 1, 0, 182, 49, 0, // Skip to: 13525
/* 799 */     MCD::OPC_Decode, 150, 9, 16, // Opcode: SUB16ji
/* 803 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 819
/* 808 */     MCD::OPC_CheckField, 3, 1, 0, 166, 49, 0, // Skip to: 13525
/* 815 */     MCD::OPC_Decode, 222, 2, 16, // Opcode: ADD16ji
/* 819 */     MCD::OPC_FilterValue, 6, 157, 49, 0, // Skip to: 13525
/* 824 */     MCD::OPC_CheckField, 3, 1, 0, 150, 49, 0, // Skip to: 13525
/* 831 */     MCD::OPC_Decode, 248, 3, 17, // Opcode: CMP16ji
/* 835 */     MCD::OPC_FilterValue, 6, 83, 0, 0, // Skip to: 923
/* 840 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 843 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 859
/* 848 */     MCD::OPC_CheckField, 3, 1, 1, 126, 49, 0, // Skip to: 13525
/* 855 */     MCD::OPC_Decode, 166, 8, 18, // Opcode: OR16pi
/* 859 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 875
/* 864 */     MCD::OPC_CheckField, 3, 1, 1, 110, 49, 0, // Skip to: 13525
/* 871 */     MCD::OPC_Decode, 148, 3, 18, // Opcode: AND16pi
/* 875 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 891
/* 880 */     MCD::OPC_CheckField, 3, 1, 1, 94, 49, 0, // Skip to: 13525
/* 887 */     MCD::OPC_Decode, 152, 9, 18, // Opcode: SUB16pi
/* 891 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 907
/* 896 */     MCD::OPC_CheckField, 3, 1, 1, 78, 49, 0, // Skip to: 13525
/* 903 */     MCD::OPC_Decode, 224, 2, 18, // Opcode: ADD16pi
/* 907 */     MCD::OPC_FilterValue, 6, 69, 49, 0, // Skip to: 13525
/* 912 */     MCD::OPC_CheckField, 3, 1, 1, 62, 49, 0, // Skip to: 13525
/* 919 */     MCD::OPC_Decode, 250, 3, 19, // Opcode: CMP16pi
/* 923 */     MCD::OPC_FilterValue, 7, 161, 0, 0, // Skip to: 1089
/* 928 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 931 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 954
/* 936 */     MCD::OPC_CheckField, 40, 4, 8, 38, 49, 0, // Skip to: 13525
/* 943 */     MCD::OPC_CheckField, 3, 1, 0, 31, 49, 0, // Skip to: 13525
/* 950 */     MCD::OPC_Decode, 162, 8, 20, // Opcode: OR16fi
/* 954 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 977
/* 959 */     MCD::OPC_CheckField, 40, 4, 8, 15, 49, 0, // Skip to: 13525
/* 966 */     MCD::OPC_CheckField, 3, 1, 0, 8, 49, 0, // Skip to: 13525
/* 973 */     MCD::OPC_Decode, 144, 3, 20, // Opcode: AND16fi
/* 977 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1000
/* 982 */     MCD::OPC_CheckField, 40, 4, 8, 248, 48, 0, // Skip to: 13525
/* 989 */     MCD::OPC_CheckField, 3, 1, 0, 241, 48, 0, // Skip to: 13525
/* 996 */     MCD::OPC_Decode, 148, 9, 20, // Opcode: SUB16fi
/* 1000 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1023
/* 1005 */    MCD::OPC_CheckField, 40, 4, 8, 225, 48, 0, // Skip to: 13525
/* 1012 */    MCD::OPC_CheckField, 3, 1, 0, 218, 48, 0, // Skip to: 13525
/* 1019 */    MCD::OPC_Decode, 220, 2, 20, // Opcode: ADD16fi
/* 1023 */    MCD::OPC_FilterValue, 6, 209, 48, 0, // Skip to: 13525
/* 1028 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1031 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1047
/* 1036 */    MCD::OPC_CheckField, 40, 4, 8, 194, 48, 0, // Skip to: 13525
/* 1043 */    MCD::OPC_Decode, 247, 3, 21, // Opcode: CMP16fi
/* 1047 */    MCD::OPC_FilterValue, 1, 185, 48, 0, // Skip to: 13525
/* 1052 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1055 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1064
/* 1060 */    MCD::OPC_Decode, 239, 3, 22, // Opcode: CMP16bi
/* 1064 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1073
/* 1069 */    MCD::OPC_Decode, 251, 3, 23, // Opcode: CMP16qi
/* 1073 */    MCD::OPC_FilterValue, 3, 159, 48, 0, // Skip to: 13525
/* 1078 */    MCD::OPC_CheckField, 40, 4, 8, 152, 48, 0, // Skip to: 13525
/* 1085 */    MCD::OPC_Decode, 249, 3, 24, // Opcode: CMP16ki
/* 1089 */    MCD::OPC_FilterValue, 8, 35, 0, 0, // Skip to: 1129
/* 1094 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1097 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 1113
/* 1102 */    MCD::OPC_CheckField, 3, 1, 0, 128, 48, 0, // Skip to: 13525
/* 1109 */    MCD::OPC_Decode, 203, 9, 25, // Opcode: XOR32di
/* 1113 */    MCD::OPC_FilterValue, 6, 119, 48, 0, // Skip to: 13525
/* 1118 */    MCD::OPC_CheckField, 3, 1, 0, 112, 48, 0, // Skip to: 13525
/* 1125 */    MCD::OPC_Decode, 254, 3, 26, // Opcode: CMP32di
/* 1129 */    MCD::OPC_FilterValue, 9, 83, 0, 0, // Skip to: 1217
/* 1134 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1137 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1153
/* 1142 */    MCD::OPC_CheckField, 3, 1, 0, 88, 48, 0, // Skip to: 13525
/* 1149 */    MCD::OPC_Decode, 178, 8, 27, // Opcode: OR32ji
/* 1153 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1169
/* 1158 */    MCD::OPC_CheckField, 3, 1, 0, 72, 48, 0, // Skip to: 13525
/* 1165 */    MCD::OPC_Decode, 160, 3, 27, // Opcode: AND32ji
/* 1169 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1185
/* 1174 */    MCD::OPC_CheckField, 3, 1, 0, 56, 48, 0, // Skip to: 13525
/* 1181 */    MCD::OPC_Decode, 172, 9, 27, // Opcode: SUB32ji
/* 1185 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1201
/* 1190 */    MCD::OPC_CheckField, 3, 1, 0, 40, 48, 0, // Skip to: 13525
/* 1197 */    MCD::OPC_Decode, 244, 2, 27, // Opcode: ADD32ji
/* 1201 */    MCD::OPC_FilterValue, 6, 31, 48, 0, // Skip to: 13525
/* 1206 */    MCD::OPC_CheckField, 3, 1, 0, 24, 48, 0, // Skip to: 13525
/* 1213 */    MCD::OPC_Decode, 133, 4, 28, // Opcode: CMP32ji
/* 1217 */    MCD::OPC_FilterValue, 10, 83, 0, 0, // Skip to: 1305
/* 1222 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1225 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1241
/* 1230 */    MCD::OPC_CheckField, 3, 1, 1, 0, 48, 0, // Skip to: 13525
/* 1237 */    MCD::OPC_Decode, 180, 8, 29, // Opcode: OR32pi
/* 1241 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1257
/* 1246 */    MCD::OPC_CheckField, 3, 1, 1, 240, 47, 0, // Skip to: 13525
/* 1253 */    MCD::OPC_Decode, 162, 3, 29, // Opcode: AND32pi
/* 1257 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1273
/* 1262 */    MCD::OPC_CheckField, 3, 1, 1, 224, 47, 0, // Skip to: 13525
/* 1269 */    MCD::OPC_Decode, 174, 9, 29, // Opcode: SUB32pi
/* 1273 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1289
/* 1278 */    MCD::OPC_CheckField, 3, 1, 1, 208, 47, 0, // Skip to: 13525
/* 1285 */    MCD::OPC_Decode, 246, 2, 29, // Opcode: ADD32pi
/* 1289 */    MCD::OPC_FilterValue, 6, 199, 47, 0, // Skip to: 13525
/* 1294 */    MCD::OPC_CheckField, 3, 1, 1, 192, 47, 0, // Skip to: 13525
/* 1301 */    MCD::OPC_Decode, 135, 4, 30, // Opcode: CMP32pi
/* 1305 */    MCD::OPC_FilterValue, 11, 161, 0, 0, // Skip to: 1471
/* 1310 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1313 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 1336
/* 1318 */    MCD::OPC_CheckField, 56, 4, 8, 168, 47, 0, // Skip to: 13525
/* 1325 */    MCD::OPC_CheckField, 3, 1, 0, 161, 47, 0, // Skip to: 13525
/* 1332 */    MCD::OPC_Decode, 176, 8, 31, // Opcode: OR32fi
/* 1336 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 1359
/* 1341 */    MCD::OPC_CheckField, 56, 4, 8, 145, 47, 0, // Skip to: 13525
/* 1348 */    MCD::OPC_CheckField, 3, 1, 0, 138, 47, 0, // Skip to: 13525
/* 1355 */    MCD::OPC_Decode, 158, 3, 31, // Opcode: AND32fi
/* 1359 */    MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1382
/* 1364 */    MCD::OPC_CheckField, 56, 4, 8, 122, 47, 0, // Skip to: 13525
/* 1371 */    MCD::OPC_CheckField, 3, 1, 0, 115, 47, 0, // Skip to: 13525
/* 1378 */    MCD::OPC_Decode, 170, 9, 31, // Opcode: SUB32fi
/* 1382 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1405
/* 1387 */    MCD::OPC_CheckField, 56, 4, 8, 99, 47, 0, // Skip to: 13525
/* 1394 */    MCD::OPC_CheckField, 3, 1, 0, 92, 47, 0, // Skip to: 13525
/* 1401 */    MCD::OPC_Decode, 242, 2, 31, // Opcode: ADD32fi
/* 1405 */    MCD::OPC_FilterValue, 6, 83, 47, 0, // Skip to: 13525
/* 1410 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1413 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1429
/* 1418 */    MCD::OPC_CheckField, 56, 4, 8, 68, 47, 0, // Skip to: 13525
/* 1425 */    MCD::OPC_Decode, 132, 4, 32, // Opcode: CMP32fi
/* 1429 */    MCD::OPC_FilterValue, 1, 59, 47, 0, // Skip to: 13525
/* 1434 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1437 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1446
/* 1442 */    MCD::OPC_Decode, 252, 3, 33, // Opcode: CMP32bi
/* 1446 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1455
/* 1451 */    MCD::OPC_Decode, 136, 4, 34, // Opcode: CMP32qi
/* 1455 */    MCD::OPC_FilterValue, 3, 33, 47, 0, // Skip to: 13525
/* 1460 */    MCD::OPC_CheckField, 56, 4, 8, 26, 47, 0, // Skip to: 13525
/* 1467 */    MCD::OPC_Decode, 134, 4, 35, // Opcode: CMP32ki
/* 1471 */    MCD::OPC_FilterValue, 13, 108, 0, 0, // Skip to: 1584
/* 1476 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1479 */    MCD::OPC_FilterValue, 5, 30, 0, 0, // Skip to: 1514
/* 1484 */    MCD::OPC_CheckPredicate, 0, 4, 47, 0, // Skip to: 13525
/* 1489 */    MCD::OPC_CheckField, 25, 7, 0, 253, 46, 0, // Skip to: 13525
/* 1496 */    MCD::OPC_CheckField, 19, 3, 0, 246, 46, 0, // Skip to: 13525
/* 1503 */    MCD::OPC_CheckField, 3, 1, 0, 239, 46, 0, // Skip to: 13525
/* 1510 */    MCD::OPC_Decode, 238, 3, 36, // Opcode: CAS8
/* 1514 */    MCD::OPC_FilterValue, 6, 30, 0, 0, // Skip to: 1549
/* 1519 */    MCD::OPC_CheckPredicate, 0, 225, 46, 0, // Skip to: 13525
/* 1524 */    MCD::OPC_CheckField, 25, 7, 0, 218, 46, 0, // Skip to: 13525
/* 1531 */    MCD::OPC_CheckField, 19, 3, 0, 211, 46, 0, // Skip to: 13525
/* 1538 */    MCD::OPC_CheckField, 3, 1, 0, 204, 46, 0, // Skip to: 13525
/* 1545 */    MCD::OPC_Decode, 236, 3, 37, // Opcode: CAS16
/* 1549 */    MCD::OPC_FilterValue, 7, 195, 46, 0, // Skip to: 13525
/* 1554 */    MCD::OPC_CheckPredicate, 0, 190, 46, 0, // Skip to: 13525
/* 1559 */    MCD::OPC_CheckField, 25, 7, 0, 183, 46, 0, // Skip to: 13525
/* 1566 */    MCD::OPC_CheckField, 19, 3, 0, 176, 46, 0, // Skip to: 13525
/* 1573 */    MCD::OPC_CheckField, 3, 1, 0, 169, 46, 0, // Skip to: 13525
/* 1580 */    MCD::OPC_Decode, 237, 3, 38, // Opcode: CAS32
/* 1584 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1593
/* 1589 */    MCD::OPC_Decode, 188, 3, 39, // Opcode: BTST32dd
/* 1593 */    MCD::OPC_FilterValue, 17, 21, 0, 0, // Skip to: 1619
/* 1598 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1601 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1610
/* 1606 */    MCD::OPC_Decode, 194, 3, 40, // Opcode: BTST8jd
/* 1610 */    MCD::OPC_FilterValue, 1, 134, 46, 0, // Skip to: 13525
/* 1615 */    MCD::OPC_Decode, 198, 3, 40, // Opcode: BTST8od
/* 1619 */    MCD::OPC_FilterValue, 18, 21, 0, 0, // Skip to: 1645
/* 1624 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1627 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1636
/* 1632 */    MCD::OPC_Decode, 190, 3, 40, // Opcode: BTST8ed
/* 1636 */    MCD::OPC_FilterValue, 1, 108, 46, 0, // Skip to: 13525
/* 1641 */    MCD::OPC_Decode, 200, 3, 41, // Opcode: BTST8pd
/* 1645 */    MCD::OPC_FilterValue, 19, 99, 46, 0, // Skip to: 13525
/* 1650 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1653 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1669
/* 1658 */    MCD::OPC_CheckField, 24, 4, 8, 84, 46, 0, // Skip to: 13525
/* 1665 */    MCD::OPC_Decode, 192, 3, 42, // Opcode: BTST8fd
/* 1669 */    MCD::OPC_FilterValue, 1, 75, 46, 0, // Skip to: 13525
/* 1674 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1677 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1686
/* 1682 */    MCD::OPC_Decode, 202, 3, 43, // Opcode: BTST8qd
/* 1686 */    MCD::OPC_FilterValue, 3, 58, 46, 0, // Skip to: 13525
/* 1691 */    MCD::OPC_CheckField, 24, 4, 8, 51, 46, 0, // Skip to: 13525
/* 1698 */    MCD::OPC_Decode, 196, 3, 44, // Opcode: BTST8kd
/* 1702 */    MCD::OPC_FilterValue, 1, 254, 4, 0, // Skip to: 2985
/* 1707 */    MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 1710 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1719
/* 1715 */    MCD::OPC_Decode, 163, 7, 45, // Opcode: MOV8dd
/* 1719 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1728
/* 1724 */    MCD::OPC_Decode, 167, 7, 46, // Opcode: MOV8dj
/* 1728 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 1737
/* 1733 */    MCD::OPC_Decode, 169, 7, 46, // Opcode: MOV8do
/* 1737 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 1746
/* 1742 */    MCD::OPC_Decode, 164, 7, 46, // Opcode: MOV8de
/* 1746 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 1755
/* 1751 */    MCD::OPC_Decode, 170, 7, 47, // Opcode: MOV8dp
/* 1755 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 1771
/* 1760 */    MCD::OPC_CheckField, 24, 4, 8, 238, 45, 0, // Skip to: 13525
/* 1767 */    MCD::OPC_Decode, 165, 7, 48, // Opcode: MOV8df
/* 1771 */    MCD::OPC_FilterValue, 7, 53, 0, 0, // Skip to: 1829
/* 1776 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1779 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1788
/* 1784 */    MCD::OPC_Decode, 162, 7, 49, // Opcode: MOV8db
/* 1788 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1797
/* 1793 */    MCD::OPC_Decode, 171, 7, 50, // Opcode: MOV8dq
/* 1797 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1813
/* 1802 */    MCD::OPC_CheckField, 24, 4, 8, 196, 45, 0, // Skip to: 13525
/* 1809 */    MCD::OPC_Decode, 168, 7, 51, // Opcode: MOV8dk
/* 1813 */    MCD::OPC_FilterValue, 4, 187, 45, 0, // Skip to: 13525
/* 1818 */    MCD::OPC_CheckField, 24, 8, 0, 180, 45, 0, // Skip to: 13525
/* 1825 */    MCD::OPC_Decode, 166, 7, 52, // Opcode: MOV8di
/* 1829 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1838
/* 1834 */    MCD::OPC_Decode, 193, 7, 53, // Opcode: MOV8jd
/* 1838 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1847
/* 1843 */    MCD::OPC_Decode, 197, 7, 54, // Opcode: MOV8jj
/* 1847 */    MCD::OPC_FilterValue, 19, 4, 0, 0, // Skip to: 1856
/* 1852 */    MCD::OPC_Decode, 199, 7, 54, // Opcode: MOV8jo
/* 1856 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 1865
/* 1861 */    MCD::OPC_Decode, 194, 7, 54, // Opcode: MOV8je
/* 1865 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 1874
/* 1870 */    MCD::OPC_Decode, 200, 7, 55, // Opcode: MOV8jp
/* 1874 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 1890
/* 1879 */    MCD::OPC_CheckField, 24, 4, 8, 119, 45, 0, // Skip to: 13525
/* 1886 */    MCD::OPC_Decode, 195, 7, 56, // Opcode: MOV8jf
/* 1890 */    MCD::OPC_FilterValue, 23, 53, 0, 0, // Skip to: 1948
/* 1895 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1898 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1907
/* 1903 */    MCD::OPC_Decode, 192, 7, 57, // Opcode: MOV8jb
/* 1907 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1916
/* 1912 */    MCD::OPC_Decode, 201, 7, 58, // Opcode: MOV8jq
/* 1916 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1932
/* 1921 */    MCD::OPC_CheckField, 24, 4, 8, 77, 45, 0, // Skip to: 13525
/* 1928 */    MCD::OPC_Decode, 198, 7, 59, // Opcode: MOV8jk
/* 1932 */    MCD::OPC_FilterValue, 4, 68, 45, 0, // Skip to: 13525
/* 1937 */    MCD::OPC_CheckField, 24, 8, 0, 61, 45, 0, // Skip to: 13525
/* 1944 */    MCD::OPC_Decode, 196, 7, 60, // Opcode: MOV8ji
/* 1948 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 1957
/* 1953 */    MCD::OPC_Decode, 213, 7, 53, // Opcode: MOV8od
/* 1957 */    MCD::OPC_FilterValue, 26, 4, 0, 0, // Skip to: 1966
/* 1962 */    MCD::OPC_Decode, 217, 7, 54, // Opcode: MOV8oj
/* 1966 */    MCD::OPC_FilterValue, 27, 4, 0, 0, // Skip to: 1975
/* 1971 */    MCD::OPC_Decode, 219, 7, 54, // Opcode: MOV8oo
/* 1975 */    MCD::OPC_FilterValue, 28, 4, 0, 0, // Skip to: 1984
/* 1980 */    MCD::OPC_Decode, 214, 7, 54, // Opcode: MOV8oe
/* 1984 */    MCD::OPC_FilterValue, 29, 4, 0, 0, // Skip to: 1993
/* 1989 */    MCD::OPC_Decode, 220, 7, 55, // Opcode: MOV8op
/* 1993 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 2009
/* 1998 */    MCD::OPC_CheckField, 24, 4, 8, 0, 45, 0, // Skip to: 13525
/* 2005 */    MCD::OPC_Decode, 215, 7, 56, // Opcode: MOV8of
/* 2009 */    MCD::OPC_FilterValue, 31, 53, 0, 0, // Skip to: 2067
/* 2014 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2017 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2026
/* 2022 */    MCD::OPC_Decode, 212, 7, 57, // Opcode: MOV8ob
/* 2026 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2035
/* 2031 */    MCD::OPC_Decode, 221, 7, 58, // Opcode: MOV8oq
/* 2035 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2051
/* 2040 */    MCD::OPC_CheckField, 24, 4, 8, 214, 44, 0, // Skip to: 13525
/* 2047 */    MCD::OPC_Decode, 218, 7, 59, // Opcode: MOV8ok
/* 2051 */    MCD::OPC_FilterValue, 4, 205, 44, 0, // Skip to: 13525
/* 2056 */    MCD::OPC_CheckField, 24, 8, 0, 198, 44, 0, // Skip to: 13525
/* 2063 */    MCD::OPC_Decode, 216, 7, 60, // Opcode: MOV8oi
/* 2067 */    MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 2076
/* 2072 */    MCD::OPC_Decode, 173, 7, 53, // Opcode: MOV8ed
/* 2076 */    MCD::OPC_FilterValue, 34, 4, 0, 0, // Skip to: 2085
/* 2081 */    MCD::OPC_Decode, 177, 7, 54, // Opcode: MOV8ej
/* 2085 */    MCD::OPC_FilterValue, 35, 4, 0, 0, // Skip to: 2094
/* 2090 */    MCD::OPC_Decode, 179, 7, 54, // Opcode: MOV8eo
/* 2094 */    MCD::OPC_FilterValue, 36, 4, 0, 0, // Skip to: 2103
/* 2099 */    MCD::OPC_Decode, 174, 7, 54, // Opcode: MOV8ee
/* 2103 */    MCD::OPC_FilterValue, 37, 4, 0, 0, // Skip to: 2112
/* 2108 */    MCD::OPC_Decode, 180, 7, 55, // Opcode: MOV8ep
/* 2112 */    MCD::OPC_FilterValue, 38, 11, 0, 0, // Skip to: 2128
/* 2117 */    MCD::OPC_CheckField, 24, 4, 8, 137, 44, 0, // Skip to: 13525
/* 2124 */    MCD::OPC_Decode, 175, 7, 56, // Opcode: MOV8ef
/* 2128 */    MCD::OPC_FilterValue, 39, 53, 0, 0, // Skip to: 2186
/* 2133 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2136 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2145
/* 2141 */    MCD::OPC_Decode, 172, 7, 57, // Opcode: MOV8eb
/* 2145 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2154
/* 2150 */    MCD::OPC_Decode, 181, 7, 58, // Opcode: MOV8eq
/* 2154 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2170
/* 2159 */    MCD::OPC_CheckField, 24, 4, 8, 95, 44, 0, // Skip to: 13525
/* 2166 */    MCD::OPC_Decode, 178, 7, 59, // Opcode: MOV8ek
/* 2170 */    MCD::OPC_FilterValue, 4, 86, 44, 0, // Skip to: 13525
/* 2175 */    MCD::OPC_CheckField, 24, 8, 0, 79, 44, 0, // Skip to: 13525
/* 2182 */    MCD::OPC_Decode, 176, 7, 60, // Opcode: MOV8ei
/* 2186 */    MCD::OPC_FilterValue, 40, 4, 0, 0, // Skip to: 2195
/* 2191 */    MCD::OPC_Decode, 223, 7, 61, // Opcode: MOV8pd
/* 2195 */    MCD::OPC_FilterValue, 42, 4, 0, 0, // Skip to: 2204
/* 2200 */    MCD::OPC_Decode, 227, 7, 62, // Opcode: MOV8pj
/* 2204 */    MCD::OPC_FilterValue, 43, 4, 0, 0, // Skip to: 2213
/* 2209 */    MCD::OPC_Decode, 229, 7, 62, // Opcode: MOV8po
/* 2213 */    MCD::OPC_FilterValue, 44, 4, 0, 0, // Skip to: 2222
/* 2218 */    MCD::OPC_Decode, 224, 7, 62, // Opcode: MOV8pe
/* 2222 */    MCD::OPC_FilterValue, 45, 4, 0, 0, // Skip to: 2231
/* 2227 */    MCD::OPC_Decode, 230, 7, 63, // Opcode: MOV8pp
/* 2231 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 2247
/* 2236 */    MCD::OPC_CheckField, 24, 4, 8, 18, 44, 0, // Skip to: 13525
/* 2243 */    MCD::OPC_Decode, 225, 7, 64, // Opcode: MOV8pf
/* 2247 */    MCD::OPC_FilterValue, 47, 53, 0, 0, // Skip to: 2305
/* 2252 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2255 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2264
/* 2260 */    MCD::OPC_Decode, 222, 7, 65, // Opcode: MOV8pb
/* 2264 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2273
/* 2269 */    MCD::OPC_Decode, 231, 7, 66, // Opcode: MOV8pq
/* 2273 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2289
/* 2278 */    MCD::OPC_CheckField, 24, 4, 8, 232, 43, 0, // Skip to: 13525
/* 2285 */    MCD::OPC_Decode, 228, 7, 67, // Opcode: MOV8pk
/* 2289 */    MCD::OPC_FilterValue, 4, 223, 43, 0, // Skip to: 13525
/* 2294 */    MCD::OPC_CheckField, 24, 8, 0, 216, 43, 0, // Skip to: 13525
/* 2301 */    MCD::OPC_Decode, 226, 7, 68, // Opcode: MOV8pi
/* 2305 */    MCD::OPC_FilterValue, 48, 11, 0, 0, // Skip to: 2321
/* 2310 */    MCD::OPC_CheckField, 24, 4, 8, 200, 43, 0, // Skip to: 13525
/* 2317 */    MCD::OPC_Decode, 183, 7, 69, // Opcode: MOV8fd
/* 2321 */    MCD::OPC_FilterValue, 50, 11, 0, 0, // Skip to: 2337
/* 2326 */    MCD::OPC_CheckField, 24, 4, 8, 184, 43, 0, // Skip to: 13525
/* 2333 */    MCD::OPC_Decode, 187, 7, 70, // Opcode: MOV8fj
/* 2337 */    MCD::OPC_FilterValue, 51, 11, 0, 0, // Skip to: 2353
/* 2342 */    MCD::OPC_CheckField, 24, 4, 8, 168, 43, 0, // Skip to: 13525
/* 2349 */    MCD::OPC_Decode, 189, 7, 70, // Opcode: MOV8fo
/* 2353 */    MCD::OPC_FilterValue, 52, 11, 0, 0, // Skip to: 2369
/* 2358 */    MCD::OPC_CheckField, 24, 4, 8, 152, 43, 0, // Skip to: 13525
/* 2365 */    MCD::OPC_Decode, 184, 7, 70, // Opcode: MOV8fe
/* 2369 */    MCD::OPC_FilterValue, 53, 11, 0, 0, // Skip to: 2385
/* 2374 */    MCD::OPC_CheckField, 40, 4, 8, 136, 43, 0, // Skip to: 13525
/* 2381 */    MCD::OPC_Decode, 190, 7, 71, // Opcode: MOV8fp
/* 2385 */    MCD::OPC_FilterValue, 54, 18, 0, 0, // Skip to: 2408
/* 2390 */    MCD::OPC_CheckField, 40, 4, 8, 120, 43, 0, // Skip to: 13525
/* 2397 */    MCD::OPC_CheckField, 24, 4, 8, 113, 43, 0, // Skip to: 13525
/* 2404 */    MCD::OPC_Decode, 185, 7, 72, // Opcode: MOV8ff
/* 2408 */    MCD::OPC_FilterValue, 55, 81, 0, 0, // Skip to: 2494
/* 2413 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2416 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2432
/* 2421 */    MCD::OPC_CheckField, 56, 4, 8, 89, 43, 0, // Skip to: 13525
/* 2428 */    MCD::OPC_Decode, 182, 7, 73, // Opcode: MOV8fb
/* 2432 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2448
/* 2437 */    MCD::OPC_CheckField, 40, 4, 8, 73, 43, 0, // Skip to: 13525
/* 2444 */    MCD::OPC_Decode, 191, 7, 74, // Opcode: MOV8fq
/* 2448 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 2471
/* 2453 */    MCD::OPC_CheckField, 40, 4, 8, 57, 43, 0, // Skip to: 13525
/* 2460 */    MCD::OPC_CheckField, 24, 4, 8, 50, 43, 0, // Skip to: 13525
/* 2467 */    MCD::OPC_Decode, 188, 7, 75, // Opcode: MOV8fk
/* 2471 */    MCD::OPC_FilterValue, 4, 41, 43, 0, // Skip to: 13525
/* 2476 */    MCD::OPC_CheckField, 40, 4, 8, 34, 43, 0, // Skip to: 13525
/* 2483 */    MCD::OPC_CheckField, 24, 8, 0, 27, 43, 0, // Skip to: 13525
/* 2490 */    MCD::OPC_Decode, 186, 7, 76, // Opcode: MOV8fi
/* 2494 */    MCD::OPC_FilterValue, 56, 37, 0, 0, // Skip to: 2536
/* 2499 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2502 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2511
/* 2507 */    MCD::OPC_Decode, 153, 7, 77, // Opcode: MOV8bd
/* 2511 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2520
/* 2516 */    MCD::OPC_Decode, 233, 7, 78, // Opcode: MOV8qd
/* 2520 */    MCD::OPC_FilterValue, 3, 248, 42, 0, // Skip to: 13525
/* 2525 */    MCD::OPC_CheckField, 24, 4, 8, 241, 42, 0, // Skip to: 13525
/* 2532 */    MCD::OPC_Decode, 203, 7, 79, // Opcode: MOV8kd
/* 2536 */    MCD::OPC_FilterValue, 58, 37, 0, 0, // Skip to: 2578
/* 2541 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2544 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2553
/* 2549 */    MCD::OPC_Decode, 157, 7, 28, // Opcode: MOV8bj
/* 2553 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2562
/* 2558 */    MCD::OPC_Decode, 237, 7, 17, // Opcode: MOV8qj
/* 2562 */    MCD::OPC_FilterValue, 3, 206, 42, 0, // Skip to: 13525
/* 2567 */    MCD::OPC_CheckField, 24, 4, 8, 199, 42, 0, // Skip to: 13525
/* 2574 */    MCD::OPC_Decode, 207, 7, 80, // Opcode: MOV8kj
/* 2578 */    MCD::OPC_FilterValue, 59, 37, 0, 0, // Skip to: 2620
/* 2583 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2586 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2595
/* 2591 */    MCD::OPC_Decode, 159, 7, 28, // Opcode: MOV8bo
/* 2595 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2604
/* 2600 */    MCD::OPC_Decode, 239, 7, 17, // Opcode: MOV8qo
/* 2604 */    MCD::OPC_FilterValue, 3, 164, 42, 0, // Skip to: 13525
/* 2609 */    MCD::OPC_CheckField, 24, 4, 8, 157, 42, 0, // Skip to: 13525
/* 2616 */    MCD::OPC_Decode, 209, 7, 80, // Opcode: MOV8ko
/* 2620 */    MCD::OPC_FilterValue, 60, 37, 0, 0, // Skip to: 2662
/* 2625 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2628 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2637
/* 2633 */    MCD::OPC_Decode, 154, 7, 28, // Opcode: MOV8be
/* 2637 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2646
/* 2642 */    MCD::OPC_Decode, 234, 7, 17, // Opcode: MOV8qe
/* 2646 */    MCD::OPC_FilterValue, 3, 122, 42, 0, // Skip to: 13525
/* 2651 */    MCD::OPC_CheckField, 24, 4, 8, 115, 42, 0, // Skip to: 13525
/* 2658 */    MCD::OPC_Decode, 204, 7, 80, // Opcode: MOV8ke
/* 2662 */    MCD::OPC_FilterValue, 61, 37, 0, 0, // Skip to: 2704
/* 2667 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2670 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2679
/* 2675 */    MCD::OPC_Decode, 160, 7, 81, // Opcode: MOV8bp
/* 2679 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2688
/* 2684 */    MCD::OPC_Decode, 240, 7, 82, // Opcode: MOV8qp
/* 2688 */    MCD::OPC_FilterValue, 3, 80, 42, 0, // Skip to: 13525
/* 2693 */    MCD::OPC_CheckField, 40, 4, 8, 73, 42, 0, // Skip to: 13525
/* 2700 */    MCD::OPC_Decode, 210, 7, 83, // Opcode: MOV8kp
/* 2704 */    MCD::OPC_FilterValue, 62, 58, 0, 0, // Skip to: 2767
/* 2709 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2712 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2728
/* 2717 */    MCD::OPC_CheckField, 24, 4, 8, 49, 42, 0, // Skip to: 13525
/* 2724 */    MCD::OPC_Decode, 155, 7, 84, // Opcode: MOV8bf
/* 2728 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2744
/* 2733 */    MCD::OPC_CheckField, 24, 4, 8, 33, 42, 0, // Skip to: 13525
/* 2740 */    MCD::OPC_Decode, 235, 7, 85, // Opcode: MOV8qf
/* 2744 */    MCD::OPC_FilterValue, 3, 24, 42, 0, // Skip to: 13525
/* 2749 */    MCD::OPC_CheckField, 40, 4, 8, 17, 42, 0, // Skip to: 13525
/* 2756 */    MCD::OPC_CheckField, 24, 4, 8, 10, 42, 0, // Skip to: 13525
/* 2763 */    MCD::OPC_Decode, 205, 7, 86, // Opcode: MOV8kf
/* 2767 */    MCD::OPC_FilterValue, 63, 1, 42, 0, // Skip to: 13525
/* 2772 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2775 */    MCD::OPC_FilterValue, 1, 37, 0, 0, // Skip to: 2817
/* 2780 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2783 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2792
/* 2788 */    MCD::OPC_Decode, 152, 7, 87, // Opcode: MOV8bb
/* 2792 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2801
/* 2797 */    MCD::OPC_Decode, 232, 7, 88, // Opcode: MOV8qb
/* 2801 */    MCD::OPC_FilterValue, 3, 223, 41, 0, // Skip to: 13525
/* 2806 */    MCD::OPC_CheckField, 56, 4, 8, 216, 41, 0, // Skip to: 13525
/* 2813 */    MCD::OPC_Decode, 202, 7, 89, // Opcode: MOV8kb
/* 2817 */    MCD::OPC_FilterValue, 2, 37, 0, 0, // Skip to: 2859
/* 2822 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2825 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2834
/* 2830 */    MCD::OPC_Decode, 161, 7, 90, // Opcode: MOV8bq
/* 2834 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2843
/* 2839 */    MCD::OPC_Decode, 241, 7, 91, // Opcode: MOV8qq
/* 2843 */    MCD::OPC_FilterValue, 3, 181, 41, 0, // Skip to: 13525
/* 2848 */    MCD::OPC_CheckField, 40, 4, 8, 174, 41, 0, // Skip to: 13525
/* 2855 */    MCD::OPC_Decode, 211, 7, 92, // Opcode: MOV8kq
/* 2859 */    MCD::OPC_FilterValue, 3, 58, 0, 0, // Skip to: 2922
/* 2864 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2867 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2883
/* 2872 */    MCD::OPC_CheckField, 24, 4, 8, 150, 41, 0, // Skip to: 13525
/* 2879 */    MCD::OPC_Decode, 158, 7, 93, // Opcode: MOV8bk
/* 2883 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2899
/* 2888 */    MCD::OPC_CheckField, 24, 4, 8, 134, 41, 0, // Skip to: 13525
/* 2895 */    MCD::OPC_Decode, 238, 7, 94, // Opcode: MOV8qk
/* 2899 */    MCD::OPC_FilterValue, 3, 125, 41, 0, // Skip to: 13525
/* 2904 */    MCD::OPC_CheckField, 40, 4, 8, 118, 41, 0, // Skip to: 13525
/* 2911 */    MCD::OPC_CheckField, 24, 4, 8, 111, 41, 0, // Skip to: 13525
/* 2918 */    MCD::OPC_Decode, 208, 7, 95, // Opcode: MOV8kk
/* 2922 */    MCD::OPC_FilterValue, 4, 102, 41, 0, // Skip to: 13525
/* 2927 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2930 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2946
/* 2935 */    MCD::OPC_CheckField, 24, 8, 0, 87, 41, 0, // Skip to: 13525
/* 2942 */    MCD::OPC_Decode, 156, 7, 96, // Opcode: MOV8bi
/* 2946 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2962
/* 2951 */    MCD::OPC_CheckField, 24, 8, 0, 71, 41, 0, // Skip to: 13525
/* 2958 */    MCD::OPC_Decode, 236, 7, 8, // Opcode: MOV8qi
/* 2962 */    MCD::OPC_FilterValue, 3, 62, 41, 0, // Skip to: 13525
/* 2967 */    MCD::OPC_CheckField, 40, 4, 8, 55, 41, 0, // Skip to: 13525
/* 2974 */    MCD::OPC_CheckField, 24, 8, 0, 48, 41, 0, // Skip to: 13525
/* 2981 */    MCD::OPC_Decode, 206, 7, 9, // Opcode: MOV8ki
/* 2985 */    MCD::OPC_FilterValue, 2, 178, 7, 0, // Skip to: 4960
/* 2990 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 2993 */    MCD::OPC_FilterValue, 0, 94, 1, 0, // Skip to: 3348
/* 2998 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 3001 */    MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 3060
/* 3006 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3009 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3025
/* 3014 */    MCD::OPC_CheckField, 6, 1, 0, 24, 0, 0, // Skip to: 3045
/* 3021 */    MCD::OPC_Decode, 168, 6, 97, // Opcode: MOV32dd
/* 3025 */    MCD::OPC_FilterValue, 1, 15, 0, 0, // Skip to: 3045
/* 3030 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 3041
/* 3037 */    MCD::OPC_Decode, 136, 6, 54, // Opcode: MOV32aa
/* 3041 */    MCD::OPC_Decode, 133, 7, 98, // Opcode: MOV32ra
/* 3045 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 3056
/* 3052 */    MCD::OPC_Decode, 154, 6, 99, // Opcode: MOV32ar
/* 3056 */    MCD::OPC_Decode, 151, 7, 100, // Opcode: MOV32rr
/* 3060 */    MCD::OPC_FilterValue, 1, 63, 0, 0, // Skip to: 3128
/* 3065 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3068 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3098
/* 3073 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3076 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3085
/* 3081 */    MCD::OPC_Decode, 203, 6, 101, // Opcode: MOV32jd
/* 3085 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3094
/* 3090 */    MCD::OPC_Decode, 201, 6, 54, // Opcode: MOV32ja
/* 3094 */    MCD::OPC_Decode, 212, 6, 99, // Opcode: MOV32jr
/* 3098 */    MCD::OPC_FilterValue, 1, 182, 40, 0, // Skip to: 13525
/* 3103 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3106 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3115
/* 3111 */    MCD::OPC_Decode, 227, 6, 101, // Opcode: MOV32od
/* 3115 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3124
/* 3120 */    MCD::OPC_Decode, 225, 6, 54, // Opcode: MOV32oa
/* 3124 */    MCD::OPC_Decode, 236, 6, 99, // Opcode: MOV32or
/* 3128 */    MCD::OPC_FilterValue, 2, 63, 0, 0, // Skip to: 3196
/* 3133 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3136 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3166
/* 3141 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3144 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3153
/* 3149 */    MCD::OPC_Decode, 179, 6, 101, // Opcode: MOV32ed
/* 3153 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3162
/* 3158 */    MCD::OPC_Decode, 177, 6, 54, // Opcode: MOV32ea
/* 3162 */    MCD::OPC_Decode, 188, 6, 99, // Opcode: MOV32er
/* 3166 */    MCD::OPC_FilterValue, 1, 114, 40, 0, // Skip to: 13525
/* 3171 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3174 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3183
/* 3179 */    MCD::OPC_Decode, 239, 6, 102, // Opcode: MOV32pd
/* 3183 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3192
/* 3188 */    MCD::OPC_Decode, 237, 6, 62, // Opcode: MOV32pa
/* 3192 */    MCD::OPC_Decode, 248, 6, 103, // Opcode: MOV32pr
/* 3196 */    MCD::OPC_FilterValue, 3, 84, 40, 0, // Skip to: 13525
/* 3201 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3204 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 3242
/* 3209 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 3212 */    MCD::OPC_FilterValue, 8, 68, 40, 0, // Skip to: 13525
/* 3217 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3220 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3229
/* 3225 */    MCD::OPC_Decode, 191, 6, 104, // Opcode: MOV32fd
/* 3229 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3238
/* 3234 */    MCD::OPC_Decode, 189, 6, 70, // Opcode: MOV32fa
/* 3238 */    MCD::OPC_Decode, 200, 6, 105, // Opcode: MOV32fr
/* 3242 */    MCD::OPC_FilterValue, 1, 38, 40, 0, // Skip to: 13525
/* 3247 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3250 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 3280
/* 3255 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3258 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3267
/* 3263 */    MCD::OPC_Decode, 157, 6, 26, // Opcode: MOV32bd
/* 3267 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3276
/* 3272 */    MCD::OPC_Decode, 155, 6, 28, // Opcode: MOV32ba
/* 3276 */    MCD::OPC_Decode, 166, 6, 106, // Opcode: MOV32br
/* 3280 */    MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 3310
/* 3285 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3288 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3297
/* 3293 */    MCD::OPC_Decode, 251, 6, 107, // Opcode: MOV32qd
/* 3297 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3306
/* 3302 */    MCD::OPC_Decode, 249, 6, 17, // Opcode: MOV32qa
/* 3306 */    MCD::OPC_Decode, 132, 7, 108, // Opcode: MOV32qr
/* 3310 */    MCD::OPC_FilterValue, 3, 226, 39, 0, // Skip to: 13525
/* 3315 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 3318 */    MCD::OPC_FilterValue, 8, 218, 39, 0, // Skip to: 13525
/* 3323 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3326 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3335
/* 3331 */    MCD::OPC_Decode, 215, 6, 109, // Opcode: MOV32kd
/* 3335 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3344
/* 3340 */    MCD::OPC_Decode, 213, 6, 80, // Opcode: MOV32ka
/* 3344 */    MCD::OPC_Decode, 224, 6, 110, // Opcode: MOV32kr
/* 3348 */    MCD::OPC_FilterValue, 1, 75, 1, 0, // Skip to: 3684
/* 3353 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 3356 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 3424
/* 3361 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3364 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3394
/* 3369 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3372 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3381
/* 3377 */    MCD::OPC_Decode, 172, 6, 111, // Opcode: MOV32dj
/* 3381 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3390
/* 3386 */    MCD::OPC_Decode, 144, 6, 54, // Opcode: MOV32aj
/* 3390 */    MCD::OPC_Decode, 141, 7, 98, // Opcode: MOV32rj
/* 3394 */    MCD::OPC_FilterValue, 1, 142, 39, 0, // Skip to: 13525
/* 3399 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3402 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3411
/* 3407 */    MCD::OPC_Decode, 174, 6, 111, // Opcode: MOV32do
/* 3411 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3420
/* 3416 */    MCD::OPC_Decode, 148, 6, 54, // Opcode: MOV32ao
/* 3420 */    MCD::OPC_Decode, 145, 7, 98, // Opcode: MOV32ro
/* 3424 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 3484
/* 3429 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3432 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3458
/* 3437 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3440 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3449
/* 3445 */    MCD::OPC_Decode, 207, 6, 54, // Opcode: MOV32jj
/* 3449 */    MCD::OPC_FilterValue, 1, 87, 39, 0, // Skip to: 13525
/* 3454 */    MCD::OPC_Decode, 231, 6, 54, // Opcode: MOV32oj
/* 3458 */    MCD::OPC_FilterValue, 1, 78, 39, 0, // Skip to: 13525
/* 3463 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3466 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3475
/* 3471 */    MCD::OPC_Decode, 209, 6, 54, // Opcode: MOV32jo
/* 3475 */    MCD::OPC_FilterValue, 1, 61, 39, 0, // Skip to: 13525
/* 3480 */    MCD::OPC_Decode, 233, 6, 54, // Opcode: MOV32oo
/* 3484 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 3544
/* 3489 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3492 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3518
/* 3497 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3500 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3509
/* 3505 */    MCD::OPC_Decode, 183, 6, 54, // Opcode: MOV32ej
/* 3509 */    MCD::OPC_FilterValue, 1, 27, 39, 0, // Skip to: 13525
/* 3514 */    MCD::OPC_Decode, 243, 6, 62, // Opcode: MOV32pj
/* 3518 */    MCD::OPC_FilterValue, 1, 18, 39, 0, // Skip to: 13525
/* 3523 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3526 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3535
/* 3531 */    MCD::OPC_Decode, 185, 6, 54, // Opcode: MOV32eo
/* 3535 */    MCD::OPC_FilterValue, 1, 1, 39, 0, // Skip to: 13525
/* 3540 */    MCD::OPC_Decode, 245, 6, 62, // Opcode: MOV32po
/* 3544 */    MCD::OPC_FilterValue, 3, 248, 38, 0, // Skip to: 13525
/* 3549 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3552 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 3618
/* 3557 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3560 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3576
/* 3565 */    MCD::OPC_CheckField, 24, 4, 8, 225, 38, 0, // Skip to: 13525
/* 3572 */    MCD::OPC_Decode, 195, 6, 70, // Opcode: MOV32fj
/* 3576 */    MCD::OPC_FilterValue, 1, 216, 38, 0, // Skip to: 13525
/* 3581 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3584 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3593
/* 3589 */    MCD::OPC_Decode, 161, 6, 28, // Opcode: MOV32bj
/* 3593 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3602
/* 3598 */    MCD::OPC_Decode, 255, 6, 17, // Opcode: MOV32qj
/* 3602 */    MCD::OPC_FilterValue, 3, 190, 38, 0, // Skip to: 13525
/* 3607 */    MCD::OPC_CheckField, 24, 4, 8, 183, 38, 0, // Skip to: 13525
/* 3614 */    MCD::OPC_Decode, 219, 6, 80, // Opcode: MOV32kj
/* 3618 */    MCD::OPC_FilterValue, 1, 174, 38, 0, // Skip to: 13525
/* 3623 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3626 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3642
/* 3631 */    MCD::OPC_CheckField, 24, 4, 8, 159, 38, 0, // Skip to: 13525
/* 3638 */    MCD::OPC_Decode, 197, 6, 70, // Opcode: MOV32fo
/* 3642 */    MCD::OPC_FilterValue, 1, 150, 38, 0, // Skip to: 13525
/* 3647 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3650 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3659
/* 3655 */    MCD::OPC_Decode, 163, 6, 28, // Opcode: MOV32bo
/* 3659 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3668
/* 3664 */    MCD::OPC_Decode, 129, 7, 17, // Opcode: MOV32qo
/* 3668 */    MCD::OPC_FilterValue, 3, 124, 38, 0, // Skip to: 13525
/* 3673 */    MCD::OPC_CheckField, 24, 4, 8, 117, 38, 0, // Skip to: 13525
/* 3680 */    MCD::OPC_Decode, 221, 6, 80, // Opcode: MOV32ko
/* 3684 */    MCD::OPC_FilterValue, 2, 75, 1, 0, // Skip to: 4020
/* 3689 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 3692 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 3760
/* 3697 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3700 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3730
/* 3705 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3708 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3717
/* 3713 */    MCD::OPC_Decode, 169, 6, 111, // Opcode: MOV32de
/* 3717 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3726
/* 3722 */    MCD::OPC_Decode, 139, 6, 54, // Opcode: MOV32ae
/* 3726 */    MCD::OPC_Decode, 136, 7, 98, // Opcode: MOV32re
/* 3730 */    MCD::OPC_FilterValue, 1, 62, 38, 0, // Skip to: 13525
/* 3735 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3738 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3747
/* 3743 */    MCD::OPC_Decode, 175, 6, 112, // Opcode: MOV32dp
/* 3747 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3756
/* 3752 */    MCD::OPC_Decode, 150, 6, 55, // Opcode: MOV32ap
/* 3756 */    MCD::OPC_Decode, 147, 7, 113, // Opcode: MOV32rp
/* 3760 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 3820
/* 3765 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3768 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3794
/* 3773 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3776 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3785
/* 3781 */    MCD::OPC_Decode, 204, 6, 54, // Opcode: MOV32je
/* 3785 */    MCD::OPC_FilterValue, 1, 7, 38, 0, // Skip to: 13525
/* 3790 */    MCD::OPC_Decode, 228, 6, 54, // Opcode: MOV32oe
/* 3794 */    MCD::OPC_FilterValue, 1, 254, 37, 0, // Skip to: 13525
/* 3799 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3802 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3811
/* 3807 */    MCD::OPC_Decode, 210, 6, 55, // Opcode: MOV32jp
/* 3811 */    MCD::OPC_FilterValue, 1, 237, 37, 0, // Skip to: 13525
/* 3816 */    MCD::OPC_Decode, 234, 6, 55, // Opcode: MOV32op
/* 3820 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 3880
/* 3825 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3828 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3854
/* 3833 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3836 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3845
/* 3841 */    MCD::OPC_Decode, 180, 6, 54, // Opcode: MOV32ee
/* 3845 */    MCD::OPC_FilterValue, 1, 203, 37, 0, // Skip to: 13525
/* 3850 */    MCD::OPC_Decode, 240, 6, 62, // Opcode: MOV32pe
/* 3854 */    MCD::OPC_FilterValue, 1, 194, 37, 0, // Skip to: 13525
/* 3859 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3862 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3871
/* 3867 */    MCD::OPC_Decode, 186, 6, 55, // Opcode: MOV32ep
/* 3871 */    MCD::OPC_FilterValue, 1, 177, 37, 0, // Skip to: 13525
/* 3876 */    MCD::OPC_Decode, 246, 6, 63, // Opcode: MOV32pp
/* 3880 */    MCD::OPC_FilterValue, 3, 168, 37, 0, // Skip to: 13525
/* 3885 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3888 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 3954
/* 3893 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3896 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3912
/* 3901 */    MCD::OPC_CheckField, 24, 4, 8, 145, 37, 0, // Skip to: 13525
/* 3908 */    MCD::OPC_Decode, 192, 6, 70, // Opcode: MOV32fe
/* 3912 */    MCD::OPC_FilterValue, 1, 136, 37, 0, // Skip to: 13525
/* 3917 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3920 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3929
/* 3925 */    MCD::OPC_Decode, 158, 6, 28, // Opcode: MOV32be
/* 3929 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3938
/* 3934 */    MCD::OPC_Decode, 252, 6, 17, // Opcode: MOV32qe
/* 3938 */    MCD::OPC_FilterValue, 3, 110, 37, 0, // Skip to: 13525
/* 3943 */    MCD::OPC_CheckField, 24, 4, 8, 103, 37, 0, // Skip to: 13525
/* 3950 */    MCD::OPC_Decode, 216, 6, 80, // Opcode: MOV32ke
/* 3954 */    MCD::OPC_FilterValue, 1, 94, 37, 0, // Skip to: 13525
/* 3959 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3962 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3978
/* 3967 */    MCD::OPC_CheckField, 40, 4, 8, 79, 37, 0, // Skip to: 13525
/* 3974 */    MCD::OPC_Decode, 198, 6, 71, // Opcode: MOV32fp
/* 3978 */    MCD::OPC_FilterValue, 1, 70, 37, 0, // Skip to: 13525
/* 3983 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3986 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3995
/* 3991 */    MCD::OPC_Decode, 164, 6, 81, // Opcode: MOV32bp
/* 3995 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4004
/* 4000 */    MCD::OPC_Decode, 130, 7, 82, // Opcode: MOV32qp
/* 4004 */    MCD::OPC_FilterValue, 3, 44, 37, 0, // Skip to: 13525
/* 4009 */    MCD::OPC_CheckField, 40, 4, 8, 37, 37, 0, // Skip to: 13525
/* 4016 */    MCD::OPC_Decode, 222, 6, 83, // Opcode: MOV32kp
/* 4020 */    MCD::OPC_FilterValue, 3, 28, 37, 0, // Skip to: 13525
/* 4025 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4028 */    MCD::OPC_FilterValue, 0, 177, 0, 0, // Skip to: 4210
/* 4033 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4036 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 4074
/* 4041 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 4044 */    MCD::OPC_FilterValue, 8, 4, 37, 0, // Skip to: 13525
/* 4049 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4052 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4061
/* 4057 */    MCD::OPC_Decode, 170, 6, 114, // Opcode: MOV32df
/* 4061 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4070
/* 4066 */    MCD::OPC_Decode, 141, 6, 56, // Opcode: MOV32af
/* 4070 */    MCD::OPC_Decode, 138, 7, 115, // Opcode: MOV32rf
/* 4074 */    MCD::OPC_FilterValue, 1, 230, 36, 0, // Skip to: 13525
/* 4079 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4082 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 4112
/* 4087 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4090 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4099
/* 4095 */    MCD::OPC_Decode, 167, 6, 116, // Opcode: MOV32db
/* 4099 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4108
/* 4104 */    MCD::OPC_Decode, 137, 6, 57, // Opcode: MOV32ab
/* 4108 */    MCD::OPC_Decode, 134, 7, 117, // Opcode: MOV32rb
/* 4112 */    MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 4142
/* 4117 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4120 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4129
/* 4125 */    MCD::OPC_Decode, 176, 6, 118, // Opcode: MOV32dq
/* 4129 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4138
/* 4134 */    MCD::OPC_Decode, 152, 6, 58, // Opcode: MOV32aq
/* 4138 */    MCD::OPC_Decode, 149, 7, 119, // Opcode: MOV32rq
/* 4142 */    MCD::OPC_FilterValue, 3, 33, 0, 0, // Skip to: 4180
/* 4147 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 4150 */    MCD::OPC_FilterValue, 8, 154, 36, 0, // Skip to: 13525
/* 4155 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4158 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4167
/* 4163 */    MCD::OPC_Decode, 173, 6, 120, // Opcode: MOV32dk
/* 4167 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4176
/* 4172 */    MCD::OPC_Decode, 146, 6, 59, // Opcode: MOV32ak
/* 4176 */    MCD::OPC_Decode, 143, 7, 121, // Opcode: MOV32rk
/* 4180 */    MCD::OPC_FilterValue, 4, 124, 36, 0, // Skip to: 13525
/* 4185 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4188 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4197
/* 4193 */    MCD::OPC_Decode, 171, 6, 116, // Opcode: MOV32di
/* 4197 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4206
/* 4202 */    MCD::OPC_Decode, 143, 6, 57, // Opcode: MOV32ai
/* 4206 */    MCD::OPC_Decode, 140, 7, 117, // Opcode: MOV32ri
/* 4210 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 4384
/* 4215 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4218 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 4258
/* 4223 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4226 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4242
/* 4231 */    MCD::OPC_CheckField, 24, 4, 8, 71, 36, 0, // Skip to: 13525
/* 4238 */    MCD::OPC_Decode, 205, 6, 56, // Opcode: MOV32jf
/* 4242 */    MCD::OPC_FilterValue, 1, 62, 36, 0, // Skip to: 13525
/* 4247 */    MCD::OPC_CheckField, 24, 4, 8, 55, 36, 0, // Skip to: 13525
/* 4254 */    MCD::OPC_Decode, 229, 6, 56, // Opcode: MOV32of
/* 4258 */    MCD::OPC_FilterValue, 1, 46, 36, 0, // Skip to: 13525
/* 4263 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4266 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 4292
/* 4271 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4274 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4283
/* 4279 */    MCD::OPC_Decode, 202, 6, 57, // Opcode: MOV32jb
/* 4283 */    MCD::OPC_FilterValue, 1, 21, 36, 0, // Skip to: 13525
/* 4288 */    MCD::OPC_Decode, 226, 6, 57, // Opcode: MOV32ob
/* 4292 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 4318
/* 4297 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4300 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4309
/* 4305 */    MCD::OPC_Decode, 211, 6, 58, // Opcode: MOV32jq
/* 4309 */    MCD::OPC_FilterValue, 1, 251, 35, 0, // Skip to: 13525
/* 4314 */    MCD::OPC_Decode, 235, 6, 58, // Opcode: MOV32oq
/* 4318 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 4358
/* 4323 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4326 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4342
/* 4331 */    MCD::OPC_CheckField, 24, 4, 8, 227, 35, 0, // Skip to: 13525
/* 4338 */    MCD::OPC_Decode, 208, 6, 59, // Opcode: MOV32jk
/* 4342 */    MCD::OPC_FilterValue, 1, 218, 35, 0, // Skip to: 13525
/* 4347 */    MCD::OPC_CheckField, 24, 4, 8, 211, 35, 0, // Skip to: 13525
/* 4354 */    MCD::OPC_Decode, 232, 6, 59, // Opcode: MOV32ok
/* 4358 */    MCD::OPC_FilterValue, 4, 202, 35, 0, // Skip to: 13525
/* 4363 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4366 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4375
/* 4371 */    MCD::OPC_Decode, 206, 6, 57, // Opcode: MOV32ji
/* 4375 */    MCD::OPC_FilterValue, 1, 185, 35, 0, // Skip to: 13525
/* 4380 */    MCD::OPC_Decode, 230, 6, 57, // Opcode: MOV32oi
/* 4384 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 4558
/* 4389 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4392 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 4432
/* 4397 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4400 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4416
/* 4405 */    MCD::OPC_CheckField, 24, 4, 8, 153, 35, 0, // Skip to: 13525
/* 4412 */    MCD::OPC_Decode, 181, 6, 56, // Opcode: MOV32ef
/* 4416 */    MCD::OPC_FilterValue, 1, 144, 35, 0, // Skip to: 13525
/* 4421 */    MCD::OPC_CheckField, 24, 4, 8, 137, 35, 0, // Skip to: 13525
/* 4428 */    MCD::OPC_Decode, 241, 6, 64, // Opcode: MOV32pf
/* 4432 */    MCD::OPC_FilterValue, 1, 128, 35, 0, // Skip to: 13525
/* 4437 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4440 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 4466
/* 4445 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4448 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4457
/* 4453 */    MCD::OPC_Decode, 178, 6, 57, // Opcode: MOV32eb
/* 4457 */    MCD::OPC_FilterValue, 1, 103, 35, 0, // Skip to: 13525
/* 4462 */    MCD::OPC_Decode, 238, 6, 65, // Opcode: MOV32pb
/* 4466 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 4492
/* 4471 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4474 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4483
/* 4479 */    MCD::OPC_Decode, 187, 6, 58, // Opcode: MOV32eq
/* 4483 */    MCD::OPC_FilterValue, 1, 77, 35, 0, // Skip to: 13525
/* 4488 */    MCD::OPC_Decode, 247, 6, 66, // Opcode: MOV32pq
/* 4492 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 4532
/* 4497 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4500 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4516
/* 4505 */    MCD::OPC_CheckField, 24, 4, 8, 53, 35, 0, // Skip to: 13525
/* 4512 */    MCD::OPC_Decode, 184, 6, 59, // Opcode: MOV32ek
/* 4516 */    MCD::OPC_FilterValue, 1, 44, 35, 0, // Skip to: 13525
/* 4521 */    MCD::OPC_CheckField, 24, 4, 8, 37, 35, 0, // Skip to: 13525
/* 4528 */    MCD::OPC_Decode, 244, 6, 67, // Opcode: MOV32pk
/* 4532 */    MCD::OPC_FilterValue, 4, 28, 35, 0, // Skip to: 13525
/* 4537 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4540 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4549
/* 4545 */    MCD::OPC_Decode, 182, 6, 57, // Opcode: MOV32ei
/* 4549 */    MCD::OPC_FilterValue, 1, 11, 35, 0, // Skip to: 13525
/* 4554 */    MCD::OPC_Decode, 242, 6, 65, // Opcode: MOV32pi
/* 4558 */    MCD::OPC_FilterValue, 3, 2, 35, 0, // Skip to: 13525
/* 4563 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4566 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 4660
/* 4571 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4574 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 4597
/* 4579 */    MCD::OPC_CheckField, 40, 4, 8, 235, 34, 0, // Skip to: 13525
/* 4586 */    MCD::OPC_CheckField, 24, 4, 8, 228, 34, 0, // Skip to: 13525
/* 4593 */    MCD::OPC_Decode, 193, 6, 72, // Opcode: MOV32ff
/* 4597 */    MCD::OPC_FilterValue, 1, 219, 34, 0, // Skip to: 13525
/* 4602 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4605 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 4621
/* 4610 */    MCD::OPC_CheckField, 24, 4, 8, 204, 34, 0, // Skip to: 13525
/* 4617 */    MCD::OPC_Decode, 159, 6, 84, // Opcode: MOV32bf
/* 4621 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 4637
/* 4626 */    MCD::OPC_CheckField, 24, 4, 8, 188, 34, 0, // Skip to: 13525
/* 4633 */    MCD::OPC_Decode, 253, 6, 85, // Opcode: MOV32qf
/* 4637 */    MCD::OPC_FilterValue, 3, 179, 34, 0, // Skip to: 13525
/* 4642 */    MCD::OPC_CheckField, 40, 4, 8, 172, 34, 0, // Skip to: 13525
/* 4649 */    MCD::OPC_CheckField, 24, 4, 8, 165, 34, 0, // Skip to: 13525
/* 4656 */    MCD::OPC_Decode, 217, 6, 86, // Opcode: MOV32kf
/* 4660 */    MCD::OPC_FilterValue, 1, 156, 34, 0, // Skip to: 13525
/* 4665 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4668 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 4734
/* 4673 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4676 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4692
/* 4681 */    MCD::OPC_CheckField, 56, 4, 8, 133, 34, 0, // Skip to: 13525
/* 4688 */    MCD::OPC_Decode, 190, 6, 73, // Opcode: MOV32fb
/* 4692 */    MCD::OPC_FilterValue, 1, 124, 34, 0, // Skip to: 13525
/* 4697 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4700 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4709
/* 4705 */    MCD::OPC_Decode, 156, 6, 87, // Opcode: MOV32bb
/* 4709 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4718
/* 4714 */    MCD::OPC_Decode, 250, 6, 88, // Opcode: MOV32qb
/* 4718 */    MCD::OPC_FilterValue, 3, 98, 34, 0, // Skip to: 13525
/* 4723 */    MCD::OPC_CheckField, 56, 4, 8, 91, 34, 0, // Skip to: 13525
/* 4730 */    MCD::OPC_Decode, 214, 6, 89, // Opcode: MOV32kb
/* 4734 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 4800
/* 4739 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4742 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4758
/* 4747 */    MCD::OPC_CheckField, 40, 4, 8, 67, 34, 0, // Skip to: 13525
/* 4754 */    MCD::OPC_Decode, 199, 6, 74, // Opcode: MOV32fq
/* 4758 */    MCD::OPC_FilterValue, 1, 58, 34, 0, // Skip to: 13525
/* 4763 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4766 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4775
/* 4771 */    MCD::OPC_Decode, 165, 6, 90, // Opcode: MOV32bq
/* 4775 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4784
/* 4780 */    MCD::OPC_Decode, 131, 7, 91, // Opcode: MOV32qq
/* 4784 */    MCD::OPC_FilterValue, 3, 32, 34, 0, // Skip to: 13525
/* 4789 */    MCD::OPC_CheckField, 40, 4, 8, 25, 34, 0, // Skip to: 13525
/* 4796 */    MCD::OPC_Decode, 223, 6, 92, // Opcode: MOV32kq
/* 4800 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 4894
/* 4805 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4808 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 4831
/* 4813 */    MCD::OPC_CheckField, 40, 4, 8, 1, 34, 0, // Skip to: 13525
/* 4820 */    MCD::OPC_CheckField, 24, 4, 8, 250, 33, 0, // Skip to: 13525
/* 4827 */    MCD::OPC_Decode, 196, 6, 75, // Opcode: MOV32fk
/* 4831 */    MCD::OPC_FilterValue, 1, 241, 33, 0, // Skip to: 13525
/* 4836 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4839 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 4855
/* 4844 */    MCD::OPC_CheckField, 24, 4, 8, 226, 33, 0, // Skip to: 13525
/* 4851 */    MCD::OPC_Decode, 162, 6, 93, // Opcode: MOV32bk
/* 4855 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 4871
/* 4860 */    MCD::OPC_CheckField, 24, 4, 8, 210, 33, 0, // Skip to: 13525
/* 4867 */    MCD::OPC_Decode, 128, 7, 94, // Opcode: MOV32qk
/* 4871 */    MCD::OPC_FilterValue, 3, 201, 33, 0, // Skip to: 13525
/* 4876 */    MCD::OPC_CheckField, 40, 4, 8, 194, 33, 0, // Skip to: 13525
/* 4883 */    MCD::OPC_CheckField, 24, 4, 8, 187, 33, 0, // Skip to: 13525
/* 4890 */    MCD::OPC_Decode, 220, 6, 95, // Opcode: MOV32kk
/* 4894 */    MCD::OPC_FilterValue, 4, 178, 33, 0, // Skip to: 13525
/* 4899 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4902 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4918
/* 4907 */    MCD::OPC_CheckField, 56, 4, 8, 163, 33, 0, // Skip to: 13525
/* 4914 */    MCD::OPC_Decode, 194, 6, 73, // Opcode: MOV32fi
/* 4918 */    MCD::OPC_FilterValue, 1, 154, 33, 0, // Skip to: 13525
/* 4923 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4926 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4935
/* 4931 */    MCD::OPC_Decode, 160, 6, 87, // Opcode: MOV32bi
/* 4935 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4944
/* 4940 */    MCD::OPC_Decode, 254, 6, 88, // Opcode: MOV32qi
/* 4944 */    MCD::OPC_FilterValue, 3, 128, 33, 0, // Skip to: 13525
/* 4949 */    MCD::OPC_CheckField, 56, 4, 8, 121, 33, 0, // Skip to: 13525
/* 4956 */    MCD::OPC_Decode, 218, 6, 89, // Opcode: MOV32ki
/* 4960 */    MCD::OPC_FilterValue, 3, 225, 7, 0, // Skip to: 6982
/* 4965 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 4968 */    MCD::OPC_FilterValue, 0, 114, 1, 0, // Skip to: 5343
/* 4973 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4976 */    MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 5035
/* 4981 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4984 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5000
/* 4989 */    MCD::OPC_CheckField, 6, 1, 0, 24, 0, 0, // Skip to: 5020
/* 4996 */    MCD::OPC_Decode, 145, 5, 122, // Opcode: MOV16dd
/* 5000 */    MCD::OPC_FilterValue, 1, 15, 0, 0, // Skip to: 5020
/* 5005 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 5016
/* 5012 */    MCD::OPC_Decode, 230, 4, 123, // Opcode: MOV16aa
/* 5016 */    MCD::OPC_Decode, 245, 5, 124, // Opcode: MOV16ra
/* 5020 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 5031
/* 5027 */    MCD::OPC_Decode, 248, 4, 125, // Opcode: MOV16ar
/* 5031 */    MCD::OPC_Decode, 135, 6, 126, // Opcode: MOV16rr
/* 5035 */    MCD::OPC_FilterValue, 1, 67, 0, 0, // Skip to: 5107
/* 5040 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5043 */    MCD::OPC_FilterValue, 0, 27, 0, 0, // Skip to: 5075
/* 5048 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5051 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5060
/* 5056 */    MCD::OPC_Decode, 183, 5, 127, // Opcode: MOV16jd
/* 5060 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5070
/* 5065 */    MCD::OPC_Decode, 180, 5, 128, 1, // Opcode: MOV16ja
/* 5070 */    MCD::OPC_Decode, 192, 5, 129, 1, // Opcode: MOV16jr
/* 5075 */    MCD::OPC_FilterValue, 1, 253, 32, 0, // Skip to: 13525
/* 5080 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5083 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5092
/* 5088 */    MCD::OPC_Decode, 209, 5, 127, // Opcode: MOV16od
/* 5092 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5102
/* 5097 */    MCD::OPC_Decode, 206, 5, 128, 1, // Opcode: MOV16oa
/* 5102 */    MCD::OPC_Decode, 218, 5, 129, 1, // Opcode: MOV16or
/* 5107 */    MCD::OPC_FilterValue, 2, 68, 0, 0, // Skip to: 5180
/* 5112 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5115 */    MCD::OPC_FilterValue, 0, 27, 0, 0, // Skip to: 5147
/* 5120 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5123 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5132
/* 5128 */    MCD::OPC_Decode, 157, 5, 127, // Opcode: MOV16ed
/* 5132 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5142
/* 5137 */    MCD::OPC_Decode, 154, 5, 128, 1, // Opcode: MOV16ea
/* 5142 */    MCD::OPC_Decode, 166, 5, 129, 1, // Opcode: MOV16er
/* 5147 */    MCD::OPC_FilterValue, 1, 181, 32, 0, // Skip to: 13525
/* 5152 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5155 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5165
/* 5160 */    MCD::OPC_Decode, 222, 5, 130, 1, // Opcode: MOV16pd
/* 5165 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5175
/* 5170 */    MCD::OPC_Decode, 219, 5, 131, 1, // Opcode: MOV16pa
/* 5175 */    MCD::OPC_Decode, 231, 5, 132, 1, // Opcode: MOV16pr
/* 5180 */    MCD::OPC_FilterValue, 3, 148, 32, 0, // Skip to: 13525
/* 5185 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5188 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 5229
/* 5193 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5196 */    MCD::OPC_FilterValue, 8, 132, 32, 0, // Skip to: 13525
/* 5201 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5204 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5214
/* 5209 */    MCD::OPC_Decode, 170, 5, 133, 1, // Opcode: MOV16fd
/* 5214 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5224
/* 5219 */    MCD::OPC_Decode, 167, 5, 134, 1, // Opcode: MOV16fa
/* 5224 */    MCD::OPC_Decode, 179, 5, 135, 1, // Opcode: MOV16fr
/* 5229 */    MCD::OPC_FilterValue, 1, 99, 32, 0, // Skip to: 13525
/* 5234 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5237 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 5270
/* 5242 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5245 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5255
/* 5250 */    MCD::OPC_Decode, 252, 4, 136, 1, // Opcode: MOV16bd
/* 5255 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5265
/* 5260 */    MCD::OPC_Decode, 249, 4, 137, 1, // Opcode: MOV16ba
/* 5265 */    MCD::OPC_Decode, 133, 5, 138, 1, // Opcode: MOV16br
/* 5270 */    MCD::OPC_FilterValue, 2, 27, 0, 0, // Skip to: 5302
/* 5275 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5278 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5287
/* 5283 */    MCD::OPC_Decode, 235, 5, 15, // Opcode: MOV16qd
/* 5287 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5297
/* 5292 */    MCD::OPC_Decode, 232, 5, 139, 1, // Opcode: MOV16qa
/* 5297 */    MCD::OPC_Decode, 244, 5, 140, 1, // Opcode: MOV16qr
/* 5302 */    MCD::OPC_FilterValue, 3, 26, 32, 0, // Skip to: 13525
/* 5307 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5310 */    MCD::OPC_FilterValue, 8, 18, 32, 0, // Skip to: 13525
/* 5315 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5318 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5328
/* 5323 */    MCD::OPC_Decode, 196, 5, 141, 1, // Opcode: MOV16kd
/* 5328 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5338
/* 5333 */    MCD::OPC_Decode, 193, 5, 142, 1, // Opcode: MOV16ka
/* 5338 */    MCD::OPC_Decode, 205, 5, 143, 1, // Opcode: MOV16kr
/* 5343 */    MCD::OPC_FilterValue, 1, 81, 1, 0, // Skip to: 5685
/* 5348 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 5351 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 5425
/* 5356 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5359 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 5392
/* 5364 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5367 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5377
/* 5372 */    MCD::OPC_Decode, 149, 5, 144, 1, // Opcode: MOV16dj
/* 5377 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5387
/* 5382 */    MCD::OPC_Decode, 238, 4, 145, 1, // Opcode: MOV16aj
/* 5387 */    MCD::OPC_Decode, 253, 5, 146, 1, // Opcode: MOV16rj
/* 5392 */    MCD::OPC_FilterValue, 1, 192, 31, 0, // Skip to: 13525
/* 5397 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5400 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5410
/* 5405 */    MCD::OPC_Decode, 151, 5, 144, 1, // Opcode: MOV16do
/* 5410 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5420
/* 5415 */    MCD::OPC_Decode, 242, 4, 145, 1, // Opcode: MOV16ao
/* 5420 */    MCD::OPC_Decode, 129, 6, 146, 1, // Opcode: MOV16ro
/* 5425 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 5485
/* 5430 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5433 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5459
/* 5438 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5441 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5450
/* 5446 */    MCD::OPC_Decode, 187, 5, 54, // Opcode: MOV16jj
/* 5450 */    MCD::OPC_FilterValue, 1, 134, 31, 0, // Skip to: 13525
/* 5455 */    MCD::OPC_Decode, 213, 5, 54, // Opcode: MOV16oj
/* 5459 */    MCD::OPC_FilterValue, 1, 125, 31, 0, // Skip to: 13525
/* 5464 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5467 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5476
/* 5472 */    MCD::OPC_Decode, 189, 5, 54, // Opcode: MOV16jo
/* 5476 */    MCD::OPC_FilterValue, 1, 108, 31, 0, // Skip to: 13525
/* 5481 */    MCD::OPC_Decode, 215, 5, 54, // Opcode: MOV16oo
/* 5485 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 5545
/* 5490 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5493 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5519
/* 5498 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5501 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5510
/* 5506 */    MCD::OPC_Decode, 161, 5, 54, // Opcode: MOV16ej
/* 5510 */    MCD::OPC_FilterValue, 1, 74, 31, 0, // Skip to: 13525
/* 5515 */    MCD::OPC_Decode, 226, 5, 62, // Opcode: MOV16pj
/* 5519 */    MCD::OPC_FilterValue, 1, 65, 31, 0, // Skip to: 13525
/* 5524 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5527 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5536
/* 5532 */    MCD::OPC_Decode, 163, 5, 54, // Opcode: MOV16eo
/* 5536 */    MCD::OPC_FilterValue, 1, 48, 31, 0, // Skip to: 13525
/* 5541 */    MCD::OPC_Decode, 228, 5, 62, // Opcode: MOV16po
/* 5545 */    MCD::OPC_FilterValue, 3, 39, 31, 0, // Skip to: 13525
/* 5550 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5553 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 5619
/* 5558 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5561 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5577
/* 5566 */    MCD::OPC_CheckField, 24, 4, 8, 16, 31, 0, // Skip to: 13525
/* 5573 */    MCD::OPC_Decode, 174, 5, 70, // Opcode: MOV16fj
/* 5577 */    MCD::OPC_FilterValue, 1, 7, 31, 0, // Skip to: 13525
/* 5582 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5585 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5594
/* 5590 */    MCD::OPC_Decode, 128, 5, 28, // Opcode: MOV16bj
/* 5594 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5603
/* 5599 */    MCD::OPC_Decode, 239, 5, 17, // Opcode: MOV16qj
/* 5603 */    MCD::OPC_FilterValue, 3, 237, 30, 0, // Skip to: 13525
/* 5608 */    MCD::OPC_CheckField, 24, 4, 8, 230, 30, 0, // Skip to: 13525
/* 5615 */    MCD::OPC_Decode, 200, 5, 80, // Opcode: MOV16kj
/* 5619 */    MCD::OPC_FilterValue, 1, 221, 30, 0, // Skip to: 13525
/* 5624 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5627 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5643
/* 5632 */    MCD::OPC_CheckField, 24, 4, 8, 206, 30, 0, // Skip to: 13525
/* 5639 */    MCD::OPC_Decode, 176, 5, 70, // Opcode: MOV16fo
/* 5643 */    MCD::OPC_FilterValue, 1, 197, 30, 0, // Skip to: 13525
/* 5648 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5651 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5660
/* 5656 */    MCD::OPC_Decode, 130, 5, 28, // Opcode: MOV16bo
/* 5660 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5669
/* 5665 */    MCD::OPC_Decode, 241, 5, 17, // Opcode: MOV16qo
/* 5669 */    MCD::OPC_FilterValue, 3, 171, 30, 0, // Skip to: 13525
/* 5674 */    MCD::OPC_CheckField, 24, 4, 8, 164, 30, 0, // Skip to: 13525
/* 5681 */    MCD::OPC_Decode, 202, 5, 80, // Opcode: MOV16ko
/* 5685 */    MCD::OPC_FilterValue, 2, 81, 1, 0, // Skip to: 6027
/* 5690 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 5693 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 5767
/* 5698 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5701 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 5734
/* 5706 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5709 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5719
/* 5714 */    MCD::OPC_Decode, 146, 5, 144, 1, // Opcode: MOV16de
/* 5719 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5729
/* 5724 */    MCD::OPC_Decode, 233, 4, 145, 1, // Opcode: MOV16ae
/* 5729 */    MCD::OPC_Decode, 248, 5, 146, 1, // Opcode: MOV16re
/* 5734 */    MCD::OPC_FilterValue, 1, 106, 30, 0, // Skip to: 13525
/* 5739 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5742 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5752
/* 5747 */    MCD::OPC_Decode, 152, 5, 147, 1, // Opcode: MOV16dp
/* 5752 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5762
/* 5757 */    MCD::OPC_Decode, 244, 4, 148, 1, // Opcode: MOV16ap
/* 5762 */    MCD::OPC_Decode, 131, 6, 149, 1, // Opcode: MOV16rp
/* 5767 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 5827
/* 5772 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5775 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5801
/* 5780 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5783 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5792
/* 5788 */    MCD::OPC_Decode, 184, 5, 54, // Opcode: MOV16je
/* 5792 */    MCD::OPC_FilterValue, 1, 48, 30, 0, // Skip to: 13525
/* 5797 */    MCD::OPC_Decode, 210, 5, 54, // Opcode: MOV16oe
/* 5801 */    MCD::OPC_FilterValue, 1, 39, 30, 0, // Skip to: 13525
/* 5806 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5809 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5818
/* 5814 */    MCD::OPC_Decode, 190, 5, 55, // Opcode: MOV16jp
/* 5818 */    MCD::OPC_FilterValue, 1, 22, 30, 0, // Skip to: 13525
/* 5823 */    MCD::OPC_Decode, 216, 5, 55, // Opcode: MOV16op
/* 5827 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 5887
/* 5832 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5835 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5861
/* 5840 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5843 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5852
/* 5848 */    MCD::OPC_Decode, 158, 5, 54, // Opcode: MOV16ee
/* 5852 */    MCD::OPC_FilterValue, 1, 244, 29, 0, // Skip to: 13525
/* 5857 */    MCD::OPC_Decode, 223, 5, 62, // Opcode: MOV16pe
/* 5861 */    MCD::OPC_FilterValue, 1, 235, 29, 0, // Skip to: 13525
/* 5866 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5869 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5878
/* 5874 */    MCD::OPC_Decode, 164, 5, 55, // Opcode: MOV16ep
/* 5878 */    MCD::OPC_FilterValue, 1, 218, 29, 0, // Skip to: 13525
/* 5883 */    MCD::OPC_Decode, 229, 5, 63, // Opcode: MOV16pp
/* 5887 */    MCD::OPC_FilterValue, 3, 209, 29, 0, // Skip to: 13525
/* 5892 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5895 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 5961
/* 5900 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5903 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5919
/* 5908 */    MCD::OPC_CheckField, 24, 4, 8, 186, 29, 0, // Skip to: 13525
/* 5915 */    MCD::OPC_Decode, 171, 5, 70, // Opcode: MOV16fe
/* 5919 */    MCD::OPC_FilterValue, 1, 177, 29, 0, // Skip to: 13525
/* 5924 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5927 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5936
/* 5932 */    MCD::OPC_Decode, 253, 4, 28, // Opcode: MOV16be
/* 5936 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5945
/* 5941 */    MCD::OPC_Decode, 236, 5, 17, // Opcode: MOV16qe
/* 5945 */    MCD::OPC_FilterValue, 3, 151, 29, 0, // Skip to: 13525
/* 5950 */    MCD::OPC_CheckField, 24, 4, 8, 144, 29, 0, // Skip to: 13525
/* 5957 */    MCD::OPC_Decode, 197, 5, 80, // Opcode: MOV16ke
/* 5961 */    MCD::OPC_FilterValue, 1, 135, 29, 0, // Skip to: 13525
/* 5966 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5969 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5985
/* 5974 */    MCD::OPC_CheckField, 40, 4, 8, 120, 29, 0, // Skip to: 13525
/* 5981 */    MCD::OPC_Decode, 177, 5, 71, // Opcode: MOV16fp
/* 5985 */    MCD::OPC_FilterValue, 1, 111, 29, 0, // Skip to: 13525
/* 5990 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5993 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6002
/* 5998 */    MCD::OPC_Decode, 131, 5, 81, // Opcode: MOV16bp
/* 6002 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6011
/* 6007 */    MCD::OPC_Decode, 242, 5, 82, // Opcode: MOV16qp
/* 6011 */    MCD::OPC_FilterValue, 3, 85, 29, 0, // Skip to: 13525
/* 6016 */    MCD::OPC_CheckField, 40, 4, 8, 78, 29, 0, // Skip to: 13525
/* 6023 */    MCD::OPC_Decode, 203, 5, 83, // Opcode: MOV16kp
/* 6027 */    MCD::OPC_FilterValue, 3, 69, 29, 0, // Skip to: 13525
/* 6032 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 6035 */    MCD::OPC_FilterValue, 0, 192, 0, 0, // Skip to: 6232
/* 6040 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6043 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 6084
/* 6048 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 6051 */    MCD::OPC_FilterValue, 8, 45, 29, 0, // Skip to: 13525
/* 6056 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6059 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6069
/* 6064 */    MCD::OPC_Decode, 147, 5, 150, 1, // Opcode: MOV16df
/* 6069 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6079
/* 6074 */    MCD::OPC_Decode, 235, 4, 151, 1, // Opcode: MOV16af
/* 6079 */    MCD::OPC_Decode, 250, 5, 152, 1, // Opcode: MOV16rf
/* 6084 */    MCD::OPC_FilterValue, 1, 12, 29, 0, // Skip to: 13525
/* 6089 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6092 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 6125
/* 6097 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6100 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6110
/* 6105 */    MCD::OPC_Decode, 143, 5, 153, 1, // Opcode: MOV16db
/* 6110 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6120
/* 6115 */    MCD::OPC_Decode, 231, 4, 154, 1, // Opcode: MOV16ab
/* 6120 */    MCD::OPC_Decode, 246, 5, 155, 1, // Opcode: MOV16rb
/* 6125 */    MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 6158
/* 6130 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6133 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6143
/* 6138 */    MCD::OPC_Decode, 153, 5, 156, 1, // Opcode: MOV16dq
/* 6143 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6153
/* 6148 */    MCD::OPC_Decode, 246, 4, 157, 1, // Opcode: MOV16aq
/* 6153 */    MCD::OPC_Decode, 133, 6, 158, 1, // Opcode: MOV16rq
/* 6158 */    MCD::OPC_FilterValue, 3, 36, 0, 0, // Skip to: 6199
/* 6163 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 6166 */    MCD::OPC_FilterValue, 8, 186, 28, 0, // Skip to: 13525
/* 6171 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6174 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6184
/* 6179 */    MCD::OPC_Decode, 150, 5, 159, 1, // Opcode: MOV16dk
/* 6184 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6194
/* 6189 */    MCD::OPC_Decode, 240, 4, 160, 1, // Opcode: MOV16ak
/* 6194 */    MCD::OPC_Decode, 255, 5, 161, 1, // Opcode: MOV16rk
/* 6199 */    MCD::OPC_FilterValue, 4, 153, 28, 0, // Skip to: 13525
/* 6204 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6207 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6217
/* 6212 */    MCD::OPC_Decode, 148, 5, 156, 1, // Opcode: MOV16di
/* 6217 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6227
/* 6222 */    MCD::OPC_Decode, 237, 4, 157, 1, // Opcode: MOV16ai
/* 6227 */    MCD::OPC_Decode, 252, 5, 158, 1, // Opcode: MOV16ri
/* 6232 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 6406
/* 6237 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6240 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 6280
/* 6245 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6248 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6264
/* 6253 */    MCD::OPC_CheckField, 24, 4, 8, 97, 28, 0, // Skip to: 13525
/* 6260 */    MCD::OPC_Decode, 185, 5, 56, // Opcode: MOV16jf
/* 6264 */    MCD::OPC_FilterValue, 1, 88, 28, 0, // Skip to: 13525
/* 6269 */    MCD::OPC_CheckField, 24, 4, 8, 81, 28, 0, // Skip to: 13525
/* 6276 */    MCD::OPC_Decode, 211, 5, 56, // Opcode: MOV16of
/* 6280 */    MCD::OPC_FilterValue, 1, 72, 28, 0, // Skip to: 13525
/* 6285 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6288 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 6314
/* 6293 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6296 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6305
/* 6301 */    MCD::OPC_Decode, 181, 5, 57, // Opcode: MOV16jb
/* 6305 */    MCD::OPC_FilterValue, 1, 47, 28, 0, // Skip to: 13525
/* 6310 */    MCD::OPC_Decode, 207, 5, 57, // Opcode: MOV16ob
/* 6314 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 6340
/* 6319 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6322 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6331
/* 6327 */    MCD::OPC_Decode, 191, 5, 58, // Opcode: MOV16jq
/* 6331 */    MCD::OPC_FilterValue, 1, 21, 28, 0, // Skip to: 13525
/* 6336 */    MCD::OPC_Decode, 217, 5, 58, // Opcode: MOV16oq
/* 6340 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 6380
/* 6345 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6348 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6364
/* 6353 */    MCD::OPC_CheckField, 24, 4, 8, 253, 27, 0, // Skip to: 13525
/* 6360 */    MCD::OPC_Decode, 188, 5, 59, // Opcode: MOV16jk
/* 6364 */    MCD::OPC_FilterValue, 1, 244, 27, 0, // Skip to: 13525
/* 6369 */    MCD::OPC_CheckField, 24, 4, 8, 237, 27, 0, // Skip to: 13525
/* 6376 */    MCD::OPC_Decode, 214, 5, 59, // Opcode: MOV16ok
/* 6380 */    MCD::OPC_FilterValue, 4, 228, 27, 0, // Skip to: 13525
/* 6385 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6388 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6397
/* 6393 */    MCD::OPC_Decode, 186, 5, 58, // Opcode: MOV16ji
/* 6397 */    MCD::OPC_FilterValue, 1, 211, 27, 0, // Skip to: 13525
/* 6402 */    MCD::OPC_Decode, 212, 5, 58, // Opcode: MOV16oi
/* 6406 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 6580
/* 6411 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6414 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 6454
/* 6419 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6422 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6438
/* 6427 */    MCD::OPC_CheckField, 24, 4, 8, 179, 27, 0, // Skip to: 13525
/* 6434 */    MCD::OPC_Decode, 159, 5, 56, // Opcode: MOV16ef
/* 6438 */    MCD::OPC_FilterValue, 1, 170, 27, 0, // Skip to: 13525
/* 6443 */    MCD::OPC_CheckField, 24, 4, 8, 163, 27, 0, // Skip to: 13525
/* 6450 */    MCD::OPC_Decode, 224, 5, 64, // Opcode: MOV16pf
/* 6454 */    MCD::OPC_FilterValue, 1, 154, 27, 0, // Skip to: 13525
/* 6459 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6462 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 6488
/* 6467 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6470 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6479
/* 6475 */    MCD::OPC_Decode, 155, 5, 57, // Opcode: MOV16eb
/* 6479 */    MCD::OPC_FilterValue, 1, 129, 27, 0, // Skip to: 13525
/* 6484 */    MCD::OPC_Decode, 220, 5, 65, // Opcode: MOV16pb
/* 6488 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 6514
/* 6493 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6496 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6505
/* 6501 */    MCD::OPC_Decode, 165, 5, 58, // Opcode: MOV16eq
/* 6505 */    MCD::OPC_FilterValue, 1, 103, 27, 0, // Skip to: 13525
/* 6510 */    MCD::OPC_Decode, 230, 5, 66, // Opcode: MOV16pq
/* 6514 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 6554
/* 6519 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6522 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6538
/* 6527 */    MCD::OPC_CheckField, 24, 4, 8, 79, 27, 0, // Skip to: 13525
/* 6534 */    MCD::OPC_Decode, 162, 5, 59, // Opcode: MOV16ek
/* 6538 */    MCD::OPC_FilterValue, 1, 70, 27, 0, // Skip to: 13525
/* 6543 */    MCD::OPC_CheckField, 24, 4, 8, 63, 27, 0, // Skip to: 13525
/* 6550 */    MCD::OPC_Decode, 227, 5, 67, // Opcode: MOV16pk
/* 6554 */    MCD::OPC_FilterValue, 4, 54, 27, 0, // Skip to: 13525
/* 6559 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6562 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6571
/* 6567 */    MCD::OPC_Decode, 160, 5, 58, // Opcode: MOV16ei
/* 6571 */    MCD::OPC_FilterValue, 1, 37, 27, 0, // Skip to: 13525
/* 6576 */    MCD::OPC_Decode, 225, 5, 66, // Opcode: MOV16pi
/* 6580 */    MCD::OPC_FilterValue, 3, 28, 27, 0, // Skip to: 13525
/* 6585 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6588 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 6682
/* 6593 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6596 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 6619
/* 6601 */    MCD::OPC_CheckField, 40, 4, 8, 5, 27, 0, // Skip to: 13525
/* 6608 */    MCD::OPC_CheckField, 24, 4, 8, 254, 26, 0, // Skip to: 13525
/* 6615 */    MCD::OPC_Decode, 172, 5, 72, // Opcode: MOV16ff
/* 6619 */    MCD::OPC_FilterValue, 1, 245, 26, 0, // Skip to: 13525
/* 6624 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6627 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 6643
/* 6632 */    MCD::OPC_CheckField, 24, 4, 8, 230, 26, 0, // Skip to: 13525
/* 6639 */    MCD::OPC_Decode, 254, 4, 84, // Opcode: MOV16bf
/* 6643 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 6659
/* 6648 */    MCD::OPC_CheckField, 24, 4, 8, 214, 26, 0, // Skip to: 13525
/* 6655 */    MCD::OPC_Decode, 237, 5, 85, // Opcode: MOV16qf
/* 6659 */    MCD::OPC_FilterValue, 3, 205, 26, 0, // Skip to: 13525
/* 6664 */    MCD::OPC_CheckField, 40, 4, 8, 198, 26, 0, // Skip to: 13525
/* 6671 */    MCD::OPC_CheckField, 24, 4, 8, 191, 26, 0, // Skip to: 13525
/* 6678 */    MCD::OPC_Decode, 198, 5, 86, // Opcode: MOV16kf
/* 6682 */    MCD::OPC_FilterValue, 1, 182, 26, 0, // Skip to: 13525
/* 6687 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6690 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 6756
/* 6695 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6698 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6714
/* 6703 */    MCD::OPC_CheckField, 56, 4, 8, 159, 26, 0, // Skip to: 13525
/* 6710 */    MCD::OPC_Decode, 168, 5, 73, // Opcode: MOV16fb
/* 6714 */    MCD::OPC_FilterValue, 1, 150, 26, 0, // Skip to: 13525
/* 6719 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6722 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6731
/* 6727 */    MCD::OPC_Decode, 250, 4, 87, // Opcode: MOV16bb
/* 6731 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6740
/* 6736 */    MCD::OPC_Decode, 233, 5, 88, // Opcode: MOV16qb
/* 6740 */    MCD::OPC_FilterValue, 3, 124, 26, 0, // Skip to: 13525
/* 6745 */    MCD::OPC_CheckField, 56, 4, 8, 117, 26, 0, // Skip to: 13525
/* 6752 */    MCD::OPC_Decode, 194, 5, 89, // Opcode: MOV16kb
/* 6756 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 6822
/* 6761 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6764 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6780
/* 6769 */    MCD::OPC_CheckField, 40, 4, 8, 93, 26, 0, // Skip to: 13525
/* 6776 */    MCD::OPC_Decode, 178, 5, 74, // Opcode: MOV16fq
/* 6780 */    MCD::OPC_FilterValue, 1, 84, 26, 0, // Skip to: 13525
/* 6785 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6788 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6797
/* 6793 */    MCD::OPC_Decode, 132, 5, 90, // Opcode: MOV16bq
/* 6797 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6806
/* 6802 */    MCD::OPC_Decode, 243, 5, 91, // Opcode: MOV16qq
/* 6806 */    MCD::OPC_FilterValue, 3, 58, 26, 0, // Skip to: 13525
/* 6811 */    MCD::OPC_CheckField, 40, 4, 8, 51, 26, 0, // Skip to: 13525
/* 6818 */    MCD::OPC_Decode, 204, 5, 92, // Opcode: MOV16kq
/* 6822 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 6916
/* 6827 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6830 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 6853
/* 6835 */    MCD::OPC_CheckField, 40, 4, 8, 27, 26, 0, // Skip to: 13525
/* 6842 */    MCD::OPC_CheckField, 24, 4, 8, 20, 26, 0, // Skip to: 13525
/* 6849 */    MCD::OPC_Decode, 175, 5, 75, // Opcode: MOV16fk
/* 6853 */    MCD::OPC_FilterValue, 1, 11, 26, 0, // Skip to: 13525
/* 6858 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6861 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 6877
/* 6866 */    MCD::OPC_CheckField, 24, 4, 8, 252, 25, 0, // Skip to: 13525
/* 6873 */    MCD::OPC_Decode, 129, 5, 93, // Opcode: MOV16bk
/* 6877 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 6893
/* 6882 */    MCD::OPC_CheckField, 24, 4, 8, 236, 25, 0, // Skip to: 13525
/* 6889 */    MCD::OPC_Decode, 240, 5, 94, // Opcode: MOV16qk
/* 6893 */    MCD::OPC_FilterValue, 3, 227, 25, 0, // Skip to: 13525
/* 6898 */    MCD::OPC_CheckField, 40, 4, 8, 220, 25, 0, // Skip to: 13525
/* 6905 */    MCD::OPC_CheckField, 24, 4, 8, 213, 25, 0, // Skip to: 13525
/* 6912 */    MCD::OPC_Decode, 201, 5, 95, // Opcode: MOV16kk
/* 6916 */    MCD::OPC_FilterValue, 4, 204, 25, 0, // Skip to: 13525
/* 6921 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6924 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6940
/* 6929 */    MCD::OPC_CheckField, 40, 4, 8, 189, 25, 0, // Skip to: 13525
/* 6936 */    MCD::OPC_Decode, 173, 5, 74, // Opcode: MOV16fi
/* 6940 */    MCD::OPC_FilterValue, 1, 180, 25, 0, // Skip to: 13525
/* 6945 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6948 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6957
/* 6953 */    MCD::OPC_Decode, 255, 4, 90, // Opcode: MOV16bi
/* 6957 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6966
/* 6962 */    MCD::OPC_Decode, 238, 5, 91, // Opcode: MOV16qi
/* 6966 */    MCD::OPC_FilterValue, 3, 154, 25, 0, // Skip to: 13525
/* 6971 */    MCD::OPC_CheckField, 40, 4, 8, 147, 25, 0, // Skip to: 13525
/* 6978 */    MCD::OPC_Decode, 199, 5, 92, // Opcode: MOV16ki
/* 6982 */    MCD::OPC_FilterValue, 4, 137, 5, 0, // Skip to: 8404
/* 6987 */    MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 6990 */    MCD::OPC_FilterValue, 0, 97, 0, 0, // Skip to: 7092
/* 6995 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6998 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7008
/* 7003 */    MCD::OPC_Decode, 151, 8, 162, 1, // Opcode: NEGX8d
/* 7008 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7018
/* 7013 */    MCD::OPC_Decode, 148, 8, 162, 1, // Opcode: NEG8d
/* 7018 */    MCD::OPC_FilterValue, 4, 12, 0, 0, // Skip to: 7035
/* 7023 */    MCD::OPC_CheckField, 3, 1, 1, 95, 25, 0, // Skip to: 13525
/* 7030 */    MCD::OPC_Decode, 223, 4, 163, 1, // Opcode: LINK32
/* 7035 */    MCD::OPC_FilterValue, 6, 85, 25, 0, // Skip to: 13525
/* 7040 */    MCD::OPC_ExtractField, 16, 12,  // Inst{27-16} ...
/* 7043 */    MCD::OPC_FilterValue, 0, 19, 0, 0, // Skip to: 7067
/* 7048 */    MCD::OPC_CheckField, 31, 1, 0, 70, 25, 0, // Skip to: 13525
/* 7055 */    MCD::OPC_CheckField, 3, 1, 0, 63, 25, 0, // Skip to: 13525
/* 7062 */    MCD::OPC_Decode, 197, 9, 164, 1, // Opcode: UMULd32d32
/* 7067 */    MCD::OPC_FilterValue, 128, 16, 52, 25, 0, // Skip to: 13525
/* 7073 */    MCD::OPC_CheckField, 31, 1, 0, 45, 25, 0, // Skip to: 13525
/* 7080 */    MCD::OPC_CheckField, 3, 1, 0, 38, 25, 0, // Skip to: 13525
/* 7087 */    MCD::OPC_Decode, 137, 9, 164, 1, // Opcode: SMULd32d32
/* 7092 */    MCD::OPC_FilterValue, 4, 107, 0, 0, // Skip to: 7204
/* 7097 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7100 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7110
/* 7105 */    MCD::OPC_Decode, 149, 8, 165, 1, // Opcode: NEGX16d
/* 7110 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7120
/* 7115 */    MCD::OPC_Decode, 146, 8, 165, 1, // Opcode: NEG16d
/* 7120 */    MCD::OPC_FilterValue, 4, 12, 0, 0, // Skip to: 7137
/* 7125 */    MCD::OPC_CheckField, 3, 1, 1, 249, 24, 0, // Skip to: 13525
/* 7132 */    MCD::OPC_Decode, 182, 3, 166, 1, // Opcode: BKPT
/* 7137 */    MCD::OPC_FilterValue, 6, 52, 0, 0, // Skip to: 7194
/* 7142 */    MCD::OPC_ExtractField, 16, 12,  // Inst{27-16} ...
/* 7145 */    MCD::OPC_FilterValue, 0, 19, 0, 0, // Skip to: 7169
/* 7150 */    MCD::OPC_CheckField, 31, 1, 0, 224, 24, 0, // Skip to: 13525
/* 7157 */    MCD::OPC_CheckField, 3, 1, 0, 217, 24, 0, // Skip to: 13525
/* 7164 */    MCD::OPC_Decode, 194, 9, 164, 1, // Opcode: UDIVd32d32
/* 7169 */    MCD::OPC_FilterValue, 128, 16, 206, 24, 0, // Skip to: 13525
/* 7175 */    MCD::OPC_CheckField, 31, 1, 0, 199, 24, 0, // Skip to: 13525
/* 7182 */    MCD::OPC_CheckField, 3, 1, 0, 192, 24, 0, // Skip to: 13525
/* 7189 */    MCD::OPC_Decode, 208, 8, 164, 1, // Opcode: SDIVd32d32
/* 7194 */    MCD::OPC_FilterValue, 7, 182, 24, 0, // Skip to: 13525
/* 7199 */    MCD::OPC_Decode, 191, 9, 167, 1, // Opcode: TRAP
/* 7204 */    MCD::OPC_FilterValue, 5, 37, 0, 0, // Skip to: 7246
/* 7209 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7212 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 7229
/* 7217 */    MCD::OPC_CheckField, 9, 3, 7, 157, 24, 0, // Skip to: 13525
/* 7224 */    MCD::OPC_Decode, 222, 4, 168, 1, // Opcode: LINK16
/* 7229 */    MCD::OPC_FilterValue, 1, 147, 24, 0, // Skip to: 13525
/* 7234 */    MCD::OPC_CheckField, 9, 3, 7, 140, 24, 0, // Skip to: 13525
/* 7241 */    MCD::OPC_Decode, 199, 9, 169, 1, // Opcode: UNLK
/* 7246 */    MCD::OPC_FilterValue, 7, 54, 0, 0, // Skip to: 7305
/* 7251 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 7254 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 7271
/* 7259 */    MCD::OPC_CheckField, 9, 3, 7, 115, 24, 0, // Skip to: 13525
/* 7266 */    MCD::OPC_Decode, 152, 8, 170, 1, // Opcode: NOP
/* 7271 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 7288
/* 7276 */    MCD::OPC_CheckField, 9, 3, 7, 98, 24, 0, // Skip to: 13525
/* 7283 */    MCD::OPC_Decode, 206, 8, 170, 1, // Opcode: RTS
/* 7288 */    MCD::OPC_FilterValue, 6, 88, 24, 0, // Skip to: 13525
/* 7293 */    MCD::OPC_CheckField, 9, 3, 7, 81, 24, 0, // Skip to: 13525
/* 7300 */    MCD::OPC_Decode, 192, 9, 170, 1, // Opcode: TRAPV
/* 7305 */    MCD::OPC_FilterValue, 8, 40, 0, 0, // Skip to: 7350
/* 7310 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7313 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7323
/* 7318 */    MCD::OPC_Decode, 150, 8, 171, 1, // Opcode: NEGX32d
/* 7323 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7333
/* 7328 */    MCD::OPC_Decode, 147, 8, 171, 1, // Opcode: NEG32d
/* 7333 */    MCD::OPC_FilterValue, 4, 43, 24, 0, // Skip to: 13525
/* 7338 */    MCD::OPC_CheckField, 3, 1, 0, 36, 24, 0, // Skip to: 13525
/* 7345 */    MCD::OPC_Decode, 150, 4, 172, 1, // Opcode: EXT16
/* 7350 */    MCD::OPC_FilterValue, 9, 72, 0, 0, // Skip to: 7427
/* 7355 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7358 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 7384
/* 7363 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7366 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7375
/* 7371 */    MCD::OPC_Decode, 245, 7, 16, // Opcode: MOVM16jm
/* 7375 */    MCD::OPC_FilterValue, 1, 1, 24, 0, // Skip to: 13525
/* 7380 */    MCD::OPC_Decode, 255, 7, 16, // Opcode: MOVM16om
/* 7384 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 7410
/* 7389 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7392 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7401
/* 7397 */    MCD::OPC_Decode, 250, 7, 17, // Opcode: MOVM16mj
/* 7401 */    MCD::OPC_FilterValue, 1, 231, 23, 0, // Skip to: 13525
/* 7406 */    MCD::OPC_Decode, 252, 7, 17, // Opcode: MOVM16mo
/* 7410 */    MCD::OPC_FilterValue, 7, 222, 23, 0, // Skip to: 13525
/* 7415 */    MCD::OPC_CheckField, 3, 1, 0, 215, 23, 0, // Skip to: 13525
/* 7422 */    MCD::OPC_Decode, 233, 3, 169, 1, // Opcode: CALLj
/* 7427 */    MCD::OPC_FilterValue, 10, 55, 0, 0, // Skip to: 7487
/* 7432 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7435 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 7461
/* 7440 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7443 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7452
/* 7448 */    MCD::OPC_Decode, 243, 7, 16, // Opcode: MOVM16em
/* 7452 */    MCD::OPC_FilterValue, 6, 180, 23, 0, // Skip to: 13525
/* 7457 */    MCD::OPC_Decode, 248, 7, 17, // Opcode: MOVM16me
/* 7461 */    MCD::OPC_FilterValue, 1, 171, 23, 0, // Skip to: 13525
/* 7466 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7469 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7478
/* 7474 */    MCD::OPC_Decode, 128, 8, 18, // Opcode: MOVM16pm
/* 7478 */    MCD::OPC_FilterValue, 6, 154, 23, 0, // Skip to: 13525
/* 7483 */    MCD::OPC_Decode, 253, 7, 19, // Opcode: MOVM16mp
/* 7487 */    MCD::OPC_FilterValue, 11, 180, 0, 0, // Skip to: 7672
/* 7492 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7495 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 7561
/* 7500 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7503 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7519
/* 7508 */    MCD::OPC_CheckField, 40, 4, 8, 122, 23, 0, // Skip to: 13525
/* 7515 */    MCD::OPC_Decode, 244, 7, 20, // Opcode: MOVM16fm
/* 7519 */    MCD::OPC_FilterValue, 1, 113, 23, 0, // Skip to: 13525
/* 7524 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7527 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7536
/* 7532 */    MCD::OPC_Decode, 242, 7, 90, // Opcode: MOVM16bm
/* 7536 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7545
/* 7541 */    MCD::OPC_Decode, 129, 8, 91, // Opcode: MOVM16qm
/* 7545 */    MCD::OPC_FilterValue, 3, 87, 23, 0, // Skip to: 13525
/* 7550 */    MCD::OPC_CheckField, 40, 4, 8, 80, 23, 0, // Skip to: 13525
/* 7557 */    MCD::OPC_Decode, 246, 7, 92, // Opcode: MOVM16km
/* 7561 */    MCD::OPC_FilterValue, 6, 61, 0, 0, // Skip to: 7627
/* 7566 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7569 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7585
/* 7574 */    MCD::OPC_CheckField, 40, 4, 8, 56, 23, 0, // Skip to: 13525
/* 7581 */    MCD::OPC_Decode, 249, 7, 21, // Opcode: MOVM16mf
/* 7585 */    MCD::OPC_FilterValue, 1, 47, 23, 0, // Skip to: 13525
/* 7590 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7593 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7602
/* 7598 */    MCD::OPC_Decode, 247, 7, 22, // Opcode: MOVM16mb
/* 7602 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7611
/* 7607 */    MCD::OPC_Decode, 254, 7, 23, // Opcode: MOVM16mq
/* 7611 */    MCD::OPC_FilterValue, 3, 21, 23, 0, // Skip to: 13525
/* 7616 */    MCD::OPC_CheckField, 40, 4, 8, 14, 23, 0, // Skip to: 13525
/* 7623 */    MCD::OPC_Decode, 251, 7, 24, // Opcode: MOVM16mk
/* 7627 */    MCD::OPC_FilterValue, 7, 5, 23, 0, // Skip to: 13525
/* 7632 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 7635 */    MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 7645
/* 7640 */    MCD::OPC_Decode, 232, 3, 173, 1, // Opcode: CALLb
/* 7645 */    MCD::OPC_FilterValue, 10, 5, 0, 0, // Skip to: 7655
/* 7650 */    MCD::OPC_Decode, 235, 3, 174, 1, // Opcode: CALLq
/* 7655 */    MCD::OPC_FilterValue, 11, 233, 22, 0, // Skip to: 13525
/* 7660 */    MCD::OPC_CheckField, 24, 4, 8, 226, 22, 0, // Skip to: 13525
/* 7667 */    MCD::OPC_Decode, 234, 3, 175, 1, // Opcode: CALLk
/* 7672 */    MCD::OPC_FilterValue, 12, 59, 0, 0, // Skip to: 7736
/* 7677 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7680 */    MCD::OPC_FilterValue, 1, 17, 0, 0, // Skip to: 7702
/* 7685 */    MCD::OPC_CheckPredicate, 1, 203, 22, 0, // Skip to: 13525
/* 7690 */    MCD::OPC_CheckField, 3, 1, 0, 196, 22, 0, // Skip to: 13525
/* 7697 */    MCD::OPC_Decode, 144, 5, 176, 1, // Opcode: MOV16dc
/* 7702 */    MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 7719
/* 7707 */    MCD::OPC_CheckField, 3, 1, 0, 179, 22, 0, // Skip to: 13525
/* 7714 */    MCD::OPC_Decode, 135, 5, 177, 1, // Opcode: MOV16cd
/* 7719 */    MCD::OPC_FilterValue, 4, 169, 22, 0, // Skip to: 13525
/* 7724 */    MCD::OPC_CheckField, 3, 1, 0, 162, 22, 0, // Skip to: 13525
/* 7731 */    MCD::OPC_Decode, 151, 4, 178, 1, // Opcode: EXT32
/* 7736 */    MCD::OPC_FilterValue, 13, 138, 0, 0, // Skip to: 7879
/* 7741 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7744 */    MCD::OPC_FilterValue, 1, 33, 0, 0, // Skip to: 7782
/* 7749 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7752 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 7767
/* 7757 */    MCD::OPC_CheckPredicate, 1, 131, 22, 0, // Skip to: 13525
/* 7762 */    MCD::OPC_Decode, 182, 5, 179, 1, // Opcode: MOV16jc
/* 7767 */    MCD::OPC_FilterValue, 1, 121, 22, 0, // Skip to: 13525
/* 7772 */    MCD::OPC_CheckPredicate, 1, 116, 22, 0, // Skip to: 13525
/* 7777 */    MCD::OPC_Decode, 208, 5, 179, 1, // Opcode: MOV16oc
/* 7782 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 7810
/* 7787 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7790 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7800
/* 7795 */    MCD::OPC_Decode, 138, 5, 177, 1, // Opcode: MOV16cj
/* 7800 */    MCD::OPC_FilterValue, 1, 88, 22, 0, // Skip to: 13525
/* 7805 */    MCD::OPC_Decode, 140, 5, 177, 1, // Opcode: MOV16co
/* 7810 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 7836
/* 7815 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7818 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7827
/* 7823 */    MCD::OPC_Decode, 133, 8, 16, // Opcode: MOVM32jm
/* 7827 */    MCD::OPC_FilterValue, 1, 61, 22, 0, // Skip to: 13525
/* 7832 */    MCD::OPC_Decode, 143, 8, 16, // Opcode: MOVM32om
/* 7836 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 7862
/* 7841 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7844 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7853
/* 7849 */    MCD::OPC_Decode, 138, 8, 17, // Opcode: MOVM32mj
/* 7853 */    MCD::OPC_FilterValue, 1, 35, 22, 0, // Skip to: 13525
/* 7858 */    MCD::OPC_Decode, 140, 8, 17, // Opcode: MOVM32mo
/* 7862 */    MCD::OPC_FilterValue, 7, 26, 22, 0, // Skip to: 13525
/* 7867 */    MCD::OPC_CheckField, 3, 1, 0, 19, 22, 0, // Skip to: 13525
/* 7874 */    MCD::OPC_Decode, 216, 4, 169, 1, // Opcode: JMP32j
/* 7879 */    MCD::OPC_FilterValue, 14, 121, 0, 0, // Skip to: 8005
/* 7884 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7887 */    MCD::OPC_FilterValue, 1, 33, 0, 0, // Skip to: 7925
/* 7892 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7895 */    MCD::OPC_FilterValue, 0, 10, 0, 0, // Skip to: 7910
/* 7900 */    MCD::OPC_CheckPredicate, 1, 244, 21, 0, // Skip to: 13525
/* 7905 */    MCD::OPC_Decode, 156, 5, 179, 1, // Opcode: MOV16ec
/* 7910 */    MCD::OPC_FilterValue, 1, 234, 21, 0, // Skip to: 13525
/* 7915 */    MCD::OPC_CheckPredicate, 1, 229, 21, 0, // Skip to: 13525
/* 7920 */    MCD::OPC_Decode, 221, 5, 180, 1, // Opcode: MOV16pc
/* 7925 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 7953
/* 7930 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7933 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7943
/* 7938 */    MCD::OPC_Decode, 136, 5, 177, 1, // Opcode: MOV16ce
/* 7943 */    MCD::OPC_FilterValue, 1, 201, 21, 0, // Skip to: 13525
/* 7948 */    MCD::OPC_Decode, 141, 5, 177, 1, // Opcode: MOV16cp
/* 7953 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 7979
/* 7958 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7961 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7970
/* 7966 */    MCD::OPC_Decode, 131, 8, 16, // Opcode: MOVM32em
/* 7970 */    MCD::OPC_FilterValue, 1, 174, 21, 0, // Skip to: 13525
/* 7975 */    MCD::OPC_Decode, 144, 8, 18, // Opcode: MOVM32pm
/* 7979 */    MCD::OPC_FilterValue, 6, 165, 21, 0, // Skip to: 13525
/* 7984 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7987 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7996
/* 7992 */    MCD::OPC_Decode, 136, 8, 17, // Opcode: MOVM32me
/* 7996 */    MCD::OPC_FilterValue, 1, 148, 21, 0, // Skip to: 13525
/* 8001 */    MCD::OPC_Decode, 141, 8, 19, // Opcode: MOVM32mp
/* 8005 */    MCD::OPC_FilterValue, 15, 56, 1, 0, // Skip to: 8322
/* 8010 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 8013 */    MCD::OPC_FilterValue, 1, 85, 0, 0, // Skip to: 8103
/* 8018 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8021 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 8043
/* 8026 */    MCD::OPC_CheckPredicate, 1, 118, 21, 0, // Skip to: 13525
/* 8031 */    MCD::OPC_CheckField, 24, 4, 8, 111, 21, 0, // Skip to: 13525
/* 8038 */    MCD::OPC_Decode, 169, 5, 181, 1, // Opcode: MOV16fc
/* 8043 */    MCD::OPC_FilterValue, 1, 101, 21, 0, // Skip to: 13525
/* 8048 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8051 */    MCD::OPC_FilterValue, 1, 10, 0, 0, // Skip to: 8066
/* 8056 */    MCD::OPC_CheckPredicate, 1, 88, 21, 0, // Skip to: 13525
/* 8061 */    MCD::OPC_Decode, 251, 4, 182, 1, // Opcode: MOV16bc
/* 8066 */    MCD::OPC_FilterValue, 2, 10, 0, 0, // Skip to: 8081
/* 8071 */    MCD::OPC_CheckPredicate, 1, 73, 21, 0, // Skip to: 13525
/* 8076 */    MCD::OPC_Decode, 234, 5, 183, 1, // Opcode: MOV16qc
/* 8081 */    MCD::OPC_FilterValue, 3, 63, 21, 0, // Skip to: 13525
/* 8086 */    MCD::OPC_CheckPredicate, 1, 58, 21, 0, // Skip to: 13525
/* 8091 */    MCD::OPC_CheckField, 24, 4, 8, 51, 21, 0, // Skip to: 13525
/* 8098 */    MCD::OPC_Decode, 195, 5, 184, 1, // Opcode: MOV16kc
/* 8103 */    MCD::OPC_FilterValue, 2, 65, 0, 0, // Skip to: 8173
/* 8108 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8111 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 8128
/* 8116 */    MCD::OPC_CheckField, 24, 4, 8, 26, 21, 0, // Skip to: 13525
/* 8123 */    MCD::OPC_Decode, 137, 5, 177, 1, // Opcode: MOV16cf
/* 8128 */    MCD::OPC_FilterValue, 1, 16, 21, 0, // Skip to: 13525
/* 8133 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8136 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 8146
/* 8141 */    MCD::OPC_Decode, 134, 5, 177, 1, // Opcode: MOV16cb
/* 8146 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 8156
/* 8151 */    MCD::OPC_Decode, 142, 5, 177, 1, // Opcode: MOV16cq
/* 8156 */    MCD::OPC_FilterValue, 3, 244, 20, 0, // Skip to: 13525
/* 8161 */    MCD::OPC_CheckField, 24, 4, 8, 237, 20, 0, // Skip to: 13525
/* 8168 */    MCD::OPC_Decode, 139, 5, 177, 1, // Opcode: MOV16ck
/* 8173 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 8239
/* 8178 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8181 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8197
/* 8186 */    MCD::OPC_CheckField, 40, 4, 8, 212, 20, 0, // Skip to: 13525
/* 8193 */    MCD::OPC_Decode, 132, 8, 20, // Opcode: MOVM32fm
/* 8197 */    MCD::OPC_FilterValue, 1, 203, 20, 0, // Skip to: 13525
/* 8202 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8205 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8214
/* 8210 */    MCD::OPC_Decode, 130, 8, 90, // Opcode: MOVM32bm
/* 8214 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8223
/* 8219 */    MCD::OPC_Decode, 145, 8, 91, // Opcode: MOVM32qm
/* 8223 */    MCD::OPC_FilterValue, 3, 177, 20, 0, // Skip to: 13525
/* 8228 */    MCD::OPC_CheckField, 40, 4, 8, 170, 20, 0, // Skip to: 13525
/* 8235 */    MCD::OPC_Decode, 134, 8, 92, // Opcode: MOVM32km
/* 8239 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 8256
/* 8244 */    MCD::OPC_CheckField, 0, 4, 12, 154, 20, 0, // Skip to: 13525
/* 8251 */    MCD::OPC_Decode, 215, 4, 170, 1, // Opcode: ILLEGAL
/* 8256 */    MCD::OPC_FilterValue, 6, 144, 20, 0, // Skip to: 13525
/* 8261 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8264 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8280
/* 8269 */    MCD::OPC_CheckField, 40, 4, 8, 129, 20, 0, // Skip to: 13525
/* 8276 */    MCD::OPC_Decode, 137, 8, 21, // Opcode: MOVM32mf
/* 8280 */    MCD::OPC_FilterValue, 1, 120, 20, 0, // Skip to: 13525
/* 8285 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8288 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8297
/* 8293 */    MCD::OPC_Decode, 135, 8, 22, // Opcode: MOVM32mb
/* 8297 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8306
/* 8302 */    MCD::OPC_Decode, 142, 8, 23, // Opcode: MOVM32mq
/* 8306 */    MCD::OPC_FilterValue, 3, 94, 20, 0, // Skip to: 13525
/* 8311 */    MCD::OPC_CheckField, 40, 4, 8, 87, 20, 0, // Skip to: 13525
/* 8318 */    MCD::OPC_Decode, 139, 8, 24, // Opcode: MOVM32mk
/* 8322 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 8338
/* 8327 */    MCD::OPC_CheckField, 3, 1, 1, 71, 20, 0, // Skip to: 13525
/* 8334 */    MCD::OPC_Decode, 220, 4, 55, // Opcode: LEA32p
/* 8338 */    MCD::OPC_FilterValue, 31, 62, 20, 0, // Skip to: 13525
/* 8343 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8346 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8362
/* 8351 */    MCD::OPC_CheckField, 24, 4, 8, 47, 20, 0, // Skip to: 13525
/* 8358 */    MCD::OPC_Decode, 218, 4, 56, // Opcode: LEA32f
/* 8362 */    MCD::OPC_FilterValue, 1, 38, 20, 0, // Skip to: 13525
/* 8367 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8370 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8379
/* 8375 */    MCD::OPC_Decode, 217, 4, 57, // Opcode: LEA32b
/* 8379 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8388
/* 8384 */    MCD::OPC_Decode, 221, 4, 58, // Opcode: LEA32q
/* 8388 */    MCD::OPC_FilterValue, 3, 12, 20, 0, // Skip to: 13525
/* 8393 */    MCD::OPC_CheckField, 24, 4, 8, 5, 20, 0, // Skip to: 13525
/* 8400 */    MCD::OPC_Decode, 219, 4, 59, // Opcode: LEA32k
/* 8404 */    MCD::OPC_FilterValue, 5, 203, 2, 0, // Skip to: 9124
/* 8409 */    MCD::OPC_ExtractField, 4, 8,  // Inst{11-4} ...
/* 8412 */    MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 8422
/* 8417 */    MCD::OPC_Decode, 223, 8, 185, 1, // Opcode: SETd8t
/* 8422 */    MCD::OPC_FilterValue, 13, 12, 0, 0, // Skip to: 8439
/* 8427 */    MCD::OPC_CheckField, 3, 1, 0, 227, 19, 0, // Skip to: 13525
/* 8434 */    MCD::OPC_Decode, 239, 8, 169, 1, // Opcode: SETj8t
/* 8439 */    MCD::OPC_FilterValue, 14, 11, 0, 0, // Skip to: 8455
/* 8444 */    MCD::OPC_CheckField, 3, 1, 1, 210, 19, 0, // Skip to: 13525
/* 8451 */    MCD::OPC_Decode, 255, 8, 17, // Opcode: SETp8t
/* 8455 */    MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 8465
/* 8460 */    MCD::OPC_Decode, 213, 8, 185, 1, // Opcode: SETd8f
/* 8465 */    MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 8482
/* 8470 */    MCD::OPC_CheckField, 3, 1, 0, 184, 19, 0, // Skip to: 13525
/* 8477 */    MCD::OPC_Decode, 229, 8, 169, 1, // Opcode: SETj8f
/* 8482 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 8498
/* 8487 */    MCD::OPC_CheckField, 3, 1, 1, 167, 19, 0, // Skip to: 13525
/* 8494 */    MCD::OPC_Decode, 245, 8, 17, // Opcode: SETp8f
/* 8498 */    MCD::OPC_FilterValue, 44, 5, 0, 0, // Skip to: 8508
/* 8503 */    MCD::OPC_Decode, 216, 8, 185, 1, // Opcode: SETd8hi
/* 8508 */    MCD::OPC_FilterValue, 45, 12, 0, 0, // Skip to: 8525
/* 8513 */    MCD::OPC_CheckField, 3, 1, 0, 141, 19, 0, // Skip to: 13525
/* 8520 */    MCD::OPC_Decode, 232, 8, 169, 1, // Opcode: SETj8hi
/* 8525 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 8541
/* 8530 */    MCD::OPC_CheckField, 3, 1, 1, 124, 19, 0, // Skip to: 13525
/* 8537 */    MCD::OPC_Decode, 248, 8, 17, // Opcode: SETp8hi
/* 8541 */    MCD::OPC_FilterValue, 60, 5, 0, 0, // Skip to: 8551
/* 8546 */    MCD::OPC_Decode, 218, 8, 185, 1, // Opcode: SETd8ls
/* 8551 */    MCD::OPC_FilterValue, 61, 12, 0, 0, // Skip to: 8568
/* 8556 */    MCD::OPC_CheckField, 3, 1, 0, 98, 19, 0, // Skip to: 13525
/* 8563 */    MCD::OPC_Decode, 234, 8, 169, 1, // Opcode: SETj8ls
/* 8568 */    MCD::OPC_FilterValue, 62, 11, 0, 0, // Skip to: 8584
/* 8573 */    MCD::OPC_CheckField, 3, 1, 1, 81, 19, 0, // Skip to: 13525
/* 8580 */    MCD::OPC_Decode, 250, 8, 17, // Opcode: SETp8ls
/* 8584 */    MCD::OPC_FilterValue, 76, 5, 0, 0, // Skip to: 8594
/* 8589 */    MCD::OPC_Decode, 210, 8, 185, 1, // Opcode: SETd8cc
/* 8594 */    MCD::OPC_FilterValue, 77, 12, 0, 0, // Skip to: 8611
/* 8599 */    MCD::OPC_CheckField, 3, 1, 0, 55, 19, 0, // Skip to: 13525
/* 8606 */    MCD::OPC_Decode, 226, 8, 169, 1, // Opcode: SETj8cc
/* 8611 */    MCD::OPC_FilterValue, 78, 11, 0, 0, // Skip to: 8627
/* 8616 */    MCD::OPC_CheckField, 3, 1, 1, 38, 19, 0, // Skip to: 13525
/* 8623 */    MCD::OPC_Decode, 242, 8, 17, // Opcode: SETp8cc
/* 8627 */    MCD::OPC_FilterValue, 92, 5, 0, 0, // Skip to: 8637
/* 8632 */    MCD::OPC_Decode, 211, 8, 185, 1, // Opcode: SETd8cs
/* 8637 */    MCD::OPC_FilterValue, 93, 12, 0, 0, // Skip to: 8654
/* 8642 */    MCD::OPC_CheckField, 3, 1, 0, 12, 19, 0, // Skip to: 13525
/* 8649 */    MCD::OPC_Decode, 227, 8, 169, 1, // Opcode: SETj8cs
/* 8654 */    MCD::OPC_FilterValue, 94, 11, 0, 0, // Skip to: 8670
/* 8659 */    MCD::OPC_CheckField, 3, 1, 1, 251, 18, 0, // Skip to: 13525
/* 8666 */    MCD::OPC_Decode, 243, 8, 17, // Opcode: SETp8cs
/* 8670 */    MCD::OPC_FilterValue, 108, 5, 0, 0, // Skip to: 8680
/* 8675 */    MCD::OPC_Decode, 221, 8, 185, 1, // Opcode: SETd8ne
/* 8680 */    MCD::OPC_FilterValue, 109, 12, 0, 0, // Skip to: 8697
/* 8685 */    MCD::OPC_CheckField, 3, 1, 0, 225, 18, 0, // Skip to: 13525
/* 8692 */    MCD::OPC_Decode, 237, 8, 169, 1, // Opcode: SETj8ne
/* 8697 */    MCD::OPC_FilterValue, 110, 11, 0, 0, // Skip to: 8713
/* 8702 */    MCD::OPC_CheckField, 3, 1, 1, 208, 18, 0, // Skip to: 13525
/* 8709 */    MCD::OPC_Decode, 253, 8, 17, // Opcode: SETp8ne
/* 8713 */    MCD::OPC_FilterValue, 124, 5, 0, 0, // Skip to: 8723
/* 8718 */    MCD::OPC_Decode, 212, 8, 185, 1, // Opcode: SETd8eq
/* 8723 */    MCD::OPC_FilterValue, 125, 12, 0, 0, // Skip to: 8740
/* 8728 */    MCD::OPC_CheckField, 3, 1, 0, 182, 18, 0, // Skip to: 13525
/* 8735 */    MCD::OPC_Decode, 228, 8, 169, 1, // Opcode: SETj8eq
/* 8740 */    MCD::OPC_FilterValue, 126, 11, 0, 0, // Skip to: 8756
/* 8745 */    MCD::OPC_CheckField, 3, 1, 1, 165, 18, 0, // Skip to: 13525
/* 8752 */    MCD::OPC_Decode, 244, 8, 17, // Opcode: SETp8eq
/* 8756 */    MCD::OPC_FilterValue, 140, 1, 5, 0, 0, // Skip to: 8767
/* 8762 */    MCD::OPC_Decode, 224, 8, 185, 1, // Opcode: SETd8vc
/* 8767 */    MCD::OPC_FilterValue, 141, 1, 12, 0, 0, // Skip to: 8785
/* 8773 */    MCD::OPC_CheckField, 3, 1, 0, 137, 18, 0, // Skip to: 13525
/* 8780 */    MCD::OPC_Decode, 240, 8, 169, 1, // Opcode: SETj8vc
/* 8785 */    MCD::OPC_FilterValue, 142, 1, 11, 0, 0, // Skip to: 8802
/* 8791 */    MCD::OPC_CheckField, 3, 1, 1, 119, 18, 0, // Skip to: 13525
/* 8798 */    MCD::OPC_Decode, 128, 9, 17, // Opcode: SETp8vc
/* 8802 */    MCD::OPC_FilterValue, 156, 1, 5, 0, 0, // Skip to: 8813
/* 8808 */    MCD::OPC_Decode, 225, 8, 185, 1, // Opcode: SETd8vs
/* 8813 */    MCD::OPC_FilterValue, 157, 1, 12, 0, 0, // Skip to: 8831
/* 8819 */    MCD::OPC_CheckField, 3, 1, 0, 91, 18, 0, // Skip to: 13525
/* 8826 */    MCD::OPC_Decode, 241, 8, 169, 1, // Opcode: SETj8vs
/* 8831 */    MCD::OPC_FilterValue, 158, 1, 11, 0, 0, // Skip to: 8848
/* 8837 */    MCD::OPC_CheckField, 3, 1, 1, 73, 18, 0, // Skip to: 13525
/* 8844 */    MCD::OPC_Decode, 129, 9, 17, // Opcode: SETp8vs
/* 8848 */    MCD::OPC_FilterValue, 172, 1, 5, 0, 0, // Skip to: 8859
/* 8854 */    MCD::OPC_Decode, 222, 8, 185, 1, // Opcode: SETd8pl
/* 8859 */    MCD::OPC_FilterValue, 173, 1, 12, 0, 0, // Skip to: 8877
/* 8865 */    MCD::OPC_CheckField, 3, 1, 0, 45, 18, 0, // Skip to: 13525
/* 8872 */    MCD::OPC_Decode, 238, 8, 169, 1, // Opcode: SETj8pl
/* 8877 */    MCD::OPC_FilterValue, 174, 1, 11, 0, 0, // Skip to: 8894
/* 8883 */    MCD::OPC_CheckField, 3, 1, 1, 27, 18, 0, // Skip to: 13525
/* 8890 */    MCD::OPC_Decode, 254, 8, 17, // Opcode: SETp8pl
/* 8894 */    MCD::OPC_FilterValue, 188, 1, 5, 0, 0, // Skip to: 8905
/* 8900 */    MCD::OPC_Decode, 220, 8, 185, 1, // Opcode: SETd8mi
/* 8905 */    MCD::OPC_FilterValue, 189, 1, 12, 0, 0, // Skip to: 8923
/* 8911 */    MCD::OPC_CheckField, 3, 1, 0, 255, 17, 0, // Skip to: 13525
/* 8918 */    MCD::OPC_Decode, 236, 8, 169, 1, // Opcode: SETj8mi
/* 8923 */    MCD::OPC_FilterValue, 190, 1, 11, 0, 0, // Skip to: 8940
/* 8929 */    MCD::OPC_CheckField, 3, 1, 1, 237, 17, 0, // Skip to: 13525
/* 8936 */    MCD::OPC_Decode, 252, 8, 17, // Opcode: SETp8mi
/* 8940 */    MCD::OPC_FilterValue, 204, 1, 5, 0, 0, // Skip to: 8951
/* 8946 */    MCD::OPC_Decode, 214, 8, 185, 1, // Opcode: SETd8ge
/* 8951 */    MCD::OPC_FilterValue, 205, 1, 12, 0, 0, // Skip to: 8969
/* 8957 */    MCD::OPC_CheckField, 3, 1, 0, 209, 17, 0, // Skip to: 13525
/* 8964 */    MCD::OPC_Decode, 230, 8, 169, 1, // Opcode: SETj8ge
/* 8969 */    MCD::OPC_FilterValue, 206, 1, 11, 0, 0, // Skip to: 8986
/* 8975 */    MCD::OPC_CheckField, 3, 1, 1, 191, 17, 0, // Skip to: 13525
/* 8982 */    MCD::OPC_Decode, 246, 8, 17, // Opcode: SETp8ge
/* 8986 */    MCD::OPC_FilterValue, 220, 1, 5, 0, 0, // Skip to: 8997
/* 8992 */    MCD::OPC_Decode, 219, 8, 185, 1, // Opcode: SETd8lt
/* 8997 */    MCD::OPC_FilterValue, 221, 1, 12, 0, 0, // Skip to: 9015
/* 9003 */    MCD::OPC_CheckField, 3, 1, 0, 163, 17, 0, // Skip to: 13525
/* 9010 */    MCD::OPC_Decode, 235, 8, 169, 1, // Opcode: SETj8lt
/* 9015 */    MCD::OPC_FilterValue, 222, 1, 11, 0, 0, // Skip to: 9032
/* 9021 */    MCD::OPC_CheckField, 3, 1, 1, 145, 17, 0, // Skip to: 13525
/* 9028 */    MCD::OPC_Decode, 251, 8, 17, // Opcode: SETp8lt
/* 9032 */    MCD::OPC_FilterValue, 236, 1, 5, 0, 0, // Skip to: 9043
/* 9038 */    MCD::OPC_Decode, 215, 8, 185, 1, // Opcode: SETd8gt
/* 9043 */    MCD::OPC_FilterValue, 237, 1, 12, 0, 0, // Skip to: 9061
/* 9049 */    MCD::OPC_CheckField, 3, 1, 0, 117, 17, 0, // Skip to: 13525
/* 9056 */    MCD::OPC_Decode, 231, 8, 169, 1, // Opcode: SETj8gt
/* 9061 */    MCD::OPC_FilterValue, 238, 1, 11, 0, 0, // Skip to: 9078
/* 9067 */    MCD::OPC_CheckField, 3, 1, 1, 99, 17, 0, // Skip to: 13525
/* 9074 */    MCD::OPC_Decode, 247, 8, 17, // Opcode: SETp8gt
/* 9078 */    MCD::OPC_FilterValue, 252, 1, 5, 0, 0, // Skip to: 9089
/* 9084 */    MCD::OPC_Decode, 217, 8, 185, 1, // Opcode: SETd8le
/* 9089 */    MCD::OPC_FilterValue, 253, 1, 12, 0, 0, // Skip to: 9107
/* 9095 */    MCD::OPC_CheckField, 3, 1, 0, 71, 17, 0, // Skip to: 13525
/* 9102 */    MCD::OPC_Decode, 233, 8, 169, 1, // Opcode: SETj8le
/* 9107 */    MCD::OPC_FilterValue, 254, 1, 60, 17, 0, // Skip to: 13525
/* 9113 */    MCD::OPC_CheckField, 3, 1, 1, 53, 17, 0, // Skip to: 13525
/* 9120 */    MCD::OPC_Decode, 249, 8, 17, // Opcode: SETp8le
/* 9124 */    MCD::OPC_FilterValue, 6, 111, 1, 0, // Skip to: 9496
/* 9129 */    MCD::OPC_ExtractField, 8, 4,  // Inst{11-8} ...
/* 9132 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 9154
/* 9137 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9149
/* 9144 */    MCD::OPC_Decode, 183, 3, 174, 1, // Opcode: BRA16
/* 9149 */    MCD::OPC_Decode, 184, 3, 186, 1, // Opcode: BRA8
/* 9154 */    MCD::OPC_FilterValue, 1, 29, 0, 0, // Skip to: 9188
/* 9159 */    MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 9162 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 9172
/* 9167 */    MCD::OPC_Decode, 185, 3, 174, 1, // Opcode: BSR16
/* 9172 */    MCD::OPC_FilterValue, 255, 1, 5, 0, 0, // Skip to: 9183
/* 9178 */    MCD::OPC_Decode, 186, 3, 173, 1, // Opcode: BSR32
/* 9183 */    MCD::OPC_Decode, 187, 3, 186, 1, // Opcode: BSR8
/* 9188 */    MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 9210
/* 9193 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9205
/* 9200 */    MCD::OPC_Decode, 214, 3, 174, 1, // Opcode: Bhi16
/* 9205 */    MCD::OPC_Decode, 215, 3, 186, 1, // Opcode: Bhi8
/* 9210 */    MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 9232
/* 9215 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9227
/* 9222 */    MCD::OPC_Decode, 218, 3, 174, 1, // Opcode: Bls16
/* 9227 */    MCD::OPC_Decode, 219, 3, 186, 1, // Opcode: Bls8
/* 9232 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 9254
/* 9237 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9249
/* 9244 */    MCD::OPC_Decode, 204, 3, 174, 1, // Opcode: Bcc16
/* 9249 */    MCD::OPC_Decode, 205, 3, 186, 1, // Opcode: Bcc8
/* 9254 */    MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 9276
/* 9259 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9271
/* 9266 */    MCD::OPC_Decode, 206, 3, 174, 1, // Opcode: Bcs16
/* 9271 */    MCD::OPC_Decode, 207, 3, 186, 1, // Opcode: Bcs8
/* 9276 */    MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 9298
/* 9281 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9293
/* 9288 */    MCD::OPC_Decode, 224, 3, 174, 1, // Opcode: Bne16
/* 9293 */    MCD::OPC_Decode, 225, 3, 186, 1, // Opcode: Bne8
/* 9298 */    MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 9320
/* 9303 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9315
/* 9310 */    MCD::OPC_Decode, 208, 3, 174, 1, // Opcode: Beq16
/* 9315 */    MCD::OPC_Decode, 209, 3, 186, 1, // Opcode: Beq8
/* 9320 */    MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 9342
/* 9325 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9337
/* 9332 */    MCD::OPC_Decode, 228, 3, 174, 1, // Opcode: Bvc16
/* 9337 */    MCD::OPC_Decode, 229, 3, 186, 1, // Opcode: Bvc8
/* 9342 */    MCD::OPC_FilterValue, 9, 17, 0, 0, // Skip to: 9364
/* 9347 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9359
/* 9354 */    MCD::OPC_Decode, 230, 3, 174, 1, // Opcode: Bvs16
/* 9359 */    MCD::OPC_Decode, 231, 3, 186, 1, // Opcode: Bvs8
/* 9364 */    MCD::OPC_FilterValue, 10, 17, 0, 0, // Skip to: 9386
/* 9369 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9381
/* 9376 */    MCD::OPC_Decode, 226, 3, 174, 1, // Opcode: Bpl16
/* 9381 */    MCD::OPC_Decode, 227, 3, 186, 1, // Opcode: Bpl8
/* 9386 */    MCD::OPC_FilterValue, 11, 17, 0, 0, // Skip to: 9408
/* 9391 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9403
/* 9398 */    MCD::OPC_Decode, 222, 3, 174, 1, // Opcode: Bmi16
/* 9403 */    MCD::OPC_Decode, 223, 3, 186, 1, // Opcode: Bmi8
/* 9408 */    MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 9430
/* 9413 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9425
/* 9420 */    MCD::OPC_Decode, 210, 3, 174, 1, // Opcode: Bge16
/* 9425 */    MCD::OPC_Decode, 211, 3, 186, 1, // Opcode: Bge8
/* 9430 */    MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 9452
/* 9435 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9447
/* 9442 */    MCD::OPC_Decode, 220, 3, 174, 1, // Opcode: Blt16
/* 9447 */    MCD::OPC_Decode, 221, 3, 186, 1, // Opcode: Blt8
/* 9452 */    MCD::OPC_FilterValue, 14, 17, 0, 0, // Skip to: 9474
/* 9457 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9469
/* 9464 */    MCD::OPC_Decode, 212, 3, 174, 1, // Opcode: Bgt16
/* 9469 */    MCD::OPC_Decode, 213, 3, 186, 1, // Opcode: Bgt8
/* 9474 */    MCD::OPC_FilterValue, 15, 206, 15, 0, // Skip to: 13525
/* 9479 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9491
/* 9486 */    MCD::OPC_Decode, 216, 3, 174, 1, // Opcode: Ble16
/* 9491 */    MCD::OPC_Decode, 217, 3, 186, 1, // Opcode: Ble8
/* 9496 */    MCD::OPC_FilterValue, 8, 110, 2, 0, // Skip to: 10123
/* 9501 */    MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 9504 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9521
/* 9509 */    MCD::OPC_CheckField, 3, 1, 0, 169, 15, 0, // Skip to: 13525
/* 9516 */    MCD::OPC_Decode, 181, 8, 187, 1, // Opcode: OR8dd
/* 9521 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 9538
/* 9526 */    MCD::OPC_CheckField, 3, 1, 0, 152, 15, 0, // Skip to: 13525
/* 9533 */    MCD::OPC_Decode, 184, 8, 188, 1, // Opcode: OR8dj
/* 9538 */    MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 9555
/* 9543 */    MCD::OPC_CheckField, 3, 1, 1, 135, 15, 0, // Skip to: 13525
/* 9550 */    MCD::OPC_Decode, 186, 8, 189, 1, // Opcode: OR8dp
/* 9555 */    MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 9632
/* 9560 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9563 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9580
/* 9568 */    MCD::OPC_CheckField, 24, 4, 8, 110, 15, 0, // Skip to: 13525
/* 9575 */    MCD::OPC_Decode, 182, 8, 190, 1, // Opcode: OR8df
/* 9580 */    MCD::OPC_FilterValue, 1, 100, 15, 0, // Skip to: 13525
/* 9585 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9588 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9598
/* 9593 */    MCD::OPC_Decode, 187, 8, 191, 1, // Opcode: OR8dq
/* 9598 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9615
/* 9603 */    MCD::OPC_CheckField, 24, 4, 8, 75, 15, 0, // Skip to: 13525
/* 9610 */    MCD::OPC_Decode, 185, 8, 192, 1, // Opcode: OR8dk
/* 9615 */    MCD::OPC_FilterValue, 4, 65, 15, 0, // Skip to: 13525
/* 9620 */    MCD::OPC_CheckField, 24, 8, 0, 58, 15, 0, // Skip to: 13525
/* 9627 */    MCD::OPC_Decode, 183, 8, 193, 1, // Opcode: OR8di
/* 9632 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 9654
/* 9637 */    MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 9649
/* 9644 */    MCD::OPC_Decode, 153, 8, 194, 1, // Opcode: OR16dd
/* 9649 */    MCD::OPC_Decode, 160, 8, 195, 1, // Opcode: OR16dr
/* 9654 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 9671
/* 9659 */    MCD::OPC_CheckField, 3, 1, 0, 19, 15, 0, // Skip to: 13525
/* 9666 */    MCD::OPC_Decode, 156, 8, 196, 1, // Opcode: OR16dj
/* 9671 */    MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 9688
/* 9676 */    MCD::OPC_CheckField, 3, 1, 1, 2, 15, 0, // Skip to: 13525
/* 9683 */    MCD::OPC_Decode, 158, 8, 197, 1, // Opcode: OR16dp
/* 9688 */    MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 9758
/* 9693 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9696 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9713
/* 9701 */    MCD::OPC_CheckField, 24, 4, 8, 233, 14, 0, // Skip to: 13525
/* 9708 */    MCD::OPC_Decode, 154, 8, 198, 1, // Opcode: OR16df
/* 9713 */    MCD::OPC_FilterValue, 1, 223, 14, 0, // Skip to: 13525
/* 9718 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9721 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9731
/* 9726 */    MCD::OPC_Decode, 159, 8, 199, 1, // Opcode: OR16dq
/* 9731 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9748
/* 9736 */    MCD::OPC_CheckField, 24, 4, 8, 198, 14, 0, // Skip to: 13525
/* 9743 */    MCD::OPC_Decode, 157, 8, 200, 1, // Opcode: OR16dk
/* 9748 */    MCD::OPC_FilterValue, 4, 188, 14, 0, // Skip to: 13525
/* 9753 */    MCD::OPC_Decode, 155, 8, 199, 1, // Opcode: OR16di
/* 9758 */    MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 9780
/* 9763 */    MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 9775
/* 9770 */    MCD::OPC_Decode, 167, 8, 201, 1, // Opcode: OR32dd
/* 9775 */    MCD::OPC_Decode, 174, 8, 202, 1, // Opcode: OR32dr
/* 9780 */    MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 9797
/* 9785 */    MCD::OPC_CheckField, 3, 1, 0, 149, 14, 0, // Skip to: 13525
/* 9792 */    MCD::OPC_Decode, 170, 8, 203, 1, // Opcode: OR32dj
/* 9797 */    MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 9814
/* 9802 */    MCD::OPC_CheckField, 3, 1, 1, 132, 14, 0, // Skip to: 13525
/* 9809 */    MCD::OPC_Decode, 172, 8, 204, 1, // Opcode: OR32dp
/* 9814 */    MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 9884
/* 9819 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9822 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9839
/* 9827 */    MCD::OPC_CheckField, 24, 4, 8, 107, 14, 0, // Skip to: 13525
/* 9834 */    MCD::OPC_Decode, 168, 8, 205, 1, // Opcode: OR32df
/* 9839 */    MCD::OPC_FilterValue, 1, 97, 14, 0, // Skip to: 13525
/* 9844 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9847 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9857
/* 9852 */    MCD::OPC_Decode, 173, 8, 206, 1, // Opcode: OR32dq
/* 9857 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9874
/* 9862 */    MCD::OPC_CheckField, 24, 4, 8, 72, 14, 0, // Skip to: 13525
/* 9869 */    MCD::OPC_Decode, 171, 8, 207, 1, // Opcode: OR32dk
/* 9874 */    MCD::OPC_FilterValue, 4, 62, 14, 0, // Skip to: 13525
/* 9879 */    MCD::OPC_Decode, 169, 8, 208, 1, // Opcode: OR32di
/* 9884 */    MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 9901
/* 9889 */    MCD::OPC_CheckField, 3, 1, 0, 45, 14, 0, // Skip to: 13525
/* 9896 */    MCD::OPC_Decode, 193, 9, 209, 1, // Opcode: UDIVd32d16
/* 9901 */    MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 9918
/* 9906 */    MCD::OPC_CheckField, 0, 4, 12, 28, 14, 0, // Skip to: 13525
/* 9913 */    MCD::OPC_Decode, 195, 9, 206, 1, // Opcode: UDIVd32i16
/* 9918 */    MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 9934
/* 9923 */    MCD::OPC_CheckField, 3, 1, 0, 11, 14, 0, // Skip to: 13525
/* 9930 */    MCD::OPC_Decode, 190, 8, 40, // Opcode: OR8jd
/* 9934 */    MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 9950
/* 9939 */    MCD::OPC_CheckField, 3, 1, 1, 251, 13, 0, // Skip to: 13525
/* 9946 */    MCD::OPC_Decode, 192, 8, 41, // Opcode: OR8pd
/* 9950 */    MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 9973
/* 9955 */    MCD::OPC_CheckField, 24, 4, 8, 235, 13, 0, // Skip to: 13525
/* 9962 */    MCD::OPC_CheckField, 3, 1, 0, 228, 13, 0, // Skip to: 13525
/* 9969 */    MCD::OPC_Decode, 188, 8, 42, // Opcode: OR8fd
/* 9973 */    MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 9990
/* 9978 */    MCD::OPC_CheckField, 3, 1, 0, 212, 13, 0, // Skip to: 13525
/* 9985 */    MCD::OPC_Decode, 163, 8, 210, 1, // Opcode: OR16jd
/* 9990 */    MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 10007
/* 9995 */    MCD::OPC_CheckField, 3, 1, 1, 195, 13, 0, // Skip to: 13525
/* 10002 */   MCD::OPC_Decode, 165, 8, 211, 1, // Opcode: OR16pd
/* 10007 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 10031
/* 10012 */   MCD::OPC_CheckField, 24, 4, 8, 178, 13, 0, // Skip to: 13525
/* 10019 */   MCD::OPC_CheckField, 3, 1, 0, 171, 13, 0, // Skip to: 13525
/* 10026 */   MCD::OPC_Decode, 161, 8, 212, 1, // Opcode: OR16fd
/* 10031 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 10048
/* 10036 */   MCD::OPC_CheckField, 3, 1, 0, 154, 13, 0, // Skip to: 13525
/* 10043 */   MCD::OPC_Decode, 177, 8, 213, 1, // Opcode: OR32jd
/* 10048 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 10065
/* 10053 */   MCD::OPC_CheckField, 3, 1, 1, 137, 13, 0, // Skip to: 13525
/* 10060 */   MCD::OPC_Decode, 179, 8, 214, 1, // Opcode: OR32pd
/* 10065 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 10089
/* 10070 */   MCD::OPC_CheckField, 24, 4, 8, 120, 13, 0, // Skip to: 13525
/* 10077 */   MCD::OPC_CheckField, 3, 1, 0, 113, 13, 0, // Skip to: 13525
/* 10084 */   MCD::OPC_Decode, 175, 8, 215, 1, // Opcode: OR32fd
/* 10089 */   MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 10106
/* 10094 */   MCD::OPC_CheckField, 3, 1, 0, 96, 13, 0, // Skip to: 13525
/* 10101 */   MCD::OPC_Decode, 207, 8, 209, 1, // Opcode: SDIVd32d16
/* 10106 */   MCD::OPC_FilterValue, 31, 86, 13, 0, // Skip to: 13525
/* 10111 */   MCD::OPC_CheckField, 0, 4, 12, 79, 13, 0, // Skip to: 13525
/* 10118 */   MCD::OPC_Decode, 209, 8, 206, 1, // Opcode: SDIVd32i16
/* 10123 */   MCD::OPC_FilterValue, 9, 217, 2, 0, // Skip to: 10857
/* 10128 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 10131 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10148
/* 10136 */   MCD::OPC_CheckField, 3, 1, 0, 54, 13, 0, // Skip to: 13525
/* 10143 */   MCD::OPC_Decode, 175, 9, 187, 1, // Opcode: SUB8dd
/* 10148 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 10165
/* 10153 */   MCD::OPC_CheckField, 3, 1, 0, 37, 13, 0, // Skip to: 13525
/* 10160 */   MCD::OPC_Decode, 178, 9, 188, 1, // Opcode: SUB8dj
/* 10165 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 10182
/* 10170 */   MCD::OPC_CheckField, 3, 1, 1, 20, 13, 0, // Skip to: 13525
/* 10177 */   MCD::OPC_Decode, 180, 9, 189, 1, // Opcode: SUB8dp
/* 10182 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 10259
/* 10187 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10190 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10207
/* 10195 */   MCD::OPC_CheckField, 24, 4, 8, 251, 12, 0, // Skip to: 13525
/* 10202 */   MCD::OPC_Decode, 176, 9, 190, 1, // Opcode: SUB8df
/* 10207 */   MCD::OPC_FilterValue, 1, 241, 12, 0, // Skip to: 13525
/* 10212 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10215 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10225
/* 10220 */   MCD::OPC_Decode, 181, 9, 191, 1, // Opcode: SUB8dq
/* 10225 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10242
/* 10230 */   MCD::OPC_CheckField, 24, 4, 8, 216, 12, 0, // Skip to: 13525
/* 10237 */   MCD::OPC_Decode, 179, 9, 192, 1, // Opcode: SUB8dk
/* 10242 */   MCD::OPC_FilterValue, 4, 206, 12, 0, // Skip to: 13525
/* 10247 */   MCD::OPC_CheckField, 24, 8, 0, 199, 12, 0, // Skip to: 13525
/* 10254 */   MCD::OPC_Decode, 177, 9, 193, 1, // Opcode: SUB8di
/* 10259 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 10281
/* 10264 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 10276
/* 10271 */   MCD::OPC_Decode, 139, 9, 194, 1, // Opcode: SUB16dd
/* 10276 */   MCD::OPC_Decode, 146, 9, 195, 1, // Opcode: SUB16dr
/* 10281 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 10298
/* 10286 */   MCD::OPC_CheckField, 3, 1, 0, 160, 12, 0, // Skip to: 13525
/* 10293 */   MCD::OPC_Decode, 142, 9, 196, 1, // Opcode: SUB16dj
/* 10298 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 10315
/* 10303 */   MCD::OPC_CheckField, 3, 1, 1, 143, 12, 0, // Skip to: 13525
/* 10310 */   MCD::OPC_Decode, 144, 9, 197, 1, // Opcode: SUB16dp
/* 10315 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 10385
/* 10320 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10323 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10340
/* 10328 */   MCD::OPC_CheckField, 24, 4, 8, 118, 12, 0, // Skip to: 13525
/* 10335 */   MCD::OPC_Decode, 140, 9, 198, 1, // Opcode: SUB16df
/* 10340 */   MCD::OPC_FilterValue, 1, 108, 12, 0, // Skip to: 13525
/* 10345 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10348 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10358
/* 10353 */   MCD::OPC_Decode, 145, 9, 199, 1, // Opcode: SUB16dq
/* 10358 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10375
/* 10363 */   MCD::OPC_CheckField, 24, 4, 8, 83, 12, 0, // Skip to: 13525
/* 10370 */   MCD::OPC_Decode, 143, 9, 200, 1, // Opcode: SUB16dk
/* 10375 */   MCD::OPC_FilterValue, 4, 73, 12, 0, // Skip to: 13525
/* 10380 */   MCD::OPC_Decode, 141, 9, 199, 1, // Opcode: SUB16di
/* 10385 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 10407
/* 10390 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 10402
/* 10397 */   MCD::OPC_Decode, 161, 9, 201, 1, // Opcode: SUB32dd
/* 10402 */   MCD::OPC_Decode, 168, 9, 202, 1, // Opcode: SUB32dr
/* 10407 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 10424
/* 10412 */   MCD::OPC_CheckField, 3, 1, 0, 34, 12, 0, // Skip to: 13525
/* 10419 */   MCD::OPC_Decode, 164, 9, 203, 1, // Opcode: SUB32dj
/* 10424 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 10441
/* 10429 */   MCD::OPC_CheckField, 3, 1, 1, 17, 12, 0, // Skip to: 13525
/* 10436 */   MCD::OPC_Decode, 166, 9, 204, 1, // Opcode: SUB32dp
/* 10441 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 10511
/* 10446 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10449 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10466
/* 10454 */   MCD::OPC_CheckField, 24, 4, 8, 248, 11, 0, // Skip to: 13525
/* 10461 */   MCD::OPC_Decode, 162, 9, 205, 1, // Opcode: SUB32df
/* 10466 */   MCD::OPC_FilterValue, 1, 238, 11, 0, // Skip to: 13525
/* 10471 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10474 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10484
/* 10479 */   MCD::OPC_Decode, 167, 9, 206, 1, // Opcode: SUB32dq
/* 10484 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10501
/* 10489 */   MCD::OPC_CheckField, 24, 4, 8, 213, 11, 0, // Skip to: 13525
/* 10496 */   MCD::OPC_Decode, 165, 9, 207, 1, // Opcode: SUB32dk
/* 10501 */   MCD::OPC_FilterValue, 4, 203, 11, 0, // Skip to: 13525
/* 10506 */   MCD::OPC_Decode, 163, 9, 208, 1, // Opcode: SUB32di
/* 10511 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 10528
/* 10516 */   MCD::OPC_CheckField, 3, 1, 0, 186, 11, 0, // Skip to: 13525
/* 10523 */   MCD::OPC_Decode, 190, 9, 187, 1, // Opcode: SUBX8dd
/* 10528 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 10544
/* 10533 */   MCD::OPC_CheckField, 3, 1, 0, 169, 11, 0, // Skip to: 13525
/* 10540 */   MCD::OPC_Decode, 184, 9, 40, // Opcode: SUB8jd
/* 10544 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 10560
/* 10549 */   MCD::OPC_CheckField, 3, 1, 1, 153, 11, 0, // Skip to: 13525
/* 10556 */   MCD::OPC_Decode, 186, 9, 41, // Opcode: SUB8pd
/* 10560 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 10583
/* 10565 */   MCD::OPC_CheckField, 24, 4, 8, 137, 11, 0, // Skip to: 13525
/* 10572 */   MCD::OPC_CheckField, 3, 1, 0, 130, 11, 0, // Skip to: 13525
/* 10579 */   MCD::OPC_Decode, 182, 9, 42, // Opcode: SUB8fd
/* 10583 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 10600
/* 10588 */   MCD::OPC_CheckField, 3, 1, 0, 114, 11, 0, // Skip to: 13525
/* 10595 */   MCD::OPC_Decode, 188, 9, 194, 1, // Opcode: SUBX16dd
/* 10600 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 10617
/* 10605 */   MCD::OPC_CheckField, 3, 1, 0, 97, 11, 0, // Skip to: 13525
/* 10612 */   MCD::OPC_Decode, 149, 9, 210, 1, // Opcode: SUB16jd
/* 10617 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 10634
/* 10622 */   MCD::OPC_CheckField, 3, 1, 1, 80, 11, 0, // Skip to: 13525
/* 10629 */   MCD::OPC_Decode, 151, 9, 211, 1, // Opcode: SUB16pd
/* 10634 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 10658
/* 10639 */   MCD::OPC_CheckField, 24, 4, 8, 63, 11, 0, // Skip to: 13525
/* 10646 */   MCD::OPC_CheckField, 3, 1, 0, 56, 11, 0, // Skip to: 13525
/* 10653 */   MCD::OPC_Decode, 147, 9, 212, 1, // Opcode: SUB16fd
/* 10658 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 10675
/* 10663 */   MCD::OPC_CheckField, 3, 1, 0, 39, 11, 0, // Skip to: 13525
/* 10670 */   MCD::OPC_Decode, 189, 9, 201, 1, // Opcode: SUBX32dd
/* 10675 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 10692
/* 10680 */   MCD::OPC_CheckField, 3, 1, 0, 22, 11, 0, // Skip to: 13525
/* 10687 */   MCD::OPC_Decode, 171, 9, 213, 1, // Opcode: SUB32jd
/* 10692 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 10709
/* 10697 */   MCD::OPC_CheckField, 3, 1, 1, 5, 11, 0, // Skip to: 13525
/* 10704 */   MCD::OPC_Decode, 173, 9, 214, 1, // Opcode: SUB32pd
/* 10709 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 10733
/* 10714 */   MCD::OPC_CheckField, 24, 4, 8, 244, 10, 0, // Skip to: 13525
/* 10721 */   MCD::OPC_CheckField, 3, 1, 0, 237, 10, 0, // Skip to: 13525
/* 10728 */   MCD::OPC_Decode, 169, 9, 215, 1, // Opcode: SUB32fd
/* 10733 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 10743
/* 10738 */   MCD::OPC_Decode, 160, 9, 216, 1, // Opcode: SUB32ar
/* 10743 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 10760
/* 10748 */   MCD::OPC_CheckField, 3, 1, 0, 210, 10, 0, // Skip to: 13525
/* 10755 */   MCD::OPC_Decode, 156, 9, 217, 1, // Opcode: SUB32aj
/* 10760 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 10777
/* 10765 */   MCD::OPC_CheckField, 3, 1, 1, 193, 10, 0, // Skip to: 13525
/* 10772 */   MCD::OPC_Decode, 158, 9, 218, 1, // Opcode: SUB32ap
/* 10777 */   MCD::OPC_FilterValue, 31, 183, 10, 0, // Skip to: 13525
/* 10782 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10785 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10802
/* 10790 */   MCD::OPC_CheckField, 24, 4, 8, 168, 10, 0, // Skip to: 13525
/* 10797 */   MCD::OPC_Decode, 154, 9, 219, 1, // Opcode: SUB32af
/* 10802 */   MCD::OPC_FilterValue, 1, 158, 10, 0, // Skip to: 13525
/* 10807 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10810 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 10820
/* 10815 */   MCD::OPC_Decode, 153, 9, 220, 1, // Opcode: SUB32ab
/* 10820 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10830
/* 10825 */   MCD::OPC_Decode, 159, 9, 221, 1, // Opcode: SUB32aq
/* 10830 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10847
/* 10835 */   MCD::OPC_CheckField, 24, 4, 8, 123, 10, 0, // Skip to: 13525
/* 10842 */   MCD::OPC_Decode, 157, 9, 222, 1, // Opcode: SUB32ak
/* 10847 */   MCD::OPC_FilterValue, 4, 113, 10, 0, // Skip to: 13525
/* 10852 */   MCD::OPC_Decode, 155, 9, 220, 1, // Opcode: SUB32ai
/* 10857 */   MCD::OPC_FilterValue, 11, 100, 1, 0, // Skip to: 11218
/* 10862 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 10865 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10875
/* 10870 */   MCD::OPC_Decode, 138, 4, 223, 1, // Opcode: CMP8dd
/* 10875 */   MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 10891
/* 10880 */   MCD::OPC_CheckField, 3, 1, 0, 78, 10, 0, // Skip to: 13525
/* 10887 */   MCD::OPC_Decode, 141, 4, 46, // Opcode: CMP8dj
/* 10891 */   MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 10907
/* 10896 */   MCD::OPC_CheckField, 3, 1, 1, 62, 10, 0, // Skip to: 13525
/* 10903 */   MCD::OPC_Decode, 143, 4, 47, // Opcode: CMP8dp
/* 10907 */   MCD::OPC_FilterValue, 3, 52, 0, 0, // Skip to: 10964
/* 10912 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10915 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 10931
/* 10920 */   MCD::OPC_CheckField, 24, 4, 8, 38, 10, 0, // Skip to: 13525
/* 10927 */   MCD::OPC_Decode, 139, 4, 48, // Opcode: CMP8df
/* 10931 */   MCD::OPC_FilterValue, 1, 29, 10, 0, // Skip to: 13525
/* 10936 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10939 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 10948
/* 10944 */   MCD::OPC_Decode, 144, 4, 50, // Opcode: CMP8dq
/* 10948 */   MCD::OPC_FilterValue, 3, 12, 10, 0, // Skip to: 13525
/* 10953 */   MCD::OPC_CheckField, 24, 4, 8, 5, 10, 0, // Skip to: 13525
/* 10960 */   MCD::OPC_Decode, 142, 4, 51, // Opcode: CMP8dk
/* 10964 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 10974
/* 10969 */   MCD::OPC_Decode, 246, 3, 224, 1, // Opcode: CMP16dr
/* 10974 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 10991
/* 10979 */   MCD::OPC_CheckField, 3, 1, 0, 235, 9, 0, // Skip to: 13525
/* 10986 */   MCD::OPC_Decode, 242, 3, 144, 1, // Opcode: CMP16dj
/* 10991 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 11008
/* 10996 */   MCD::OPC_CheckField, 3, 1, 1, 218, 9, 0, // Skip to: 13525
/* 11003 */   MCD::OPC_Decode, 244, 3, 147, 1, // Opcode: CMP16dp
/* 11008 */   MCD::OPC_FilterValue, 7, 55, 0, 0, // Skip to: 11068
/* 11013 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11016 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11033
/* 11021 */   MCD::OPC_CheckField, 24, 4, 8, 193, 9, 0, // Skip to: 13525
/* 11028 */   MCD::OPC_Decode, 240, 3, 150, 1, // Opcode: CMP16df
/* 11033 */   MCD::OPC_FilterValue, 1, 183, 9, 0, // Skip to: 13525
/* 11038 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11041 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11051
/* 11046 */   MCD::OPC_Decode, 245, 3, 156, 1, // Opcode: CMP16dq
/* 11051 */   MCD::OPC_FilterValue, 3, 165, 9, 0, // Skip to: 13525
/* 11056 */   MCD::OPC_CheckField, 24, 4, 8, 158, 9, 0, // Skip to: 13525
/* 11063 */   MCD::OPC_Decode, 243, 3, 159, 1, // Opcode: CMP16dk
/* 11068 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 11078
/* 11073 */   MCD::OPC_Decode, 131, 4, 225, 1, // Opcode: CMP32dr
/* 11078 */   MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 11094
/* 11083 */   MCD::OPC_CheckField, 3, 1, 0, 131, 9, 0, // Skip to: 13525
/* 11090 */   MCD::OPC_Decode, 255, 3, 111, // Opcode: CMP32dj
/* 11094 */   MCD::OPC_FilterValue, 10, 11, 0, 0, // Skip to: 11110
/* 11099 */   MCD::OPC_CheckField, 3, 1, 1, 115, 9, 0, // Skip to: 13525
/* 11106 */   MCD::OPC_Decode, 129, 4, 112, // Opcode: CMP32dp
/* 11110 */   MCD::OPC_FilterValue, 11, 52, 0, 0, // Skip to: 11167
/* 11115 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11118 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 11134
/* 11123 */   MCD::OPC_CheckField, 24, 4, 8, 91, 9, 0, // Skip to: 13525
/* 11130 */   MCD::OPC_Decode, 253, 3, 114, // Opcode: CMP32df
/* 11134 */   MCD::OPC_FilterValue, 1, 82, 9, 0, // Skip to: 13525
/* 11139 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11142 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 11151
/* 11147 */   MCD::OPC_Decode, 130, 4, 118, // Opcode: CMP32dq
/* 11151 */   MCD::OPC_FilterValue, 3, 65, 9, 0, // Skip to: 13525
/* 11156 */   MCD::OPC_CheckField, 24, 4, 8, 58, 9, 0, // Skip to: 13525
/* 11163 */   MCD::OPC_Decode, 128, 4, 120, // Opcode: CMP32dk
/* 11167 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 11184
/* 11172 */   MCD::OPC_CheckField, 3, 1, 0, 42, 9, 0, // Skip to: 13525
/* 11179 */   MCD::OPC_Decode, 204, 9, 226, 1, // Opcode: XOR8dd
/* 11184 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 11201
/* 11189 */   MCD::OPC_CheckField, 3, 1, 0, 25, 9, 0, // Skip to: 13525
/* 11196 */   MCD::OPC_Decode, 200, 9, 227, 1, // Opcode: XOR16dd
/* 11201 */   MCD::OPC_FilterValue, 24, 15, 9, 0, // Skip to: 13525
/* 11206 */   MCD::OPC_CheckField, 3, 1, 0, 8, 9, 0, // Skip to: 13525
/* 11213 */   MCD::OPC_Decode, 202, 9, 228, 1, // Opcode: XOR32dd
/* 11218 */   MCD::OPC_FilterValue, 12, 110, 2, 0, // Skip to: 11845
/* 11223 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11226 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11243
/* 11231 */   MCD::OPC_CheckField, 3, 1, 0, 239, 8, 0, // Skip to: 13525
/* 11238 */   MCD::OPC_Decode, 163, 3, 187, 1, // Opcode: AND8dd
/* 11243 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 11260
/* 11248 */   MCD::OPC_CheckField, 3, 1, 0, 222, 8, 0, // Skip to: 13525
/* 11255 */   MCD::OPC_Decode, 166, 3, 188, 1, // Opcode: AND8dj
/* 11260 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 11277
/* 11265 */   MCD::OPC_CheckField, 3, 1, 1, 205, 8, 0, // Skip to: 13525
/* 11272 */   MCD::OPC_Decode, 168, 3, 189, 1, // Opcode: AND8dp
/* 11277 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 11354
/* 11282 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11285 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11302
/* 11290 */   MCD::OPC_CheckField, 24, 4, 8, 180, 8, 0, // Skip to: 13525
/* 11297 */   MCD::OPC_Decode, 164, 3, 190, 1, // Opcode: AND8df
/* 11302 */   MCD::OPC_FilterValue, 1, 170, 8, 0, // Skip to: 13525
/* 11307 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11310 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11320
/* 11315 */   MCD::OPC_Decode, 169, 3, 191, 1, // Opcode: AND8dq
/* 11320 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11337
/* 11325 */   MCD::OPC_CheckField, 24, 4, 8, 145, 8, 0, // Skip to: 13525
/* 11332 */   MCD::OPC_Decode, 167, 3, 192, 1, // Opcode: AND8dk
/* 11337 */   MCD::OPC_FilterValue, 4, 135, 8, 0, // Skip to: 13525
/* 11342 */   MCD::OPC_CheckField, 24, 8, 0, 128, 8, 0, // Skip to: 13525
/* 11349 */   MCD::OPC_Decode, 165, 3, 193, 1, // Opcode: AND8di
/* 11354 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 11376
/* 11359 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11371
/* 11366 */   MCD::OPC_Decode, 135, 3, 194, 1, // Opcode: AND16dd
/* 11371 */   MCD::OPC_Decode, 142, 3, 195, 1, // Opcode: AND16dr
/* 11376 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 11393
/* 11381 */   MCD::OPC_CheckField, 3, 1, 0, 89, 8, 0, // Skip to: 13525
/* 11388 */   MCD::OPC_Decode, 138, 3, 196, 1, // Opcode: AND16dj
/* 11393 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 11410
/* 11398 */   MCD::OPC_CheckField, 3, 1, 1, 72, 8, 0, // Skip to: 13525
/* 11405 */   MCD::OPC_Decode, 140, 3, 197, 1, // Opcode: AND16dp
/* 11410 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 11480
/* 11415 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11418 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11435
/* 11423 */   MCD::OPC_CheckField, 24, 4, 8, 47, 8, 0, // Skip to: 13525
/* 11430 */   MCD::OPC_Decode, 136, 3, 198, 1, // Opcode: AND16df
/* 11435 */   MCD::OPC_FilterValue, 1, 37, 8, 0, // Skip to: 13525
/* 11440 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11443 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11453
/* 11448 */   MCD::OPC_Decode, 141, 3, 199, 1, // Opcode: AND16dq
/* 11453 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11470
/* 11458 */   MCD::OPC_CheckField, 24, 4, 8, 12, 8, 0, // Skip to: 13525
/* 11465 */   MCD::OPC_Decode, 139, 3, 200, 1, // Opcode: AND16dk
/* 11470 */   MCD::OPC_FilterValue, 4, 2, 8, 0, // Skip to: 13525
/* 11475 */   MCD::OPC_Decode, 137, 3, 199, 1, // Opcode: AND16di
/* 11480 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 11502
/* 11485 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11497
/* 11492 */   MCD::OPC_Decode, 149, 3, 201, 1, // Opcode: AND32dd
/* 11497 */   MCD::OPC_Decode, 156, 3, 202, 1, // Opcode: AND32dr
/* 11502 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 11519
/* 11507 */   MCD::OPC_CheckField, 3, 1, 0, 219, 7, 0, // Skip to: 13525
/* 11514 */   MCD::OPC_Decode, 152, 3, 203, 1, // Opcode: AND32dj
/* 11519 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 11536
/* 11524 */   MCD::OPC_CheckField, 3, 1, 1, 202, 7, 0, // Skip to: 13525
/* 11531 */   MCD::OPC_Decode, 154, 3, 204, 1, // Opcode: AND32dp
/* 11536 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 11606
/* 11541 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11544 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11561
/* 11549 */   MCD::OPC_CheckField, 24, 4, 8, 177, 7, 0, // Skip to: 13525
/* 11556 */   MCD::OPC_Decode, 150, 3, 205, 1, // Opcode: AND32df
/* 11561 */   MCD::OPC_FilterValue, 1, 167, 7, 0, // Skip to: 13525
/* 11566 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11569 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11579
/* 11574 */   MCD::OPC_Decode, 155, 3, 206, 1, // Opcode: AND32dq
/* 11579 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11596
/* 11584 */   MCD::OPC_CheckField, 24, 4, 8, 142, 7, 0, // Skip to: 13525
/* 11591 */   MCD::OPC_Decode, 153, 3, 207, 1, // Opcode: AND32dk
/* 11596 */   MCD::OPC_FilterValue, 4, 132, 7, 0, // Skip to: 13525
/* 11601 */   MCD::OPC_Decode, 151, 3, 208, 1, // Opcode: AND32di
/* 11606 */   MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 11623
/* 11611 */   MCD::OPC_CheckField, 3, 1, 0, 115, 7, 0, // Skip to: 13525
/* 11618 */   MCD::OPC_Decode, 196, 9, 209, 1, // Opcode: UMULd32d16
/* 11623 */   MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 11640
/* 11628 */   MCD::OPC_CheckField, 0, 4, 12, 98, 7, 0, // Skip to: 13525
/* 11635 */   MCD::OPC_Decode, 198, 9, 206, 1, // Opcode: UMULd32i16
/* 11640 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 11656
/* 11645 */   MCD::OPC_CheckField, 3, 1, 0, 81, 7, 0, // Skip to: 13525
/* 11652 */   MCD::OPC_Decode, 172, 3, 40, // Opcode: AND8jd
/* 11656 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 11672
/* 11661 */   MCD::OPC_CheckField, 3, 1, 1, 65, 7, 0, // Skip to: 13525
/* 11668 */   MCD::OPC_Decode, 174, 3, 41, // Opcode: AND8pd
/* 11672 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 11695
/* 11677 */   MCD::OPC_CheckField, 24, 4, 8, 49, 7, 0, // Skip to: 13525
/* 11684 */   MCD::OPC_CheckField, 3, 1, 0, 42, 7, 0, // Skip to: 13525
/* 11691 */   MCD::OPC_Decode, 170, 3, 42, // Opcode: AND8fd
/* 11695 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 11712
/* 11700 */   MCD::OPC_CheckField, 3, 1, 0, 26, 7, 0, // Skip to: 13525
/* 11707 */   MCD::OPC_Decode, 145, 3, 210, 1, // Opcode: AND16jd
/* 11712 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 11729
/* 11717 */   MCD::OPC_CheckField, 3, 1, 1, 9, 7, 0, // Skip to: 13525
/* 11724 */   MCD::OPC_Decode, 147, 3, 211, 1, // Opcode: AND16pd
/* 11729 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 11753
/* 11734 */   MCD::OPC_CheckField, 24, 4, 8, 248, 6, 0, // Skip to: 13525
/* 11741 */   MCD::OPC_CheckField, 3, 1, 0, 241, 6, 0, // Skip to: 13525
/* 11748 */   MCD::OPC_Decode, 143, 3, 212, 1, // Opcode: AND16fd
/* 11753 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 11770
/* 11758 */   MCD::OPC_CheckField, 3, 1, 0, 224, 6, 0, // Skip to: 13525
/* 11765 */   MCD::OPC_Decode, 159, 3, 213, 1, // Opcode: AND32jd
/* 11770 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 11787
/* 11775 */   MCD::OPC_CheckField, 3, 1, 1, 207, 6, 0, // Skip to: 13525
/* 11782 */   MCD::OPC_Decode, 161, 3, 214, 1, // Opcode: AND32pd
/* 11787 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 11811
/* 11792 */   MCD::OPC_CheckField, 24, 4, 8, 190, 6, 0, // Skip to: 13525
/* 11799 */   MCD::OPC_CheckField, 3, 1, 0, 183, 6, 0, // Skip to: 13525
/* 11806 */   MCD::OPC_Decode, 157, 3, 215, 1, // Opcode: AND32fd
/* 11811 */   MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 11828
/* 11816 */   MCD::OPC_CheckField, 3, 1, 0, 166, 6, 0, // Skip to: 13525
/* 11823 */   MCD::OPC_Decode, 136, 9, 209, 1, // Opcode: SMULd32d16
/* 11828 */   MCD::OPC_FilterValue, 31, 156, 6, 0, // Skip to: 13525
/* 11833 */   MCD::OPC_CheckField, 0, 4, 12, 149, 6, 0, // Skip to: 13525
/* 11840 */   MCD::OPC_Decode, 138, 9, 206, 1, // Opcode: SMULd32i16
/* 11845 */   MCD::OPC_FilterValue, 13, 217, 2, 0, // Skip to: 12579
/* 11850 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11853 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11870
/* 11858 */   MCD::OPC_CheckField, 3, 1, 0, 124, 6, 0, // Skip to: 13525
/* 11865 */   MCD::OPC_Decode, 247, 2, 187, 1, // Opcode: ADD8dd
/* 11870 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 11887
/* 11875 */   MCD::OPC_CheckField, 3, 1, 0, 107, 6, 0, // Skip to: 13525
/* 11882 */   MCD::OPC_Decode, 250, 2, 188, 1, // Opcode: ADD8dj
/* 11887 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 11904
/* 11892 */   MCD::OPC_CheckField, 3, 1, 1, 90, 6, 0, // Skip to: 13525
/* 11899 */   MCD::OPC_Decode, 252, 2, 189, 1, // Opcode: ADD8dp
/* 11904 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 11981
/* 11909 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11912 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11929
/* 11917 */   MCD::OPC_CheckField, 24, 4, 8, 65, 6, 0, // Skip to: 13525
/* 11924 */   MCD::OPC_Decode, 248, 2, 190, 1, // Opcode: ADD8df
/* 11929 */   MCD::OPC_FilterValue, 1, 55, 6, 0, // Skip to: 13525
/* 11934 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11937 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11947
/* 11942 */   MCD::OPC_Decode, 253, 2, 191, 1, // Opcode: ADD8dq
/* 11947 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11964
/* 11952 */   MCD::OPC_CheckField, 24, 4, 8, 30, 6, 0, // Skip to: 13525
/* 11959 */   MCD::OPC_Decode, 251, 2, 192, 1, // Opcode: ADD8dk
/* 11964 */   MCD::OPC_FilterValue, 4, 20, 6, 0, // Skip to: 13525
/* 11969 */   MCD::OPC_CheckField, 24, 8, 0, 13, 6, 0, // Skip to: 13525
/* 11976 */   MCD::OPC_Decode, 249, 2, 193, 1, // Opcode: ADD8di
/* 11981 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 12003
/* 11986 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11998
/* 11993 */   MCD::OPC_Decode, 211, 2, 194, 1, // Opcode: ADD16dd
/* 11998 */   MCD::OPC_Decode, 218, 2, 195, 1, // Opcode: ADD16dr
/* 12003 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 12020
/* 12008 */   MCD::OPC_CheckField, 3, 1, 0, 230, 5, 0, // Skip to: 13525
/* 12015 */   MCD::OPC_Decode, 214, 2, 196, 1, // Opcode: ADD16dj
/* 12020 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 12037
/* 12025 */   MCD::OPC_CheckField, 3, 1, 1, 213, 5, 0, // Skip to: 13525
/* 12032 */   MCD::OPC_Decode, 216, 2, 197, 1, // Opcode: ADD16dp
/* 12037 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 12107
/* 12042 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12045 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12062
/* 12050 */   MCD::OPC_CheckField, 24, 4, 8, 188, 5, 0, // Skip to: 13525
/* 12057 */   MCD::OPC_Decode, 212, 2, 198, 1, // Opcode: ADD16df
/* 12062 */   MCD::OPC_FilterValue, 1, 178, 5, 0, // Skip to: 13525
/* 12067 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12070 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12080
/* 12075 */   MCD::OPC_Decode, 217, 2, 199, 1, // Opcode: ADD16dq
/* 12080 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12097
/* 12085 */   MCD::OPC_CheckField, 24, 4, 8, 153, 5, 0, // Skip to: 13525
/* 12092 */   MCD::OPC_Decode, 215, 2, 200, 1, // Opcode: ADD16dk
/* 12097 */   MCD::OPC_FilterValue, 4, 143, 5, 0, // Skip to: 13525
/* 12102 */   MCD::OPC_Decode, 213, 2, 199, 1, // Opcode: ADD16di
/* 12107 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 12129
/* 12112 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 12124
/* 12119 */   MCD::OPC_Decode, 233, 2, 201, 1, // Opcode: ADD32dd
/* 12124 */   MCD::OPC_Decode, 240, 2, 202, 1, // Opcode: ADD32dr
/* 12129 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 12146
/* 12134 */   MCD::OPC_CheckField, 3, 1, 0, 104, 5, 0, // Skip to: 13525
/* 12141 */   MCD::OPC_Decode, 236, 2, 203, 1, // Opcode: ADD32dj
/* 12146 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 12163
/* 12151 */   MCD::OPC_CheckField, 3, 1, 1, 87, 5, 0, // Skip to: 13525
/* 12158 */   MCD::OPC_Decode, 238, 2, 204, 1, // Opcode: ADD32dp
/* 12163 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 12233
/* 12168 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12171 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12188
/* 12176 */   MCD::OPC_CheckField, 24, 4, 8, 62, 5, 0, // Skip to: 13525
/* 12183 */   MCD::OPC_Decode, 234, 2, 205, 1, // Opcode: ADD32df
/* 12188 */   MCD::OPC_FilterValue, 1, 52, 5, 0, // Skip to: 13525
/* 12193 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12196 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12206
/* 12201 */   MCD::OPC_Decode, 239, 2, 206, 1, // Opcode: ADD32dq
/* 12206 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12223
/* 12211 */   MCD::OPC_CheckField, 24, 4, 8, 27, 5, 0, // Skip to: 13525
/* 12218 */   MCD::OPC_Decode, 237, 2, 207, 1, // Opcode: ADD32dk
/* 12223 */   MCD::OPC_FilterValue, 4, 17, 5, 0, // Skip to: 13525
/* 12228 */   MCD::OPC_Decode, 235, 2, 208, 1, // Opcode: ADD32di
/* 12233 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 12250
/* 12238 */   MCD::OPC_CheckField, 3, 1, 0, 0, 5, 0, // Skip to: 13525
/* 12245 */   MCD::OPC_Decode, 134, 3, 187, 1, // Opcode: ADDX8dd
/* 12250 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 12266
/* 12255 */   MCD::OPC_CheckField, 3, 1, 0, 239, 4, 0, // Skip to: 13525
/* 12262 */   MCD::OPC_Decode, 128, 3, 40, // Opcode: ADD8jd
/* 12266 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 12282
/* 12271 */   MCD::OPC_CheckField, 3, 1, 1, 223, 4, 0, // Skip to: 13525
/* 12278 */   MCD::OPC_Decode, 130, 3, 41, // Opcode: ADD8pd
/* 12282 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 12305
/* 12287 */   MCD::OPC_CheckField, 24, 4, 8, 207, 4, 0, // Skip to: 13525
/* 12294 */   MCD::OPC_CheckField, 3, 1, 0, 200, 4, 0, // Skip to: 13525
/* 12301 */   MCD::OPC_Decode, 254, 2, 42, // Opcode: ADD8fd
/* 12305 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 12322
/* 12310 */   MCD::OPC_CheckField, 3, 1, 0, 184, 4, 0, // Skip to: 13525
/* 12317 */   MCD::OPC_Decode, 132, 3, 194, 1, // Opcode: ADDX16dd
/* 12322 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 12339
/* 12327 */   MCD::OPC_CheckField, 3, 1, 0, 167, 4, 0, // Skip to: 13525
/* 12334 */   MCD::OPC_Decode, 221, 2, 210, 1, // Opcode: ADD16jd
/* 12339 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 12356
/* 12344 */   MCD::OPC_CheckField, 3, 1, 1, 150, 4, 0, // Skip to: 13525
/* 12351 */   MCD::OPC_Decode, 223, 2, 211, 1, // Opcode: ADD16pd
/* 12356 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 12380
/* 12361 */   MCD::OPC_CheckField, 24, 4, 8, 133, 4, 0, // Skip to: 13525
/* 12368 */   MCD::OPC_CheckField, 3, 1, 0, 126, 4, 0, // Skip to: 13525
/* 12375 */   MCD::OPC_Decode, 219, 2, 212, 1, // Opcode: ADD16fd
/* 12380 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 12397
/* 12385 */   MCD::OPC_CheckField, 3, 1, 0, 109, 4, 0, // Skip to: 13525
/* 12392 */   MCD::OPC_Decode, 133, 3, 201, 1, // Opcode: ADDX32dd
/* 12397 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 12414
/* 12402 */   MCD::OPC_CheckField, 3, 1, 0, 92, 4, 0, // Skip to: 13525
/* 12409 */   MCD::OPC_Decode, 243, 2, 213, 1, // Opcode: ADD32jd
/* 12414 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 12431
/* 12419 */   MCD::OPC_CheckField, 3, 1, 1, 75, 4, 0, // Skip to: 13525
/* 12426 */   MCD::OPC_Decode, 245, 2, 214, 1, // Opcode: ADD32pd
/* 12431 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 12455
/* 12436 */   MCD::OPC_CheckField, 24, 4, 8, 58, 4, 0, // Skip to: 13525
/* 12443 */   MCD::OPC_CheckField, 3, 1, 0, 51, 4, 0, // Skip to: 13525
/* 12450 */   MCD::OPC_Decode, 241, 2, 215, 1, // Opcode: ADD32fd
/* 12455 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 12465
/* 12460 */   MCD::OPC_Decode, 232, 2, 216, 1, // Opcode: ADD32ar
/* 12465 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 12482
/* 12470 */   MCD::OPC_CheckField, 3, 1, 0, 24, 4, 0, // Skip to: 13525
/* 12477 */   MCD::OPC_Decode, 228, 2, 217, 1, // Opcode: ADD32aj
/* 12482 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 12499
/* 12487 */   MCD::OPC_CheckField, 3, 1, 1, 7, 4, 0, // Skip to: 13525
/* 12494 */   MCD::OPC_Decode, 230, 2, 218, 1, // Opcode: ADD32ap
/* 12499 */   MCD::OPC_FilterValue, 31, 253, 3, 0, // Skip to: 13525
/* 12504 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12507 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12524
/* 12512 */   MCD::OPC_CheckField, 24, 4, 8, 238, 3, 0, // Skip to: 13525
/* 12519 */   MCD::OPC_Decode, 226, 2, 219, 1, // Opcode: ADD32af
/* 12524 */   MCD::OPC_FilterValue, 1, 228, 3, 0, // Skip to: 13525
/* 12529 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12532 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 12542
/* 12537 */   MCD::OPC_Decode, 225, 2, 220, 1, // Opcode: ADD32ab
/* 12542 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12552
/* 12547 */   MCD::OPC_Decode, 231, 2, 221, 1, // Opcode: ADD32aq
/* 12552 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12569
/* 12557 */   MCD::OPC_CheckField, 24, 4, 8, 193, 3, 0, // Skip to: 13525
/* 12564 */   MCD::OPC_Decode, 229, 2, 222, 1, // Opcode: ADD32ak
/* 12569 */   MCD::OPC_FilterValue, 4, 183, 3, 0, // Skip to: 13525
/* 12574 */   MCD::OPC_Decode, 227, 2, 220, 1, // Opcode: ADD32ai
/* 12579 */   MCD::OPC_FilterValue, 14, 47, 1, 0, // Skip to: 12887
/* 12584 */   MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 12587 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 12597
/* 12592 */   MCD::OPC_Decode, 181, 3, 229, 1, // Opcode: ASR8di
/* 12597 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 12607
/* 12602 */   MCD::OPC_Decode, 229, 4, 229, 1, // Opcode: LSR8di
/* 12607 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 12617
/* 12612 */   MCD::OPC_Decode, 205, 8, 229, 1, // Opcode: ROR8di
/* 12617 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 12627
/* 12622 */   MCD::OPC_Decode, 180, 3, 226, 1, // Opcode: ASR8dd
/* 12627 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 12637
/* 12632 */   MCD::OPC_Decode, 228, 4, 226, 1, // Opcode: LSR8dd
/* 12637 */   MCD::OPC_FilterValue, 7, 5, 0, 0, // Skip to: 12647
/* 12642 */   MCD::OPC_Decode, 204, 8, 226, 1, // Opcode: ROR8dd
/* 12647 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 12657
/* 12652 */   MCD::OPC_Decode, 177, 3, 230, 1, // Opcode: ASR16di
/* 12657 */   MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 12667
/* 12662 */   MCD::OPC_Decode, 225, 4, 230, 1, // Opcode: LSR16di
/* 12667 */   MCD::OPC_FilterValue, 11, 5, 0, 0, // Skip to: 12677
/* 12672 */   MCD::OPC_Decode, 201, 8, 230, 1, // Opcode: ROR16di
/* 12677 */   MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 12687
/* 12682 */   MCD::OPC_Decode, 176, 3, 227, 1, // Opcode: ASR16dd
/* 12687 */   MCD::OPC_FilterValue, 13, 5, 0, 0, // Skip to: 12697
/* 12692 */   MCD::OPC_Decode, 224, 4, 227, 1, // Opcode: LSR16dd
/* 12697 */   MCD::OPC_FilterValue, 15, 5, 0, 0, // Skip to: 12707
/* 12702 */   MCD::OPC_Decode, 200, 8, 227, 1, // Opcode: ROR16dd
/* 12707 */   MCD::OPC_FilterValue, 16, 5, 0, 0, // Skip to: 12717
/* 12712 */   MCD::OPC_Decode, 179, 3, 231, 1, // Opcode: ASR32di
/* 12717 */   MCD::OPC_FilterValue, 17, 5, 0, 0, // Skip to: 12727
/* 12722 */   MCD::OPC_Decode, 227, 4, 231, 1, // Opcode: LSR32di
/* 12727 */   MCD::OPC_FilterValue, 19, 5, 0, 0, // Skip to: 12737
/* 12732 */   MCD::OPC_Decode, 203, 8, 231, 1, // Opcode: ROR32di
/* 12737 */   MCD::OPC_FilterValue, 20, 5, 0, 0, // Skip to: 12747
/* 12742 */   MCD::OPC_Decode, 178, 3, 228, 1, // Opcode: ASR32dd
/* 12747 */   MCD::OPC_FilterValue, 21, 5, 0, 0, // Skip to: 12757
/* 12752 */   MCD::OPC_Decode, 226, 4, 228, 1, // Opcode: LSR32dd
/* 12757 */   MCD::OPC_FilterValue, 23, 5, 0, 0, // Skip to: 12767
/* 12762 */   MCD::OPC_Decode, 202, 8, 228, 1, // Opcode: ROR32dd
/* 12767 */   MCD::OPC_FilterValue, 33, 5, 0, 0, // Skip to: 12777
/* 12772 */   MCD::OPC_Decode, 135, 9, 229, 1, // Opcode: SHL8di
/* 12777 */   MCD::OPC_FilterValue, 35, 5, 0, 0, // Skip to: 12787
/* 12782 */   MCD::OPC_Decode, 199, 8, 229, 1, // Opcode: ROL8di
/* 12787 */   MCD::OPC_FilterValue, 37, 5, 0, 0, // Skip to: 12797
/* 12792 */   MCD::OPC_Decode, 134, 9, 226, 1, // Opcode: SHL8dd
/* 12797 */   MCD::OPC_FilterValue, 39, 5, 0, 0, // Skip to: 12807
/* 12802 */   MCD::OPC_Decode, 198, 8, 226, 1, // Opcode: ROL8dd
/* 12807 */   MCD::OPC_FilterValue, 41, 5, 0, 0, // Skip to: 12817
/* 12812 */   MCD::OPC_Decode, 131, 9, 230, 1, // Opcode: SHL16di
/* 12817 */   MCD::OPC_FilterValue, 43, 5, 0, 0, // Skip to: 12827
/* 12822 */   MCD::OPC_Decode, 195, 8, 230, 1, // Opcode: ROL16di
/* 12827 */   MCD::OPC_FilterValue, 45, 5, 0, 0, // Skip to: 12837
/* 12832 */   MCD::OPC_Decode, 130, 9, 227, 1, // Opcode: SHL16dd
/* 12837 */   MCD::OPC_FilterValue, 47, 5, 0, 0, // Skip to: 12847
/* 12842 */   MCD::OPC_Decode, 194, 8, 227, 1, // Opcode: ROL16dd
/* 12847 */   MCD::OPC_FilterValue, 49, 5, 0, 0, // Skip to: 12857
/* 12852 */   MCD::OPC_Decode, 133, 9, 231, 1, // Opcode: SHL32di
/* 12857 */   MCD::OPC_FilterValue, 51, 5, 0, 0, // Skip to: 12867
/* 12862 */   MCD::OPC_Decode, 197, 8, 231, 1, // Opcode: ROL32di
/* 12867 */   MCD::OPC_FilterValue, 53, 5, 0, 0, // Skip to: 12877
/* 12872 */   MCD::OPC_Decode, 132, 9, 228, 1, // Opcode: SHL32dd
/* 12877 */   MCD::OPC_FilterValue, 55, 131, 2, 0, // Skip to: 13525
/* 12882 */   MCD::OPC_Decode, 196, 8, 228, 1, // Opcode: ROL32dd
/* 12887 */   MCD::OPC_FilterValue, 15, 121, 2, 0, // Skip to: 13525
/* 12892 */   MCD::OPC_ExtractField, 16, 7,  // Inst{22-16} ...
/* 12895 */   MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 12925
/* 12900 */   MCD::OPC_CheckPredicate, 2, 108, 2, 0, // Skip to: 13525
/* 12905 */   MCD::OPC_CheckField, 29, 3, 0, 101, 2, 0, // Skip to: 13525
/* 12912 */   MCD::OPC_CheckField, 0, 12, 128, 4, 93, 2, 0, // Skip to: 13525
/* 12920 */   MCD::OPC_Decode, 184, 4, 232, 1, // Opcode: FMOV80fp_fp
/* 12925 */   MCD::OPC_FilterValue, 24, 25, 0, 0, // Skip to: 12955
/* 12930 */   MCD::OPC_CheckPredicate, 2, 78, 2, 0, // Skip to: 13525
/* 12935 */   MCD::OPC_CheckField, 29, 3, 0, 71, 2, 0, // Skip to: 13525
/* 12942 */   MCD::OPC_CheckField, 0, 12, 128, 4, 63, 2, 0, // Skip to: 13525
/* 12950 */   MCD::OPC_Decode, 154, 4, 232, 1, // Opcode: FABS80fp_fp
/* 12955 */   MCD::OPC_FilterValue, 26, 25, 0, 0, // Skip to: 12985
/* 12960 */   MCD::OPC_CheckPredicate, 2, 48, 2, 0, // Skip to: 13525
/* 12965 */   MCD::OPC_CheckField, 29, 3, 0, 41, 2, 0, // Skip to: 13525
/* 12972 */   MCD::OPC_CheckField, 0, 12, 128, 4, 33, 2, 0, // Skip to: 13525
/* 12980 */   MCD::OPC_Decode, 190, 4, 232, 1, // Opcode: FNEG80fp_fp
/* 12985 */   MCD::OPC_FilterValue, 32, 25, 0, 0, // Skip to: 13015
/* 12990 */   MCD::OPC_CheckPredicate, 2, 18, 2, 0, // Skip to: 13525
/* 12995 */   MCD::OPC_CheckField, 29, 3, 0, 11, 2, 0, // Skip to: 13525
/* 13002 */   MCD::OPC_CheckField, 0, 12, 128, 4, 3, 2, 0, // Skip to: 13525
/* 13010 */   MCD::OPC_Decode, 169, 4, 233, 1, // Opcode: FDIV80fp_fp
/* 13015 */   MCD::OPC_FilterValue, 34, 25, 0, 0, // Skip to: 13045
/* 13020 */   MCD::OPC_CheckPredicate, 2, 244, 1, 0, // Skip to: 13525
/* 13025 */   MCD::OPC_CheckField, 29, 3, 0, 237, 1, 0, // Skip to: 13525
/* 13032 */   MCD::OPC_CheckField, 0, 12, 128, 4, 229, 1, 0, // Skip to: 13525
/* 13040 */   MCD::OPC_Decode, 157, 4, 233, 1, // Opcode: FADD80fp_fp
/* 13045 */   MCD::OPC_FilterValue, 35, 25, 0, 0, // Skip to: 13075
/* 13050 */   MCD::OPC_CheckPredicate, 2, 214, 1, 0, // Skip to: 13525
/* 13055 */   MCD::OPC_CheckField, 29, 3, 0, 207, 1, 0, // Skip to: 13525
/* 13062 */   MCD::OPC_CheckField, 0, 12, 128, 4, 199, 1, 0, // Skip to: 13525
/* 13070 */   MCD::OPC_Decode, 187, 4, 233, 1, // Opcode: FMUL80fp_fp
/* 13075 */   MCD::OPC_FilterValue, 40, 25, 0, 0, // Skip to: 13105
/* 13080 */   MCD::OPC_CheckPredicate, 2, 184, 1, 0, // Skip to: 13525
/* 13085 */   MCD::OPC_CheckField, 29, 3, 0, 177, 1, 0, // Skip to: 13525
/* 13092 */   MCD::OPC_CheckField, 0, 12, 128, 4, 169, 1, 0, // Skip to: 13525
/* 13100 */   MCD::OPC_Decode, 214, 4, 233, 1, // Opcode: FSUB80fp_fp
/* 13105 */   MCD::OPC_FilterValue, 64, 25, 0, 0, // Skip to: 13135
/* 13110 */   MCD::OPC_CheckPredicate, 3, 154, 1, 0, // Skip to: 13525
/* 13115 */   MCD::OPC_CheckField, 29, 3, 0, 147, 1, 0, // Skip to: 13525
/* 13122 */   MCD::OPC_CheckField, 0, 12, 128, 4, 139, 1, 0, // Skip to: 13525
/* 13130 */   MCD::OPC_Decode, 202, 4, 232, 1, // Opcode: FSMOV80fp_fp
/* 13135 */   MCD::OPC_FilterValue, 68, 25, 0, 0, // Skip to: 13165
/* 13140 */   MCD::OPC_CheckPredicate, 3, 124, 1, 0, // Skip to: 13525
/* 13145 */   MCD::OPC_CheckField, 29, 3, 0, 117, 1, 0, // Skip to: 13525
/* 13152 */   MCD::OPC_CheckField, 0, 12, 128, 4, 109, 1, 0, // Skip to: 13525
/* 13160 */   MCD::OPC_Decode, 172, 4, 232, 1, // Opcode: FDMOV80fp_fp
/* 13165 */   MCD::OPC_FilterValue, 88, 25, 0, 0, // Skip to: 13195
/* 13170 */   MCD::OPC_CheckPredicate, 3, 94, 1, 0, // Skip to: 13525
/* 13175 */   MCD::OPC_CheckField, 29, 3, 0, 87, 1, 0, // Skip to: 13525
/* 13182 */   MCD::OPC_CheckField, 0, 12, 128, 4, 79, 1, 0, // Skip to: 13525
/* 13190 */   MCD::OPC_Decode, 193, 4, 232, 1, // Opcode: FSABS80fp_fp
/* 13195 */   MCD::OPC_FilterValue, 90, 25, 0, 0, // Skip to: 13225
/* 13200 */   MCD::OPC_CheckPredicate, 3, 64, 1, 0, // Skip to: 13525
/* 13205 */   MCD::OPC_CheckField, 29, 3, 0, 57, 1, 0, // Skip to: 13525
/* 13212 */   MCD::OPC_CheckField, 0, 12, 128, 4, 49, 1, 0, // Skip to: 13525
/* 13220 */   MCD::OPC_Decode, 208, 4, 232, 1, // Opcode: FSNEG80fp_fp
/* 13225 */   MCD::OPC_FilterValue, 92, 25, 0, 0, // Skip to: 13255
/* 13230 */   MCD::OPC_CheckPredicate, 3, 34, 1, 0, // Skip to: 13525
/* 13235 */   MCD::OPC_CheckField, 29, 3, 0, 27, 1, 0, // Skip to: 13525
/* 13242 */   MCD::OPC_CheckField, 0, 12, 128, 4, 19, 1, 0, // Skip to: 13525
/* 13250 */   MCD::OPC_Decode, 160, 4, 232, 1, // Opcode: FDABS80fp_fp
/* 13255 */   MCD::OPC_FilterValue, 94, 25, 0, 0, // Skip to: 13285
/* 13260 */   MCD::OPC_CheckPredicate, 3, 4, 1, 0, // Skip to: 13525
/* 13265 */   MCD::OPC_CheckField, 29, 3, 0, 253, 0, 0, // Skip to: 13525
/* 13272 */   MCD::OPC_CheckField, 0, 12, 128, 4, 245, 0, 0, // Skip to: 13525
/* 13280 */   MCD::OPC_Decode, 178, 4, 232, 1, // Opcode: FDNEG80fp_fp
/* 13285 */   MCD::OPC_FilterValue, 96, 25, 0, 0, // Skip to: 13315
/* 13290 */   MCD::OPC_CheckPredicate, 3, 230, 0, 0, // Skip to: 13525
/* 13295 */   MCD::OPC_CheckField, 29, 3, 0, 223, 0, 0, // Skip to: 13525
/* 13302 */   MCD::OPC_CheckField, 0, 12, 128, 4, 215, 0, 0, // Skip to: 13525
/* 13310 */   MCD::OPC_Decode, 199, 4, 233, 1, // Opcode: FSDIV80fp_fp
/* 13315 */   MCD::OPC_FilterValue, 98, 25, 0, 0, // Skip to: 13345
/* 13320 */   MCD::OPC_CheckPredicate, 3, 200, 0, 0, // Skip to: 13525
/* 13325 */   MCD::OPC_CheckField, 29, 3, 0, 193, 0, 0, // Skip to: 13525
/* 13332 */   MCD::OPC_CheckField, 0, 12, 128, 4, 185, 0, 0, // Skip to: 13525
/* 13340 */   MCD::OPC_Decode, 196, 4, 233, 1, // Opcode: FSADD80fp_fp
/* 13345 */   MCD::OPC_FilterValue, 99, 25, 0, 0, // Skip to: 13375
/* 13350 */   MCD::OPC_CheckPredicate, 3, 170, 0, 0, // Skip to: 13525
/* 13355 */   MCD::OPC_CheckField, 29, 3, 0, 163, 0, 0, // Skip to: 13525
/* 13362 */   MCD::OPC_CheckField, 0, 12, 128, 4, 155, 0, 0, // Skip to: 13525
/* 13370 */   MCD::OPC_Decode, 205, 4, 233, 1, // Opcode: FSMUL80fp_fp
/* 13375 */   MCD::OPC_FilterValue, 100, 25, 0, 0, // Skip to: 13405
/* 13380 */   MCD::OPC_CheckPredicate, 3, 140, 0, 0, // Skip to: 13525
/* 13385 */   MCD::OPC_CheckField, 29, 3, 0, 133, 0, 0, // Skip to: 13525
/* 13392 */   MCD::OPC_CheckField, 0, 12, 128, 4, 125, 0, 0, // Skip to: 13525
/* 13400 */   MCD::OPC_Decode, 166, 4, 233, 1, // Opcode: FDDIV80fp_fp
/* 13405 */   MCD::OPC_FilterValue, 102, 25, 0, 0, // Skip to: 13435
/* 13410 */   MCD::OPC_CheckPredicate, 3, 110, 0, 0, // Skip to: 13525
/* 13415 */   MCD::OPC_CheckField, 29, 3, 0, 103, 0, 0, // Skip to: 13525
/* 13422 */   MCD::OPC_CheckField, 0, 12, 128, 4, 95, 0, 0, // Skip to: 13525
/* 13430 */   MCD::OPC_Decode, 163, 4, 233, 1, // Opcode: FDADD80fp_fp
/* 13435 */   MCD::OPC_FilterValue, 103, 25, 0, 0, // Skip to: 13465
/* 13440 */   MCD::OPC_CheckPredicate, 3, 80, 0, 0, // Skip to: 13525
/* 13445 */   MCD::OPC_CheckField, 29, 3, 0, 73, 0, 0, // Skip to: 13525
/* 13452 */   MCD::OPC_CheckField, 0, 12, 128, 4, 65, 0, 0, // Skip to: 13525
/* 13460 */   MCD::OPC_Decode, 175, 4, 233, 1, // Opcode: FDMUL80fp_fp
/* 13465 */   MCD::OPC_FilterValue, 104, 25, 0, 0, // Skip to: 13495
/* 13470 */   MCD::OPC_CheckPredicate, 3, 50, 0, 0, // Skip to: 13525
/* 13475 */   MCD::OPC_CheckField, 29, 3, 0, 43, 0, 0, // Skip to: 13525
/* 13482 */   MCD::OPC_CheckField, 0, 12, 128, 4, 35, 0, 0, // Skip to: 13525
/* 13490 */   MCD::OPC_Decode, 211, 4, 233, 1, // Opcode: FSSUB80fp_fp
/* 13495 */   MCD::OPC_FilterValue, 108, 25, 0, 0, // Skip to: 13525
/* 13500 */   MCD::OPC_CheckPredicate, 3, 20, 0, 0, // Skip to: 13525
/* 13505 */   MCD::OPC_CheckField, 29, 3, 0, 13, 0, 0, // Skip to: 13525
/* 13512 */   MCD::OPC_CheckField, 0, 12, 128, 4, 5, 0, 0, // Skip to: 13525
/* 13520 */   MCD::OPC_Decode, 181, 4, 233, 1, // Opcode: FDSUB80fp_fp
/* 13525 */   MCD::OPC_Fail,
  0
};

static const uint8_t InstrLenTable[] = {
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
32,
16,
32,
48,
16,
16,
32,
16,
32,
32,
48,
16,
32,
32,
48,
16,
32,
32,
48,
32,
48,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
48,
16,
32,
32,
32,
32,
32,
64,
32,
32,
16,
32,
32,
32,
16,
48,
32,
48,
48,
48,
80,
32,
48,
16,
32,
32,
32,
16,
64,
48,
64,
64,
64,
64,
16,
32,
32,
16,
32,
32,
32,
48,
32,
48,
48,
48,
16,
16,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
0,
0,
32,
16,
16,
48,
32,
32,
32,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
48,
16,
16,
32,
16,
32,
16,
32,
32,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
64,
80,
48,
64,
48,
64,
64,
48,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
80,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
16,
16,
32,
16,
48,
16,
32,
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[M68k::FeatureISA20]);
  case 1:
    return (Bits[M68k::FeatureISA10]);
  case 2:
    return (Bits[M68k::FeatureISA881]);
  case 3:
    return (Bits[M68k::FeatureISA40]);
  }
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 48, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 98:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 100:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 113:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 115:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 119:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 122:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 123:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 124:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 126:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 127:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 128:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 130:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 131:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 132:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 133:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 134:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 135:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 136:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 137:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 138:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 139:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 140:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 141:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 142:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 143:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 144:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 145:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 146:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 147:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 148:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 149:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 150:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 151:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 152:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 153:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 154:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 155:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 156:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 157:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 158:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 159:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 160:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 161:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 162:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 163:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 164:
    tmp = fieldFromInstruction(insn, 28, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 165:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 166:
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 167:
    tmp = fieldFromInstruction(insn, 0, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 168:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 169:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 170:
    return S;
  case 171:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 172:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 173:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 174:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 175:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 176:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 177:
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 178:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 179:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 180:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 181:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 182:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 183:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 184:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 185:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 186:
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 187:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 188:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 189:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 190:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 191:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 192:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 193:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 194:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 195:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 196:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 197:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 198:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 199:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 200:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 201:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 202:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 203:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 204:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 205:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 206:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 207:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 208:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 209:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 210:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 211:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 212:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 213:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 214:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 215:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 216:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 217:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 218:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 219:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 220:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 221:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 222:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 223:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 224:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 225:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 226:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 227:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 228:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 229:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 230:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 231:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 232:
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 233:
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 23, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 26, 3);
    if (!Check(S, DecodeFPDR80RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI,
                                      llvm::function_ref<void(APInt &, uint64_t)> makeUp) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      makeUp(insn, Start + Len);
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      uint64_t Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      makeUp(insn, Start + Len);
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      Len = InstrLenTable[Opc];
      makeUp(insn, Len);
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      uint64_t PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      uint64_t NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // end namespace llvm
